package fr.cnrs.aniseed;

import java.util.*;

/**
 * @author Olivier Tassy
 * 
 * @version 1.0, Created on 16 juillet 2003, 19:16
 */

public class Biometry extends javax.swing.JPanel {
    
    private GTableModel t1;
    private Hashtable objs;
    
////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor
    public Biometry(Hashtable objs) {
        initComponents();
        
        this.objs=objs;

        t1=new GTableModel();
        t1.addColumn("Cell");
        t1.addColumn("Surface(µ2)");
        t1.addColumn("Volume(µ3)");
        t1.addMouseListenerToHeaderInTable(TableVolume);
        
        
        TableVolume.setModel(t1);
        TableVolume.getTableHeader().setReorderingAllowed(false);
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
////////////////////////////////////////////////////////////////////////////////////////////////////    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.JPanel jPanel2 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel1 = new javax.swing.JPanel();
        javax.swing.JButton jButton1 = new javax.swing.JButton();
        javax.swing.JLabel jLabel1 = new javax.swing.JLabel();
        javax.swing.JScrollPane jScrollPane1 = new javax.swing.JScrollPane();
        TableVolume = new javax.swing.JTable();
        javax.swing.JPanel jPanel3 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel4 = new javax.swing.JPanel();
        javax.swing.JButton jButton2 = new javax.swing.JButton();
        javax.swing.JLabel jLabel2 = new javax.swing.JLabel();
        javax.swing.JLabel jLabel3 = new javax.swing.JLabel();
        totalvol = new javax.swing.JLabel();
        totalsurf = new javax.swing.JLabel();

        setFont(new java.awt.Font("Arial", 0, 12));
        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jButton1.setBackground(new java.awt.Color(153, 0, 0));
        jButton1.setFont(new java.awt.Font("Arial", 1, 12));
        jButton1.setForeground(new java.awt.Color(255, 255, 255));
        jButton1.setText("Compute selected cells");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 30, 190, 20));

        jLabel1.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel1.setText("<html><center>Surface & volume</center></html>");
        jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(40, 10, 110, 20));

        jPanel2.add(jPanel1);

        add(jPanel2, java.awt.BorderLayout.NORTH);

        jScrollPane1.setFont(new java.awt.Font("Arial", 0, 12));
        jScrollPane1.setMinimumSize(null);

        TableVolume.setFont(new java.awt.Font("Arial", 0, 12));
        TableVolume.setMinimumSize(null);
        TableVolume.setPreferredScrollableViewportSize(null);
        TableVolume.setPreferredSize(null);
        jScrollPane1.setViewportView(TableVolume);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel4.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jButton2.setBackground(new java.awt.Color(153, 0, 0));
        jButton2.setFont(new java.awt.Font("Arial", 1, 12));
        jButton2.setForeground(new java.awt.Color(255, 255, 255));
        jButton2.setText("Export");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel4.add(jButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 40, 150, 20));

        jLabel2.setText("Total volume: ");
        jPanel4.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 20, 100, 20));

        jLabel3.setText("Total surface: ");
        jPanel4.add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 100, 20));
        jPanel4.add(totalvol, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 20, 60, 20));
        jPanel4.add(totalsurf, new org.netbeans.lib.awtextra.AbsoluteConstraints(101, 0, 60, 20));

        jPanel3.add(jPanel4);

        add(jPanel3, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        if(t1.getRowCount()<=0)
            return;
        
        javax.swing.JFileChooser chooser = new javax.swing.JFileChooser("Biometry report");
        int returnVal = chooser.showSaveDialog(this);
        if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
            java.io.File fileselected = chooser.getSelectedFile();
            if ( fileselected != null ){
                
                
                try {
                    java.io.BufferedWriter out = new java.io.BufferedWriter(new java.io.FileWriter(fileselected));
                    
                    out.write("#cell / surface µ2/ volume µ3\n");
                    out.write("#devstage="+VirtualEmbryo.devstage+"\n");
                    
                    
                    for(int a=0; a<t1.getRowCount();++a){
                        out.write( t1.getValueAt(a, 0)+"\t"+t1.getValueAt(a, 1)+"\t"+t1.getValueAt(a, 2)+"\n" );
                    }
                    
                    out.close();
                } catch (Exception e) {;}
                
            }
        }
        
    }//GEN-LAST:event_jButton2ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        
        while(t1.getRowCount()>0)
            t1.removeRow(0);
        
        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        
        double totvol=0;
        double totsurf=0;
        
        while (ite.hasNext()){
            Object obj3d = ite.next();
            cell node = (cell) objs.get(obj3d);
            
            if(node.isSelected()){
                double surf = node.getSurface();
                double vol = node.getVolume();
                t1.addRow(new Object[]{node.getName(), new java.lang.Integer((int)surf), new java.lang.Integer((int)vol) });
                
                totvol  += vol;
                totsurf += surf;
            }
        }
        
        totalsurf.setText(new java.lang.Integer((int)totsurf)+"");
        totalvol.setText(new java.lang.Integer((int)totvol)+"");
    }//GEN-LAST:event_jButton1ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void destroy(){
        try{
            Set keys = objs.keySet();
            Iterator ite = keys.iterator();
            while (ite.hasNext()){
                Object obj3d = ite.next();
                objs.remove(obj3d);
            }
        this.removeAll();
        }catch(Exception e){;}
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable TableVolume;
    private javax.swing.JLabel totalsurf;
    private javax.swing.JLabel totalvol;
    // End of variables declaration//GEN-END:variables
    
}
