package fr.cnrs.aniseed;

import javax.swing.*;
import java.util.*;
import javax.media.j3d.*;
import javax.vecmath.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, Created on 17 juillet 2003, 11:59
 */

public class BiometryNeighbor extends javax.swing.JPanel {
    
    Hashtable objs;
    private GTableModel t1;
    BranchGroup bgsurf;
    
    BranchGroup bgsurf2; //For the points
    BranchGroup bgsurf3; //For the points
    
////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor    
    public BiometryNeighbor(Hashtable objs) {
        this.objs=objs;
        initComponents();
        
        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while ( ite.hasNext() ){
            Object obj = ite.next();
            combo.addItem( obj.toString() );
            
        }
        selectionSort(combo);
        t1=new GTableModel();
        t1.addColumn("Cell");
        t1.addColumn("Distance(µ)");
        t1.addColumn("Closest distance(µ)");
        t1.addMouseListenerToHeaderInTable(Table);
        
        Table.setModel(t1);
        Table.getTableHeader().setReorderingAllowed(false);
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
////////////////////////////////////////////////////////////////////////////////////////////////////    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.JPanel jPanel3 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel1 = new javax.swing.JPanel();
        javax.swing.JLabel jLabel2 = new javax.swing.JLabel();
        javax.swing.JButton jButton1 = new javax.swing.JButton();
        combo = new javax.swing.JComboBox();
        javax.swing.JButton jButtonNeighbor = new javax.swing.JButton();
        neighborLimit = new javax.swing.JTextField();
        javax.swing.JLabel jLabel31 = new javax.swing.JLabel();
        javax.swing.JLabel jLabel11 = new javax.swing.JLabel();
        estimate = new javax.swing.JRadioButton();
        javax.swing.JScrollPane jScrollPane2 = new javax.swing.JScrollPane();
        Table = new javax.swing.JTable();
        javax.swing.JPanel jPanel4 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel2 = new javax.swing.JPanel();
        javax.swing.JButton jButton2 = new javax.swing.JButton();
        ButtonColor = new javax.swing.JButton();
        infoLabel = new javax.swing.JLabel();
        javax.swing.JButton jButton4 = new javax.swing.JButton();
        javax.swing.JButton jButton5 = new javax.swing.JButton();
        javax.swing.JButton jButtonContact = new javax.swing.JButton();
        javax.swing.JButton jButtonPlus = new javax.swing.JButton();
        javax.swing.JButton jButtonMinus = new javax.swing.JButton();
        contactLimit = new javax.swing.JTextField();
        javax.swing.JLabel jLabel1 = new javax.swing.JLabel();
        jTextField1 = new javax.swing.JTextField();
        javax.swing.JButton jButton3 = new javax.swing.JButton();
        javax.swing.JLabel jLabel3 = new javax.swing.JLabel();
        javax.swing.JLabel jLabel311 = new javax.swing.JLabel();
        javax.swing.JButton jButton6 = new javax.swing.JButton();
        delaunay = new javax.swing.JRadioButton();

        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel2.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel2.setText("Neighbours");
        jPanel1.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(68, 0, 90, -1));

        jButton1.setBackground(new java.awt.Color(153, 0, 0));
        jButton1.setFont(new java.awt.Font("Arial", 1, 10));
        jButton1.setForeground(new java.awt.Color(255, 255, 255));
        jButton1.setText("Get selected");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 20, 100, 20));

        combo.setBackground(new java.awt.Color(255, 255, 255));
        combo.setFont(new java.awt.Font("Arial", 1, 12));
        jPanel1.add(combo, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 20, 90, 20));

        jButtonNeighbor.setBackground(new java.awt.Color(153, 0, 0));
        jButtonNeighbor.setFont(new java.awt.Font("Arial", 1, 10));
        jButtonNeighbor.setForeground(new java.awt.Color(255, 255, 255));
        jButtonNeighbor.setText("Get neighbouring cells");
        jButtonNeighbor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonNeighborActionPerformed(evt);
            }
        });
        jPanel1.add(jButtonNeighbor, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 40, 190, 20));

        neighborLimit.setFont(new java.awt.Font("Arial", 1, 12));
        neighborLimit.setText("5");
        jPanel1.add(neighborLimit, new org.netbeans.lib.awtextra.AbsoluteConstraints(130, 60, 40, -1));

        jLabel31.setBackground(new java.awt.Color(255, 255, 255));
        jLabel31.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel31.setText(" µ");
        jLabel31.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel31.setOpaque(true);
        jPanel1.add(jLabel31, new org.netbeans.lib.awtextra.AbsoluteConstraints(170, 60, 20, 20));

        jLabel11.setFont(new java.awt.Font("Arial", 0, 12));
        jLabel11.setText("Distance threshold");
        jLabel11.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel1.add(jLabel11, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 60, 130, 20));

        estimate.setFont(new java.awt.Font("Arial", 0, 10));
        estimate.setText("Estimate");
        estimate.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        estimate.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel1.add(estimate, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 80, 190, -1));

        jPanel3.add(jPanel1);

        add(jPanel3, java.awt.BorderLayout.NORTH);

        jScrollPane2.setFont(new java.awt.Font("Arial", 0, 12));
        jScrollPane2.setMinimumSize(null);

        Table.setFont(new java.awt.Font("Arial", 0, 12));
        Table.setMinimumSize(null);
        Table.setPreferredScrollableViewportSize(null);
        Table.setPreferredSize(null);
        jScrollPane2.setViewportView(Table);

        add(jScrollPane2, java.awt.BorderLayout.CENTER);

        jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jButton2.setBackground(new java.awt.Color(153, 0, 0));
        jButton2.setFont(new java.awt.Font("Arial", 1, 12));
        jButton2.setForeground(new java.awt.Color(255, 255, 255));
        jButton2.setText("Select");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, -1, 20));

        ButtonColor.setBackground(new java.awt.Color(153, 0, 0));
        ButtonColor.setFont(new java.awt.Font("Arial", 1, 12));
        ButtonColor.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ButtonColorActionPerformed(evt);
            }
        });
        jPanel2.add(ButtonColor, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 0, 20, 20));

        infoLabel.setFont(new java.awt.Font("Arial", 1, 12));
        infoLabel.setText("___________");
        jPanel2.add(infoLabel, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 0, 90, 20));

        jButton4.setBackground(new java.awt.Color(153, 0, 0));
        jButton4.setFont(new java.awt.Font("Arial", 1, 12));
        jButton4.setForeground(new java.awt.Color(255, 255, 255));
        jButton4.setText("Select");
        jButton4.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton4ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton4, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 20, 90, 20));

        jButton5.setBackground(new java.awt.Color(153, 0, 0));
        jButton5.setFont(new java.awt.Font("Arial", 1, 12));
        jButton5.setForeground(new java.awt.Color(255, 255, 255));
        jButton5.setText("Unselect");
        jButton5.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton5ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton5, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 40, 90, 20));

        jButtonContact.setBackground(new java.awt.Color(153, 0, 0));
        jButtonContact.setFont(new java.awt.Font("Arial", 1, 12));
        jButtonContact.setForeground(new java.awt.Color(255, 255, 255));
        jButtonContact.setText("Surface of contact");
        jButtonContact.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonContactActionPerformed(evt);
            }
        });
        jPanel2.add(jButtonContact, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 70, 190, 20));

        jButtonPlus.setBackground(new java.awt.Color(153, 0, 0));
        jButtonPlus.setFont(new java.awt.Font("Arial", 1, 8));
        jButtonPlus.setForeground(new java.awt.Color(255, 255, 255));
        jButtonPlus.setText("+");
        jButtonPlus.setMaximumSize(new java.awt.Dimension(36, 17));
        jButtonPlus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonPlusActionPerformed(evt);
            }
        });
        jPanel2.add(jButtonPlus, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 115, 40, 10));

        jButtonMinus.setBackground(new java.awt.Color(153, 0, 0));
        jButtonMinus.setFont(new java.awt.Font("Arial", 1, 5));
        jButtonMinus.setForeground(new java.awt.Color(255, 255, 255));
        jButtonMinus.setText("-");
        jButtonMinus.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonMinusActionPerformed(evt);
            }
        });
        jPanel2.add(jButtonMinus, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 125, 40, 10));

        contactLimit.setFont(new java.awt.Font("Arial", 0, 12));
        contactLimit.setText("4");
        jPanel2.add(contactLimit, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 115, 55, -1));

        jLabel1.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel1.setText("Threshold");
        jPanel2.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 115, 70, 20));

        jTextField1.setEditable(false);
        jTextField1.setFont(new java.awt.Font("Arial", 1, 12));
        jPanel2.add(jTextField1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 135, 165, -1));

        jButton3.setBackground(new java.awt.Color(153, 0, 0));
        jButton3.setFont(new java.awt.Font("Arial", 1, 12));
        jButton3.setForeground(new java.awt.Color(255, 255, 255));
        jButton3.setText("Delete surface");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton3, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 155, 190, 20));

        jLabel3.setBackground(new java.awt.Color(255, 255, 255));
        jLabel3.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel3.setText(" µ²");
        jLabel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel3.setOpaque(true);
        jPanel2.add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(165, 135, 25, 20));

        jLabel311.setBackground(new java.awt.Color(255, 255, 255));
        jLabel311.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel311.setText(" µ");
        jLabel311.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jLabel311.setOpaque(true);
        jPanel2.add(jLabel311, new org.netbeans.lib.awtextra.AbsoluteConstraints(165, 115, 25, 20));

        jButton6.setBackground(new java.awt.Color(153, 0, 0));
        jButton6.setFont(new java.awt.Font("Arial", 1, 12));
        jButton6.setForeground(new java.awt.Color(255, 255, 255));
        jButton6.setText("Export full report");
        jButton6.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton6ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton6, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 185, 190, 20));

        delaunay.setFont(new java.awt.Font("Arial", 0, 10));
        delaunay.setSelected(true);
        delaunay.setText("Use Delauney triangulation");
        jPanel2.add(delaunay, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 90, 190, -1));

        jPanel4.add(jPanel2);

        add(jPanel4, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents
////////////////////////////////////////////////////////////////////////////////////////////////////
/*    */
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton6ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton6ActionPerformed
        
        javax.swing.JFileChooser chooser = new javax.swing.JFileChooser("Biometry report");
        int returnVal = chooser.showSaveDialog(this);
        if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
            java.io.File fileselected = chooser.getSelectedFile();
            if ( fileselected != null ){
                
                
                try {
                    java.io.BufferedWriter out = new java.io.BufferedWriter(new java.io.FileWriter(fileselected));
                    
                    
                    out.write("#cell A / cell B / closest µ / farest µ / central µ / contact µ2\n");
                    out.write("#devstage="+VirtualEmbryo.devstage+"\n");
                    
                    for(int a=0; a<combo.getItemCount(); ++a){
                        String item = (String) combo.getItemAt(a);
                        cell shape = (cell) objs.get( item );
                        
                        
                        for(int b=a; b<combo.getItemCount(); ++b){
                            String item2 = (String) combo.getItemAt(b);
                            
                            if(item.equals(item2))
                                continue;
                            
                            cell shape2 = (cell) objs.get( item2 );
                            
                            
                            double results[]=new double[2];
                            results=shape.Distance(shape2,2);                            //closest             //farest
                            out.write( shape.getName()+"\t"+shape2.getName()+"\t"+(int)results[0]+"\t"+(int)results[1]+"\t" );
                            int tmp=(int)results[0];
                            
                            results=shape.Distance(shape2,1);
                            out.write( (int)results[0]+"\t" );//central
                            
                            
                            if( tmp <= Float.parseFloat( contactLimit.getText() ) ){ //contact computation if neighboring cells
                                if(delaunay.isSelected())
                                    out.write( this.contactDelaunay(shape,shape2)+"\n" );
                                else
                                    out.write( this.contact(shape,shape2)+"\n" );
                            }else{
                                out.write(0+"\n");
                            }
                            
                            
                        }
                    }
                    
                    out.close();
                } catch (Exception e) {;}
                
            }
        }
        
    }//GEN-LAST:event_jButton6ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton5ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton5ActionPerformed
        for(int a=0; a<Table.getRowCount(); ++a){
            cell node = (cell) objs.get(Table.getValueAt(a,0));
            node.setSelected( false );
        }
    }//GEN-LAST:event_jButton5ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton4ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton4ActionPerformed
        for(int a=0; a<Table.getRowCount(); ++a){
            cell node = (cell) objs.get(Table.getValueAt(a,0));
            node.setSelected( true, new Color3f(node.getTreeRef().getColor()) );
        }
    }//GEN-LAST:event_jButton4ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButtonPlusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonPlusActionPerformed
        double tolerance;
        try{
            tolerance = Float.valueOf(contactLimit.getText()).floatValue() ;
        }catch(java.lang.NumberFormatException e){
            JOptionPane diag2=new JOptionPane();
            diag2.showMessageDialog(new JWindow(),"Error: Incorrect thresold value");
            return;
        }
        tolerance+=0.5;
        
        contactLimit.setText(tolerance+"");
        
        if(delaunay.isSelected())
            contactDelaunay();
        else
            contact();
    }//GEN-LAST:event_jButtonPlusActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButtonMinusActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonMinusActionPerformed
        double tolerance;
        try{
            tolerance = Float.valueOf(contactLimit.getText()).floatValue() ;
        }catch(java.lang.NumberFormatException e){
            JOptionPane diag2=new JOptionPane();
            diag2.showMessageDialog(new JWindow(),"Error: Incorrect thresold value");
            return;
        }
        tolerance-=0.5;
        contactLimit.setText(tolerance+"");
        
        if(delaunay.isSelected())
            contactDelaunay();
        else
            contact();
    }//GEN-LAST:event_jButtonMinusActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        if(bgsurf != null)
            bgsurf.detach();
        
        //For the points
        if (bgsurf2 !=null)
            bgsurf2.detach();
        
        //For the points 
        if (bgsurf3 !=null)
            bgsurf3.detach();
        
        
        
    }//GEN-LAST:event_jButton3ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void ButtonColorActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ButtonColorActionPerformed
        java.awt.Color bgColor = JColorChooser.showDialog(this,"Choose object Color",new java.awt.Color(153,0,0));
        if (bgColor != null){
            ButtonColor.setBackground(bgColor);
        }
    }//GEN-LAST:event_ButtonColorActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        for(int a=0; a<Table.getRowCount(); ++a){
            cell node = (cell) objs.get(Table.getValueAt(a,0));
            node.setSelected(true, ButtonColor.getBackground(), node.isSelected());
        }
    }//GEN-LAST:event_jButton2ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while (ite.hasNext()){
            Object obj3d = ite.next();
            cell node = (cell) objs.get(obj3d);
            if(node.isSelected()){
                combo.setSelectedItem(obj3d.toString());
            }
        }
    }//GEN-LAST:event_jButton1ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButtonContactActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonContactActionPerformed
        if(delaunay.isSelected())
            contactDelaunay();
        else
            contact();
    }//GEN-LAST:event_jButtonContactActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void contactDelaunay(){
        
        String item = (String) combo.getSelectedItem();
        if(item != null){
            cell node1=(cell) objs.get( item );
            
            cell node2;
            
            
            if( Table.getSelectedRow() >=0 ){
                node2=(cell)
                objs.get( Table.getValueAt(Table.getSelectedRow(),0));
            }else{return;}
            
            GeometryArray geom1 = (GeometryArray) node1.getGeometry();
            GeometryArray geom2 = (GeometryArray) node2.getGeometry();
            
            com.sun.j3d.utils.geometry.GeometryInfo geoinfo1 = new
            com.sun.j3d.utils.geometry.GeometryInfo(geom1);
            com.sun.j3d.utils.geometry.GeometryInfo geoinfo2 = new
            com.sun.j3d.utils.geometry.GeometryInfo(geom2);
            
            Point3f[] coordinates1 = new Point3f[geom1.getVertexCount()];
            Point3f[] coordinates2 = new Point3f[geom2.getVertexCount()];
            
            coordinates1 = geoinfo1.getCoordinates();
            coordinates2 = geoinfo2.getCoordinates();
            
            double tolerance;
            try{
                tolerance =
                Float.valueOf(contactLimit.getText()).floatValue() ;
            }catch(java.lang.NumberFormatException e){
                JOptionPane diag2=new JOptionPane();
                diag2.showMessageDialog(new JWindow(),"Error: Incorrect thresold value");
                return;
            }
            double tolerance2=tolerance+(tolerance/2);
            
            
            Vector sharedPoints = new Vector();
            int hit=0;
            double surface=0;
            
            /*Delaunay 3D*/

            //First cell area of contact

            ArrayList candidat=new ArrayList();
            
            /*Search for nearest point from cell a to cell b*/
            int m=0;
            for (int b=0;b<coordinates2.length;b++) {
                
                for (int a=0;a<coordinates1.length;a++) {
                    if (coordinates1[a].distance(coordinates2[b]) <= tolerance) {
  
                        if (!isIn(coordinates1[a],candidat)) {
                            candidat.add(coordinates1[a]);
                          }
                    }
                }
            }
            //Array containing candidate points ready to be triangulated
            Point3f[] candidat1=new Point3f[candidat.size()];
            for (int i=0;i<candidat.size();i++)
                candidat1[i]=(Point3f) candidat.get(i);
            
            boolean pointFree;
            int n=candidat1.length;
            
            for (int i = 0; i < n-2; i++) {
                
                for (int j = i + 1; j < n-1; j++)
                    if (j != i)
                        for (int k = j + 1; k < n; k++)
                            if (k != i && k != j) {
                                
                                Point3f circumcenter=computeCircumcenter(candidat1[i],candidat1[j],candidat1[k]);
                                
                                pointFree = true;
                                for (int l = 0; l < n; l++)
                                    if (l != i && l != j && l != k) {
                                        
                                        if (candidat1[l].distance(circumcenter)<candidat1[i].distance(circumcenter)) {
                                            pointFree = false;
                                            break;
                                        }
                                    }
                                
                                
                                if (pointFree){
                                    
                                    //Heuristic to give up bad triangles
                                    
                                    float d1=candidat1[i].distance(candidat1[j]);
                                    float d2=candidat1[j].distance(candidat1[k]);
                                    float d3=candidat1[i].distance(candidat1[k]);
                                    
                                    double angleA=((double) Math.pow((double)d2,2)+Math.pow((double) d3,2)-Math.pow((double) d1,2))/(2*d2*d3);
                                    double angleB=((double) Math.pow((double)d1,2)+Math.pow((double) d2,2)-Math.pow((double) d3,2))/(2*d1*d2);
                                    double angleC=((double) Math.pow((double)d1,2)+Math.pow((double) d3,2)-Math.pow((double) d2,2))/(2*d1*d3);
                                    
                                    //Threshold ... 
                                    double seuil=0.98;
                                    
                                    if (((angleA<seuil)&&(angleB<seuil))&&(angleC<seuil)) {
                                        
                                        sharedPoints.add(hit++, candidat1[i]);
                                        sharedPoints.add(hit++, candidat1[j]);
                                        sharedPoints.add(hit++, candidat1[k]);
                                        
                                        float aa = candidat1[i].distance(candidat1[j]);
                                        float bb = candidat1[j].distance(candidat1[k]);
                                        float cc = candidat1[k].distance(candidat1[i]);
                                        
                                        
                                        float p =(aa+bb+cc)/2;
                                        surface+=Math.sqrt(p*(p-aa)*(p-bb)*(p-cc));
                                        
                                    }
                                }
                            }
            }
            
            
            //Id. for the second cell
            ArrayList candidat2eme=new ArrayList();
            
            for (int b=0;b<coordinates1.length;b++) {
                
                for (int a=0;a<coordinates2.length;a++) {
                    if (coordinates2[a].distance(coordinates1[b]) <= tolerance) {
                        if (!isIn(coordinates2[a],candidat2eme))
                            candidat2eme.add(coordinates2[a]);
                        
                    }
                    
                }
                
            }

            Point3f[] candidat2=new Point3f[candidat2eme.size()];
            for (int i=0;i<candidat2eme.size();i++)
                candidat2[i]=(Point3f) candidat2eme.get(i);
            
            boolean pointFree2;
            int nn=candidat2.length;
            
            for (int i = 0; i < nn-2; i++) {
                
                
                for (int j = i + 1; j < nn-1; j++)
                    if (j != i)
                        for (int k = j + 1; k < nn; k++)
                            if (k != i && k != j) {
                                
                                Point3f circumcenter=computeCircumcenter(candidat2[i],candidat2[j],candidat2[k]);
                               
                                pointFree2 = true;
                                for (int l = 0; l < nn; l++)
                                    if (l != i && l != j && l != k) {
                                        
                                        if (candidat2[l].distance(circumcenter)<candidat2[i].distance(circumcenter)) {
                                            pointFree2 = false;
                                            break;
                                        }
                                    }
                                
                                
                                if (pointFree2){

                                    float d1=candidat2[i].distance(candidat2[j]);
                                    float d2=candidat2[j].distance(candidat2[k]);
                                    float d3=candidat2[i].distance(candidat2[k]);

                                    double angleA=((double) Math.pow((double)d2,2)+Math.pow((double) d3,2)-Math.pow((double) d1,2))/(2*d2*d3);
                                    double angleB=((double) Math.pow((double)d1,2)+Math.pow((double) d2,2)-Math.pow((double) d3,2))/(2*d1*d2);
                                    double angleC=((double) Math.pow((double)d1,2)+Math.pow((double) d3,2)-Math.pow((double) d2,2))/(2*d1*d3);
                                    
                                    double seuil=0.98;
                                    
                                    if(((angleA<seuil)&&(angleB<seuil))&&(angleC<seuil)) {
                                        
                                        sharedPoints.add(hit++, candidat2[i]);
                                        sharedPoints.add(hit++, candidat2[j]);
                                        sharedPoints.add(hit++, candidat2[k]);
                                        
                                        float aa = candidat2[i].distance(candidat2[j]);
                                        float bb = candidat2[j].distance(candidat2[k]);
                                        float cc = candidat2[k].distance(candidat2[i]);
                                        
                                        float p =(aa+bb+cc)/2;
                                        surface+=Math.sqrt(p*(p-aa)*(p-bb)*(p-cc));
                                        
                                    }
                                }
                            }
            }
            
            
            surface/=2;
            
            Point3f[] shared = new Point3f[sharedPoints.size()];
            sharedPoints.copyInto(shared);
            
            jTextField1.setText((int)surface+"");
            

            //Rebuild of the contact area as a 3d independant object
                        
            if(shared.length>0){
                
                if(bgsurf != null)
                    bgsurf.detach();
                
                TriangleArray contact = new TriangleArray(shared.length,
                GeometryArray.COORDINATES | GeometryArray.COLOR_3 | GeometryArray.NORMALS  );
                contact.setCoordinates(0, shared);
                
                //Make a new appearance
                float xx=contact.getVertexCount();
                for(int a=0; a<xx; ++a)
                    contact.setColor(a, new Color3f( 0, 0.8f, 0.2f ) );
                
                //Make a new geometry with selected points
                Shape3D sharedSurf = new Shape3D(contact, new Appearance());
                
                Appearance app = sharedSurf.getAppearance();
                PolygonAttributes poly = new PolygonAttributes();
                poly.setCullFace(PolygonAttributes.CULL_NONE);
                app.setPolygonAttributes(poly);
                
                bgsurf=new BranchGroup();
                bgsurf.setCapability(BranchGroup.ALLOW_DETACH);
                bgsurf.addChild(sharedSurf);
                bgsurf.setPickable(false);
                embryo.TGsizeCell.addChild(bgsurf);
            }
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private int contactDelaunay(cell node1, cell node2){
 
            
            GeometryArray geom1 = (GeometryArray) node1.getGeometry();
            GeometryArray geom2 = (GeometryArray) node2.getGeometry();
            
            com.sun.j3d.utils.geometry.GeometryInfo geoinfo1 = new
            com.sun.j3d.utils.geometry.GeometryInfo(geom1);
            com.sun.j3d.utils.geometry.GeometryInfo geoinfo2 = new
            com.sun.j3d.utils.geometry.GeometryInfo(geom2);
            
            Point3f[] coordinates1 = new Point3f[geom1.getVertexCount()];
            Point3f[] coordinates2 = new Point3f[geom2.getVertexCount()];
            
            coordinates1 = geoinfo1.getCoordinates();
            coordinates2 = geoinfo2.getCoordinates();
            
            double tolerance;
            try{
                tolerance =
                Float.valueOf(contactLimit.getText()).floatValue() ;
            }catch(java.lang.NumberFormatException e){
                JOptionPane diag2=new JOptionPane();
                diag2.showMessageDialog(new JWindow(),"Error: Incorrect thresold value");
                return (-1);
            }
            double tolerance2=tolerance+(tolerance/2);
            
            
            Vector sharedPoints = new Vector();
            int hit=0;
            double surface=0;

            
            ArrayList candidat=new ArrayList();
            
            int m=0;
            for (int b=0;b<coordinates2.length;b++) {
                
                for (int a=0;a<coordinates1.length;a++) {
                    if (coordinates1[a].distance(coordinates2[b]) <= tolerance) {
                        
                        if (!isIn(coordinates1[a],candidat)) {
                            candidat.add(coordinates1[a]);

                        }
                    }
                }
            }

            Point3f[] candidat1=new Point3f[candidat.size()];
            for (int i=0;i<candidat.size();i++)
                candidat1[i]=(Point3f) candidat.get(i);
            
            boolean pointFree;
            int n=candidat1.length;
            
            for (int i = 0; i < n-2; i++) {
                
                for (int j = i + 1; j < n-1; j++)
                    if (j != i)
                        for (int k = j + 1; k < n; k++)
                            if (k != i && k != j) {
                                
                                Point3f circumcenter=computeCircumcenter(candidat1[i],candidat1[j],candidat1[k]);
                                pointFree = true;
                                for (int l = 0; l < n; l++)
                                    if (l != i && l != j && l != k) {
                                        
                                        if (candidat1[l].distance(circumcenter)<candidat1[i].distance(circumcenter)) {
                                            pointFree = false;
                                            break;
                                        }
                                    }
                                
                                if (pointFree){

                                    float d1=candidat1[i].distance(candidat1[j]);
                                    float d2=candidat1[j].distance(candidat1[k]);
                                    float d3=candidat1[i].distance(candidat1[k]);
                                    

                                    double angleA=((double) Math.pow((double)d2,2)+Math.pow((double) d3,2)-Math.pow((double) d1,2))/(2*d2*d3);
                                    double angleB=((double) Math.pow((double)d1,2)+Math.pow((double) d2,2)-Math.pow((double) d3,2))/(2*d1*d2);
                                    double angleC=((double) Math.pow((double)d1,2)+Math.pow((double) d3,2)-Math.pow((double) d2,2))/(2*d1*d3);
                                    
                                    
                                    double seuil=0.98;
                                    
                                    if (((angleA<seuil)&&(angleB<seuil))&&(angleC<seuil)) {
                                        
                                        sharedPoints.add(hit++, candidat1[i]);
                                        sharedPoints.add(hit++, candidat1[j]);
                                        sharedPoints.add(hit++, candidat1[k]);
                                        
                                        float aa = candidat1[i].distance(candidat1[j]);
                                        float bb = candidat1[j].distance(candidat1[k]);
                                        float cc = candidat1[k].distance(candidat1[i]);
                                        
                                        
                                        float p =(aa+bb+cc)/2;
                                        surface+=Math.sqrt(p*(p-aa)*(p-bb)*(p-cc));
                                        
                                    }
                                }
                            }
            }
            
            
            

            ArrayList candidat2eme=new ArrayList();
            
            for (int b=0;b<coordinates1.length;b++) {
                
                for (int a=0;a<coordinates2.length;a++) {
                    if (coordinates2[a].distance(coordinates1[b]) <= tolerance) {
                        if (!isIn(coordinates2[a],candidat2eme))
                            candidat2eme.add(coordinates2[a]);
                        
                    }
                    
                }
                
            }

            Point3f[] candidat2=new Point3f[candidat2eme.size()];
            for (int i=0;i<candidat2eme.size();i++)
                candidat2[i]=(Point3f) candidat2eme.get(i);
            

            boolean pointFree2;
            int nn=candidat2.length;
            
            for (int i = 0; i < nn-2; i++) {
                
                
                for (int j = i + 1; j < nn-1; j++)
                    if (j != i)
                        for (int k = j + 1; k < nn; k++)
                            if (k != i && k != j) {
                                
                                Point3f circumcenter=computeCircumcenter(candidat2[i],candidat2[j],candidat2[k]);
                                
                                pointFree2 = true;
                                for (int l = 0; l < nn; l++)
                                    if (l != i && l != j && l != k) {
                                        
                                        if (candidat2[l].distance(circumcenter)<candidat2[i].distance(circumcenter)) {
                                            pointFree2 = false;
                                            break;
                                        }
                                    }
                                
                                
                                if (pointFree2){
                                    
                                    float d1=candidat2[i].distance(candidat2[j]);
                                    float d2=candidat2[j].distance(candidat2[k]);
                                    float d3=candidat2[i].distance(candidat2[k]);
                                    

                                    double angleA=((double) Math.pow((double)d2,2)+Math.pow((double) d3,2)-Math.pow((double) d1,2))/(2*d2*d3);
                                    double angleB=((double) Math.pow((double)d1,2)+Math.pow((double) d2,2)-Math.pow((double) d3,2))/(2*d1*d2);
                                    double angleC=((double) Math.pow((double)d1,2)+Math.pow((double) d3,2)-Math.pow((double) d2,2))/(2*d1*d3);
                                    
                                    double seuil=0.98;
                                    
                                    if(((angleA<seuil)&&(angleB<seuil))&&(angleC<seuil)) {
                                        
                                        sharedPoints.add(hit++, candidat2[i]);
                                        sharedPoints.add(hit++, candidat2[j]);
                                        sharedPoints.add(hit++, candidat2[k]);
                                        
                                        float aa = candidat2[i].distance(candidat2[j]);
                                        float bb = candidat2[j].distance(candidat2[k]);
                                        float cc = candidat2[k].distance(candidat2[i]);
                                        
                                        float p =(aa+bb+cc)/2;
                                        surface+=Math.sqrt(p*(p-aa)*(p-bb)*(p-cc));
                                        
                                    }
                                }
                            }
            }
            surface/=2;
        return ((int)surface);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private int contact(cell node1, cell node2){
        GeometryArray geom1 = (GeometryArray) node1.getGeometry();
        GeometryArray geom2 = (GeometryArray) node2.getGeometry();
        
        com.sun.j3d.utils.geometry.GeometryInfo geoinfo1 = new com.sun.j3d.utils.geometry.GeometryInfo(geom1);
        com.sun.j3d.utils.geometry.GeometryInfo geoinfo2 = new com.sun.j3d.utils.geometry.GeometryInfo(geom2);
        
        Point3f[] coordinates1 = new Point3f[geom1.getVertexCount()];
        Point3f[] coordinates2 = new Point3f[geom2.getVertexCount()];
        
        coordinates1 = geoinfo1.getCoordinates();
        coordinates2 = geoinfo2.getCoordinates();
        
        double tolerance;
        try{
            tolerance = Float.valueOf(contactLimit.getText()).floatValue();
        }catch(java.lang.NumberFormatException e){
            JOptionPane diag2=new JOptionPane();
            diag2.showMessageDialog(new JWindow(),"Error: Incorrect thresold value");
            return -1;
        }
        double tolerance2=tolerance+(tolerance/2);
        
        
        Vector sharedPoints = new Vector();
        int hit=0;
        double surface=0;
        
        
        
        for(int a=0; a<coordinates1.length-2; a+=3){
            
            Point3f[] triangle=new Point3f[3];
            triangle[0]=coordinates1[a];
            triangle[1]=coordinates1[a+1];
            triangle[2]=coordinates1[a+2];
            
            int score[]=new int[3];
            score[0]=0;
            score[1]=0;
            score[2]=0;
            
            for(int b=0; b<coordinates2.length; ++b){
                
                if(triangle[0] != null){
                    if( triangle[0].distance(coordinates2[b]) <= tolerance){
                        score[0]=2;
                        triangle[0]=null;
                    }
                    else if( triangle[0].distance(coordinates2[b]) <= tolerance2){
                        score[0]=1;
                    }
                }
                
                if(triangle[1] != null){
                    if( triangle[1].distance(coordinates2[b]) <= tolerance){
                        score[1]=2;
                        triangle[1]=null;
                    }
                    else if( triangle[1].distance(coordinates2[b]) <= tolerance2){
                        score[1]=1;
                    }
                }
                
                if(triangle[2] != null){
                    if( triangle[2].distance(coordinates2[b]) <= tolerance){
                        score[2]=2;
                        triangle[2]=null;
                    }
                    else if(triangle[2].distance(coordinates2[b]) <= tolerance2){
                        score[2]=1;
                    }
                }
                
                if ( (score[0]+score[1]+score[2])>=5 ){
                    sharedPoints.add(hit++, coordinates1[a]);
                    sharedPoints.add(hit++, coordinates1[a+1]);
                    sharedPoints.add(hit++, coordinates1[a+2]);
                    
                    float aa = coordinates1[a].distance(coordinates1[a+1]);
                    float bb = coordinates1[a+1].distance(coordinates1[a+2]);
                    float cc = coordinates1[a+2].distance(coordinates1[a]);
                    
                    
                    float p =(aa+bb+cc)/2;
                    surface+=Math.sqrt(p*(p-aa)*(p-bb)*(p-cc));
                    break;
                }
                
            }
        }
        
        
        //second cell: contact area
        for(int a=0; a<coordinates2.length-2; a+=3){
            
            Point3f[] triangle=new Point3f[3];
            triangle[0]=coordinates2[a];
            triangle[1]=coordinates2[a+1];
            triangle[2]=coordinates2[a+2];
            
            int score[]=new int[3];
            score[0]=0;
            score[1]=0;
            score[2]=0;
            
            for(int b=0; b<coordinates1.length; ++b){
                
                if(triangle[0] != null){
                    if( triangle[0].distance(coordinates1[b]) <= tolerance){
                        score[0]=2;
                        triangle[0]=null;
                    }
                    else if( triangle[0].distance(coordinates1[b]) <= tolerance2){
                        score[0]=1;
                    }
                }
                
                if(triangle[1] != null){
                    if( triangle[1].distance(coordinates1[b]) <= tolerance){
                        score[1]=2;
                        triangle[1]=null;
                    }
                    else if( triangle[1].distance(coordinates1[b]) <= tolerance2){
                        score[1]=1;
                    }
                }
                
                if(triangle[2] != null){
                    if( triangle[2].distance(coordinates1[b]) <= tolerance){
                        score[2]=2;
                        triangle[2]=null;
                    }
                    else if( triangle[2].distance(coordinates1[b]) <= tolerance2){
                        score[2]=1;
                    }
                }
                
                if ( (score[0]+score[1]+score[2])>=5 ){
                    sharedPoints.add(hit++, coordinates2[a]);
                    sharedPoints.add(hit++, coordinates2[a+1]);
                    sharedPoints.add(hit++, coordinates2[a+2]);
                    
                    float aa = coordinates2[a].distance(coordinates2[a+1]);
                    float bb = coordinates2[a+1].distance(coordinates2[a+2]);
                    float cc = coordinates2[a+2].distance(coordinates2[a]);
                    
                    
                    float p =(aa+bb+cc)/2;
                    surface+=Math.sqrt(p*(p-aa)*(p-bb)*(p-cc));
                    break;
                }
                
            }
        }
        
        surface/=2;
        
        return ((int)surface);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void contact(){
        
        String item = (String) combo.getSelectedItem();
        if(item != null){
            cell node1=(cell) objs.get( item );
            
            cell node2;
            if( Table.getSelectedRow() >=0 ){
                node2=(cell) objs.get( Table.getValueAt(Table.getSelectedRow(),0));
            }else{return;}
            
            GeometryArray geom1 = (GeometryArray) node1.getGeometry();
            GeometryArray geom2 = (GeometryArray) node2.getGeometry();
            
            com.sun.j3d.utils.geometry.GeometryInfo geoinfo1 = new com.sun.j3d.utils.geometry.GeometryInfo(geom1);
            com.sun.j3d.utils.geometry.GeometryInfo geoinfo2 = new com.sun.j3d.utils.geometry.GeometryInfo(geom2);
            
            Point3f[] coordinates1 = new Point3f[geom1.getVertexCount()];
            Point3f[] coordinates2 = new Point3f[geom2.getVertexCount()];
            
            coordinates1 = geoinfo1.getCoordinates();
            coordinates2 = geoinfo2.getCoordinates();
            
            double tolerance;
            try{
                tolerance = Float.valueOf(contactLimit.getText()).floatValue() ;
            }catch(java.lang.NumberFormatException e){
                JOptionPane diag2=new JOptionPane();
                diag2.showMessageDialog(new JWindow(),"Error: Incorrect thresold value");
                return;
            }
            double tolerance2=tolerance+(tolerance/2);
            
            
            Vector sharedPoints = new Vector();
            int hit=0;
            double surface=0;
            
            
            
            for(int a=0; a<coordinates1.length-2; a+=3){
                
                Point3f[] triangle=new Point3f[3];
                triangle[0]=coordinates1[a];
                triangle[1]=coordinates1[a+1];
                triangle[2]=coordinates1[a+2];
                
                int score[]=new int[3];
                score[0]=0;
                score[1]=0;
                score[2]=0;
                
                for(int b=0; b<coordinates2.length; ++b){
                    
                    if(triangle[0] != null){
                        if( triangle[0].distance(coordinates2[b]) <= tolerance){
                            score[0]=2;
                            triangle[0]=null;
                        }
                        else if( triangle[0].distance(coordinates2[b]) <= tolerance2){
                            score[0]=1;
                        }
                    }
                    
                    if(triangle[1] != null){
                        if( triangle[1].distance(coordinates2[b]) <= tolerance){
                            score[1]=2;
                            triangle[1]=null;
                        }
                        else if( triangle[1].distance(coordinates2[b]) <= tolerance2){
                            score[1]=1;
                        }
                    }
                    
                    if(triangle[2] != null){
                        if( triangle[2].distance(coordinates2[b]) <= tolerance){
                            score[2]=2;
                            triangle[2]=null;
                        }
                        else if(triangle[2].distance(coordinates2[b]) <= tolerance2){
                            score[2]=1;
                        }
                    }
                    
                    
                    if ( (score[0]+score[1]+score[2])>=5 ){
                        sharedPoints.add(hit++, coordinates1[a]);
                        sharedPoints.add(hit++, coordinates1[a+1]);
                        sharedPoints.add(hit++, coordinates1[a+2]);
                        
                        float aa = coordinates1[a].distance(coordinates1[a+1]);
                        float bb = coordinates1[a+1].distance(coordinates1[a+2]);
                        float cc = coordinates1[a+2].distance(coordinates1[a]);
                        
                        
                        float p =(aa+bb+cc)/2;
                        surface+=Math.sqrt(p*(p-aa)*(p-bb)*(p-cc));
                        break;
                    }
                    
                }
            }
            
            
            //Second cell: contact area
            for(int a=0; a<coordinates2.length-2; a+=3){
                Point3f[] triangle=new Point3f[3];
                triangle[0]=coordinates2[a];
                triangle[1]=coordinates2[a+1];
                triangle[2]=coordinates2[a+2];
                
                int score[]=new int[3];
                score[0]=0;
                score[1]=0;
                score[2]=0;
                
                for(int b=0; b<coordinates1.length; ++b){
                    
                    if(triangle[0] != null){
                        if( triangle[0].distance(coordinates1[b]) <= tolerance){
                            score[0]=2;
                            triangle[0]=null;
                        }
                        else if( triangle[0].distance(coordinates1[b]) <= tolerance2){
                            score[0]=1;
                        }
                    }
                    
                    if(triangle[1] != null){
                        if( triangle[1].distance(coordinates1[b]) <= tolerance){
                            score[1]=2;
                            triangle[1]=null;
                        }
                        else if( triangle[1].distance(coordinates1[b]) <= tolerance2){
                            score[1]=1;
                        }
                    }
                    
                    if(triangle[2] != null){
                        if( triangle[2].distance(coordinates1[b]) <= tolerance){
                            score[2]=2;
                            triangle[2]=null;
                        }
                        else if( triangle[2].distance(coordinates1[b]) <= tolerance2){
                            score[2]=1;
                        }
                    }
                    
                    if ( (score[0]+score[1]+score[2])>=5 ){
                        sharedPoints.add(hit++, coordinates2[a]);
                        sharedPoints.add(hit++, coordinates2[a+1]);
                        sharedPoints.add(hit++, coordinates2[a+2]);
                        
                        float aa = coordinates2[a].distance(coordinates2[a+1]);
                        float bb = coordinates2[a+1].distance(coordinates2[a+2]);
                        float cc = coordinates2[a+2].distance(coordinates2[a]);
                        
                        
                        float p =(aa+bb+cc)/2;
                        surface+=Math.sqrt(p*(p-aa)*(p-bb)*(p-cc));
                        break;
                    }
                }
            }
            
            surface/=2;
            
            
            Point3f[] shared = new Point3f[sharedPoints.size()];
            sharedPoints.copyInto(shared);
            
            jTextField1.setText((int)surface+"");
 
            
 // rebuild area of contact 
            
            if(shared.length>0){
                
                if(bgsurf != null)
                    bgsurf.detach();
                
                TriangleArray contact = new TriangleArray(shared.length, GeometryArray.COORDINATES | GeometryArray.COLOR_3 | GeometryArray.NORMALS  );
                contact.setCoordinates(0, shared);
                
                
                //A good appearance
                //float xx=contact.getVertexCount();
                //for(int a=0; a<xx; ++a)
                //contact.setColor(a, new Color3f( 0.2f, (1f*a)/xx, (1f*a)/xx) );
                //contact.setColor(a, new Color3f( 0, (a-0.3f)/xx, 0.2f ) );
                
                //New Appearance
                float xx=contact.getVertexCount();
                for(int a=0; a<xx; ++a)
                    contact.setColor(a, new Color3f( 0, 0.8f, 0.2f ) );
                
                //New geometry
                Shape3D sharedSurf = new Shape3D(contact, new Appearance());
                
                Appearance app = sharedSurf.getAppearance();
                PolygonAttributes poly = new PolygonAttributes();
                poly.setCullFace(PolygonAttributes.CULL_NONE);
                app.setPolygonAttributes(poly);
                
                
                bgsurf=new BranchGroup();
                bgsurf.setCapability(BranchGroup.ALLOW_DETACH);
                bgsurf.addChild(sharedSurf);
                bgsurf.setPickable(false);
                embryo.TGsizeCell.addChild(bgsurf);
                
            }
            
        }
        
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
//Given a triangle: compute the circumcenter
    private Point3f computeCircumcenter(Point3f a,Point3f b, Point3f c) {
        Point3f result=new Point3f();
        
        float x1=a.x;
        float y1=a.y;
        float z1=a.z;
        
        float x2=b.x;
        float y2=b.y;
        float z2=b.z;
        
        float x3=c.x;
        float y3=c.y;
        float z3=c.z;
        
        float dx1,dy1,dz1,dx2,dy2,dz2,dx3,dy3,dz3;
        float tnx,tny,tnz;
        float sx1,sy1,sz1,sx2,sy2,sz2,sx3,sy3,sz3,sx4,sy4,sz4;
        float nx,ny,nz;
        float ax,ay,az,bx,by,bz,cx,cy,cz;
        float qx1,qy1,qz1,qx2,qy2,qz2;
        float dot;
        float le;
        float si;
        
        float circumcenterx,circumcentery,circumcenterz;
        
        dx1=x2-x1;
        dy1=y2-y1;
        dz1=z2-z1;
        
        dx2=x3-x1;
        dy2=y3-y1;
        dz2=z3-z1;
        
        tnx = dy1 * dz2 - dy2 * dz1;
        tny = dz1 * dx2 - dz2 * dx1;
        tnz = dx1 * dy2 - dx2 * dy1;
        
        sx1=(x1+x3)/2.0f;
        sy1=(y1+y3)/2.0f;
        sz1=(z1+z3)/2.0f;
        
        dx1=(sx1-x1);
        dy1=(sy1-y1);
        dz1=(sz1-z1);
        
        dx2=tnx;
        dy2=tny;
        dz2=tnz;
        
        nx = dy1 * dz2 - dy2 * dz1;
        ny = dz1 * dx2 - dz2 * dx1;
        nz = dx1 * dy2 - dx2 * dy1;
        
        sx2=sx1+nx;
        sy2=sy1+ny;
        sz2=sz1+nz;
        
        sx3=(x1+x2)/2.0f;
        sy3=(y1+y2)/2.0f;
        sz3=(z1+z2)/2.0f;
        
        dx1=(sx3-x1);
        dy1=(sy3-y1);
        dz1=(sz3-z1);
        
        dx2=tnx;
        dy2=tny;
        dz2=tnz;
        
        nx = dy1 * dz2 - dy2 * dz1;
        ny = dz1 * dx2 - dz2 * dx1;
        nz = dx1 * dy2 - dx2 * dy1;
        
        sx4=sx3+nx;
        sy4=sy3+ny;
        sz4=sz3+nz;
        
        ax=sx2-sx1;
        ay=sy2-sy1;
        az=sz2-sz1;
        
        bx=sx4-sx3;
        by=sy4-sy3;
        bz=sz4-sz3;
        
        cx=sx3-sx1;
        cy=sy3-sy1;
        cz=sz3-sz1;
        
        qx1 = cy * bz - by * cz;
        qy1 = cz * bx - bz * cx;
        qz1 = cx * by - bx * cy;
        
        qx2 = ay * bz - by * az;
        qy2 = az * bx - bz * ax;
        qz2 = ax * by - bx * ay;
        
        dot=qx1*qx2+qy1*qy2+qz1*qz2;
        
        le= (float) Math.sqrt((double)qx2*qx2+qy2*qy2+qz2*qz2);
        
        si=dot/(le*le);
        
        circumcenterx=sx1+ax*si;
        circumcentery=sy1+ay*si;
        circumcenterz=sz1+az*si;
        
        result.x=circumcenterx;
        result.y=circumcentery;
        result.z=circumcenterz;
        
        return result;
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////        
    private boolean isIn(Point3f a,ArrayList b) {
        return b.contains(a);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////        
    private void jButtonNeighborActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonNeighborActionPerformed
        
        while(Table.getRowCount()>0)
            t1.removeRow(0);
        
        float limit;
        try{
            limit = Float.valueOf(neighborLimit.getText()).floatValue() ;
        }catch(java.lang.NumberFormatException e){
            JOptionPane diag2=new JOptionPane();
            diag2.showMessageDialog(new JWindow(),"Error: Incorrect thresold value");
            return;
        }
        
        int cont=0;
        String item = (String) combo.getSelectedItem();
        cell shape=(cell) objs.get( item );
        
        ArrayList candidat=new ArrayList();
        
        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while (ite.hasNext()){
            Object obj3d = ite.next();
            cell node = (cell) objs.get(obj3d);
            
            BoundingSphere b=new BoundingSphere(shape.getBounds());
            
            b.setRadius(b.getRadius()+limit);
            
            if (b.intersect(node.getBounds()))
                if (!obj3d.toString().equals(item)) {
                    candidat.add(obj3d);
                }
        }
        
        if(! estimate.isSelected()){
            for (int i=0;i<candidat.size();i++) {
                Object obj3d=(Object) candidat.get(i);
                cell node = (cell) objs.get(obj3d);
                
                double result[]=new double[1];
                result= shape.Distance(node,2);
                double dist = result[0];
                
                if (  (dist< limit )&(! obj3d.toString().equals(item))  ){
                    ++cont;
                    
                    result= shape.Distance(node,1);
                    double dist2 = result[0];
                    
                    t1.addRow(new Object[] {obj3d.toString(), new java.lang.Integer((int)dist2), new java.lang.Integer((int)dist)});
                }
                
            }
        }else{
            for (int i=0;i<candidat.size();i++) {
                ++cont;
                Object obj3d=(Object) candidat.get(i);
                t1.addRow(new Object[] {obj3d.toString(), null, null});
            }
        }
        
        
        
        infoLabel.setText(cont+" cells found");
        
  
    }//GEN-LAST:event_jButtonNeighborActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////        
    public void selectionSort(JComboBox cmb){
        
        int count = cmb.getItemCount();
        for(int start = 0;start < count;start++){
            for(int x = start;x < count-1;x++){
                String first = (String)cmb.getItemAt(start);
                String next = (String)cmb.getItemAt(x+1);
                if( compare(first,next)>0 ){
                    String temp  = (String)cmb.getItemAt(start);
                    String temp2 = (String)cmb.getItemAt(x+1);
                    cmb.removeItemAt(start);
                    cmb.insertItemAt(temp2,start);
                    cmb.removeItemAt(x+1);
                    cmb.insertItemAt(temp,x+1);
                }
            }
        }
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////        
    private int compare(String o1, String o2){
        Comparable c1 = (Comparable) o1;
        Comparable c2 = (Comparable) o2;
        
        try {
            return c1.compareTo(c2);
        } catch (ClassCastException cce) {;}
        return 0;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////        
    public void destroy(){
        try{
            Set keys = objs.keySet();
            Iterator ite = keys.iterator();
            while (ite.hasNext()){
                Object obj3d = ite.next();
                objs.remove(obj3d);
            }
            //objs.clear();
            this.removeAll();
        }catch(Exception e){;}
    }
////////////////////////////////////////////////////////////////////////////////////////////////////        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton ButtonColor;
    private javax.swing.JTable Table;
    private javax.swing.JComboBox combo;
    private javax.swing.JTextField contactLimit;
    private javax.swing.JRadioButton delaunay;
    private javax.swing.JRadioButton estimate;
    private javax.swing.JLabel infoLabel;
    private javax.swing.JTextField jTextField1;
    private javax.swing.JTextField neighborLimit;
    // End of variables declaration//GEN-END:variables
    
}
