package fr.cnrs.aniseed;

import java.util.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, 8 decembre 2004, 12:08
 */

public class BiometrySphericity extends javax.swing.JPanel {
    
    private GTableModel t1;
    private Hashtable objs;
    
////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor
    public BiometrySphericity(Hashtable objs) {
        initComponents();
        
        this.objs=objs;
        
        t1=new GTableModel();
        t1.addColumn("Cell");
        t1.addColumn("Sphericity");
        t1.addColumn("Elongation");
        t1.addColumn("Flatness");
        t1.addColumn("Squareness");
        t1.addColumn("Entropy");
        t1.addColumn("S/V");
        t1.addColumn("Convexity");
        t1.addColumn("v/V");
        
        t1.addMouseListenerToHeaderInTable(TableSphericity);
        
        
        TableSphericity.setModel(t1);
        TableSphericity.getTableHeader().setReorderingAllowed(false);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
////////////////////////////////////////////////////////////////////////////////////////////////////    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel2 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel11 = new javax.swing.JPanel();
        javax.swing.JButton jButton1 = new javax.swing.JButton();
        javax.swing.JLabel jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        TableSphericity = new javax.swing.JTable();
        javax.swing.JPanel jPanel3 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel4 = new javax.swing.JPanel();
        javax.swing.JButton jButton2 = new javax.swing.JButton();
        javax.swing.JButton jButton3 = new javax.swing.JButton();
        show = new javax.swing.JCheckBox();

        setMinimumSize(new java.awt.Dimension(200, 107));
        setPreferredSize(new java.awt.Dimension(200, 88));
        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new java.awt.BorderLayout());

        jPanel11.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jButton1.setBackground(new java.awt.Color(153, 0, 0));
        jButton1.setFont(new java.awt.Font("Arial", 1, 12));
        jButton1.setForeground(new java.awt.Color(255, 255, 255));
        jButton1.setText("Compute selected cells");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel11.add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 30, 190, 20));

        jLabel1.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel1.setText("Cell geometry descriptor");
        jPanel11.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 10, 170, 20));

        jPanel2.add(jPanel11);

        jPanel1.add(jPanel2, java.awt.BorderLayout.NORTH);

        jScrollPane1.setViewportView(TableSphericity);

        jPanel1.add(jScrollPane1, java.awt.BorderLayout.CENTER);

        add(jPanel1, java.awt.BorderLayout.CENTER);

        jPanel4.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jButton2.setBackground(new java.awt.Color(153, 0, 0));
        jButton2.setFont(new java.awt.Font("Arial", 1, 12));
        jButton2.setForeground(new java.awt.Color(255, 255, 255));
        jButton2.setText("Export");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel4.add(jButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 60, 170, 20));

        jButton3.setBackground(new java.awt.Color(153, 0, 0));
        jButton3.setFont(new java.awt.Font("Arial", 0, 12));
        jButton3.setForeground(new java.awt.Color(255, 255, 255));
        jButton3.setText("Delete bounding boxes");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanel4.add(jButton3, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 30, 170, 20));

        show.setFont(new java.awt.Font("Arial", 1, 12));
        show.setText("Display bounding boxes");
        jPanel4.add(show, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 10, 170, 20));

        jPanel3.add(jPanel4);

        add(jPanel3, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        deletebox();
    }//GEN-LAST:event_jButton3ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        if(t1.getRowCount()<=0)
            return;
        
        javax.swing.JFileChooser chooser = new javax.swing.JFileChooser("Biometry report");
        int returnVal = chooser.showSaveDialog(this);
        if (returnVal == javax.swing.JFileChooser.APPROVE_OPTION) {
            java.io.File fileselected = chooser.getSelectedFile();
            if ( fileselected != null ){
                
                
                try {
                    java.io.BufferedWriter out = new java.io.BufferedWriter(new java.io.FileWriter(fileselected));
                    
                    out.write("#Cell / Sphericity / Elongation / Flatness / squareness / entropy / Surf/Vol / Convexity / v/V / \n");
                    out.write("#devstage="+VirtualEmbryo.devstage+"\n");
                    
                    
                    for(int a=0; a<t1.getRowCount();++a){
                        out.write( t1.getValueAt(a, 0)+"\t"+t1.getValueAt(a, 1)+"\t"+t1.getValueAt(a, 2)+"\t"+t1.getValueAt(a, 3)+"\t"+t1.getValueAt(a, 4)+"\t"+t1.getValueAt(a, 5)+"\t"+t1.getValueAt(a, 6)+"\t"+t1.getValueAt(a,7)+"\t"+t1.getValueAt(a,8)+"\n" );
                    }
                    
                    out.close();
                } catch (Exception e) {;}
                
            }
        }
    }//GEN-LAST:event_jButton2ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        deletebox();
        while(t1.getRowCount()>0)
            t1.removeRow(0);
        
        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while (ite.hasNext()){
            Object obj3d = ite.next();
            cell node = (cell) objs.get(obj3d);
            if(node.isSelected()){
                float[] res=node.getShapeFactors(show.isSelected());/*, tolerance);*/
                t1.addRow(new Object[]{node.getName(), new java.lang.Float((float)res[5]), new java.lang.Float((float)res[2]), new java.lang.Float((float)res[3]), new java.lang.Float((float)res[0]), new java.lang.Float((float)res[6]), new java.lang.Float((float)res[7]), new java.lang.Float((float)res[8]), new java.lang.Float((float)res[9])});
            
            }
        }
        
    }//GEN-LAST:event_jButton1ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
//Delete the bounding boxes
    public void deletebox(){
        try{
            embryo.extra.removeAllChildren();
        }catch(Exception e){;}
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void destroy(){
        try{
            Set keys = objs.keySet();
            Iterator ite = keys.iterator();
            while (ite.hasNext()){
                Object obj3d = ite.next();
                objs.remove(obj3d);
            }
            this.removeAll();
        }catch(Exception e){;}
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable TableSphericity;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JCheckBox show;
    // End of variables declaration//GEN-END:variables
    
}
