package fr.cnrs.aniseed;

import java.lang.reflect.Method;
import javax.swing.JOptionPane;

/**
 * @author http://www.codestumps.com/2009/04/launch-an-internet-browser-from-java/
 */
public class BrowserLauncher {

   private static final String errMsg = "Failed to launch browser";

   public static void openURL(String url) {
       String osName = System.getProperty("os.name");
       try {
           if (osName.startsWith("Mac OS")) {
               Class fileMgr = Class.forName("com.apple.eio.FileManager");
               Method openURL = fileMgr.getDeclaredMethod("openURL",
                       new Class[]{String.class});
               openURL.invoke(null, new Object[]{url});
           } else if (osName.startsWith("Windows")) {
               Runtime.getRuntime().exec("rundll32 url.dll,FileProtocolHandler " + url);
           } else { //assume Unix or Linux
               String[] browsers = {
                   "firefox", "opera", "konqueror", "epiphany", "mozilla", "netscape"};
               String browser = null;
               for (int count = 0; count < browsers.length && browser == null; count++) {
                   if (Runtime.getRuntime().exec(
                           new String[]{"which", browsers[count]}).waitFor() == 0) {
                       browser = browsers[count];
                   }
               }
               if (browser == null) {
                   throw new Exception("Could not find a web browser");
               } else {
                   Runtime.getRuntime().exec(new String[]{browser, url});
               }
           }
       } catch (Exception e) {
           JOptionPane.showMessageDialog(null, errMsg + ":\n" + e.getLocalizedMessage());
       }
   }
}