package fr.cnrs.aniseed;

import java.sql.*;
import javax.swing.*;
import java.util.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, 7 juillet 2004, 17:57
 */

public class Fate extends javax.swing.JPanel {
    Connection con=null;
    private GTableModel t1;
    private Hashtable objs;
    
////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor    
    public Fate(Hashtable objs) {
        initComponents();
        this.objs=objs;
        
        t1=new GTableModel();
        t1.addColumn("Fate");
        t1.addColumn("Color");
        t1.addMouseListenerToHeaderInTable(TableFate);
        TableFate.setModel(t1);
        TableFate.getTableHeader().setReorderingAllowed(false);
        
        javax.swing.table.TableColumnModel colmod = TableFate.getColumnModel();

        colmod.getColumn(1).setMinWidth(40);
        colmod.getColumn(1).setMaxWidth(40);
        colmod.getColumn(1).setPreferredWidth(40);
        
        
        TableFate.getColumn("Color").setCellRenderer( new CustomButtonRenderer() );
        
        try{
            DriverManager.registerDriver(new org.postgresql.Driver());
            String db = VirtualEmbryo.database;
            String userID = VirtualEmbryo.DBlog;
            String pass = VirtualEmbryo.DBpass;
            
            con = DriverManager.getConnection(db, userID, pass);
            Statement s;
            ResultSet result=null;
            
            s=con.createStatement();
            
            String query=new String();
            query += "Select \"KEYWORDS\" from \"FATE_KW\"";
            result=s.executeQuery(query);
            
            
            while(result.next()){
                String kw = new String();
                kw=result.getString(1);
                
                t1.addRow( new Object[]{kw, new CustomButtonRenderer()} );
                
            }
            s.close();
        
        }catch(SQLException e){
            ;
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
////////////////////////////////////////////////////////////////////////////////////////////////////    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        TableFate = new javax.swing.JTable();

        setBackground(new java.awt.Color(255, 255, 255));
        setLayout(new java.awt.BorderLayout());

        jScrollPane1.setBackground(new java.awt.Color(255, 255, 255));
        jScrollPane1.setFont(new java.awt.Font("Arial", 0, 12));
        jScrollPane1.setMaximumSize(null);
        jScrollPane1.setMinimumSize(null);

        TableFate.setFont(new java.awt.Font("Arial", 0, 12));
        TableFate.setMaximumSize(null);
        TableFate.setMinimumSize(null);
        TableFate.setPreferredScrollableViewportSize(null);
        TableFate.setPreferredSize(null);
        TableFate.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                mouseclic(evt);
            }
        });
        jScrollPane1.setViewportView(TableFate);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void mouseclic(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mouseclic
        if( evt.getClickCount()==2 ){
            if(TableFate.getSelectedColumn()==1){
                java.awt.Color bgColor = JColorChooser.showDialog(this,"Choose object Color",new java.awt.Color(153,0,0));
                if (bgColor != null){
                    JButton bout = (JButton) TableFate.getValueAt(TableFate.getSelectedRow(),1);
                    bout.setBackground(bgColor);
                }
            }
            else{
                StainCell();
            }
        }
    }//GEN-LAST:event_mouseclic
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void StainCell(){
        if(TableFate.getRowCount()<=0)
            return;
            
        String id = TableFate.getValueAt(TableFate.getSelectedRow(), 0).toString();
        java.awt.Color coul = ((JButton) TableFate.getValueAt(TableFate.getSelectedRow(),1)).getBackground();
        
        try{
            DriverManager.registerDriver(new org.postgresql.Driver());
            String url = VirtualEmbryo.database;
            String userID = VirtualEmbryo.DBlog;
            String pass = VirtualEmbryo.DBpass;
            
            con = DriverManager.getConnection(url, userID, pass);
            Statement s;
            ResultSet result=null;
            
            s=con.createStatement();
            
            String query=new String();
            query = "Select \"ANAT_ID\" from \"FATE\" where \"KEYWORDS\"='"+id+"' and \"ANAT_ID\" in (select \"ANAT_ID\" from \"ANAT_ENTITY\" where \"DEV_STAGE_ID\"="+VirtualEmbryo.devstage+")";
            result=s.executeQuery(query);
            
            while(result.next()){
                String anatid = result.getString(1);
                s=con.createStatement();
                query = "SELECT \"NAME\" FROM \"ANAT_ENTITY\" WHERE \"ANAT_ID\"="+anatid;
                ResultSet result2=s.executeQuery(query);
                while(result2.next()){
                    try{
                        String name = result2.getString(1);
                        cell shape=(cell) objs.get(name);
                        shape.setSelected(true, coul, shape.isSelected());
                    }catch(NullPointerException e ){;}
                }
                
            }

        }catch(SQLException e){
            JOptionPane diag2=new JOptionPane();
            diag2.showMessageDialog(new JWindow(),"Error: "+ e.getMessage());
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
////////////////////////////////////////////////////////////////////////////////////////////////////
    class CustomButtonRenderer extends JButton implements javax.swing.table.TableCellRenderer {
////////////////////////////////////////////////////////////////////////////////////////////////////
        public CustomButtonRenderer() {
            setOpaque(true);
            this.setBackground( new java.awt.Color(153,0,0) );
        }
////////////////////////////////////////////////////////////////////////////////////////////////////        
        public java.awt.Component getTableCellRendererComponent(
        JTable Table, Object value,
        boolean isSelected,
        boolean hasFocus, int row,
        int column) {
            return (JButton)value;
        }
////////////////////////////////////////////////////////////////////////////////////////////////////
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void destroy(){
        try{
            Set keys = objs.keySet();
            Iterator ite = keys.iterator();
            while (ite.hasNext()){
                Object obj3d = ite.next();
                objs.remove(obj3d);
            }
        this.removeAll();
        }catch(Exception e){;}
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable TableFate;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
