package fr.cnrs.aniseed;

import java.util.*;
import java.sql.*;
import javax.swing.*;
import java.util.regex.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, Created on 18 juillet 2003, 15:08
 */

public class Query extends javax.swing.JPanel {

    Connection con=null;
   private GTableModel t1;
    private GTableModel t2;
    java.util.Hashtable objs;
    String recResult="";
    String recResult2="";


////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor
    public Query(java.util.Hashtable objs) {
        initComponents();

        this.objs=objs;

        t2=new GTableModel();
        t2.addColumn("Expression excluded from");
        t2.addMouseListenerToHeaderInTable(Table1);
        Table1.setModel(t2);
        Table1.getTableHeader().setReorderingAllowed(false);

        t2.addRow(new Object[]{""});

        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while (ite.hasNext()){
            Object obj = ite.next();
            cell node=(cell) objs.get( obj.toString() );

            t2.addRow( new Object[]{obj.toString()} );
        }

        t1=new GTableModel();
        t1.addColumn("In situ");
        t1.addColumn("Probe");
        t1.addColumn("Embryo type");
        t1.addColumn("Author");
        t1.addColumn("Color");
        t1.addColumn("Comment");
        t1.addMouseListenerToHeaderInTable(Table);

        Table.setModel(t1);
        Table.getTableHeader().setReorderingAllowed(false);



        //Hide ID
        javax.swing.table.TableColumnModel colmod = Table.getColumnModel();
        colmod.getColumn(0).setMinWidth(0);
        colmod.getColumn(0).setMaxWidth(0);
        colmod.getColumn(0).setPreferredWidth(0);

        colmod.getColumn(3).setMinWidth(0);
        colmod.getColumn(3).setMaxWidth(0);
        colmod.getColumn(3).setPreferredWidth(0);

        colmod.getColumn(4).setMinWidth(40);
        colmod.getColumn(4).setMaxWidth(40);
        colmod.getColumn(4).setPreferredWidth(40);

        colmod.getColumn(5).setMinWidth(0);
        colmod.getColumn(5).setMaxWidth(0);
        colmod.getColumn(5).setPreferredWidth(0);

        Table.getColumn("Color").setCellRenderer( new CustomButtonRenderer() );

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
////////////////////////////////////////////////////////////////////////////////////////////////////
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        buttonGroup2 = new javax.swing.ButtonGroup();
        buttonGroup3 = new javax.swing.ButtonGroup();
        buttonGroup4 = new javax.swing.ButtonGroup();
        javax.swing.JPanel jPanel1 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel2 = new javax.swing.JPanel();
        javax.swing.JButton jButton11 = new javax.swing.JButton();
        javax.swing.JLabel jLabel5 = new javax.swing.JLabel();
        mand = new javax.swing.JRadioButton();
        mor = new javax.swing.JRadioButton();
        or = new javax.swing.JRadioButton();
        and = new javax.swing.JRadioButton();
        javax.swing.JLabel jLabel1 = new javax.swing.JLabel();
        ishid = new javax.swing.JTextField();
        javax.swing.JLabel jLabel4 = new javax.swing.JLabel();
        mutant = new javax.swing.JTextField();
        gene = new javax.swing.JRadioButton();
        clone = new javax.swing.JRadioButton();
        javax.swing.JLabel jLabel3 = new javax.swing.JLabel();
        molecule = new javax.swing.JTextField();
        mnone = new javax.swing.JRadioButton();
        javax.swing.JLabel jLabel2 = new javax.swing.JLabel();
        ninclude = new javax.swing.JRadioButton();
        nany = new javax.swing.JRadioButton();
        nnone = new javax.swing.JRadioButton();
        many = new javax.swing.JRadioButton();
        jLabel6 = new javax.swing.JLabel();
        jButton2 = new javax.swing.JButton();
        jCheckBox1 = new javax.swing.JCheckBox();
        jCheckBox2 = new javax.swing.JCheckBox();
        jButton21 = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        Table1 = new javax.swing.JTable();
        author = new javax.swing.JTextField();
        javax.swing.JScrollPane jScrollPane1 = new javax.swing.JScrollPane();
        Table = new javax.swing.JTable();
        javax.swing.JPanel jPanel21 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel3 = new javax.swing.JPanel();
        javax.swing.JButton jButton1 = new javax.swing.JButton();
        javax.swing.JButton jButton141 = new javax.swing.JButton();
        javax.swing.JButton jButton131 = new javax.swing.JButton();

        setFont(new java.awt.Font("Arial", 0, 12));
        setLayout(new java.awt.BorderLayout());

        jPanel2.setMinimumSize(new java.awt.Dimension(200, 560));
        jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jButton11.setBackground(new java.awt.Color(153, 0, 0));
        jButton11.setFont(new java.awt.Font("Arial", 1, 12));
        jButton11.setForeground(new java.awt.Color(255, 255, 255));
        jButton11.setText("Find expression patterns");
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton11, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 385, 200, 25));

        jLabel5.setFont(new java.awt.Font("Arial", 0, 10));
        jLabel5.setForeground(new java.awt.Color(102, 102, 102));
        jLabel5.setText("Separate multiple entries with ':'");
        jPanel2.add(jLabel5, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 0, 180, 20));

        buttonGroup3.add(mand);
        mand.setFont(new java.awt.Font("Arial", 1, 9));
        mand.setText("(include)  and");
        mand.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        mand.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(mand, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 160, 90, -1));

        buttonGroup3.add(mor);
        mor.setFont(new java.awt.Font("Arial", 1, 9));
        mor.setText("or");
        mor.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        mor.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(mor, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 160, 80, -1));

        buttonGroup2.add(or);
        or.setFont(new java.awt.Font("Arial", 1, 9));
        or.setSelected(true);
        or.setText("or");
        or.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        or.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(or, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 60, 80, 20));

        buttonGroup2.add(and);
        and.setFont(new java.awt.Font("Arial", 1, 9));
        and.setText("and");
        and.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        and.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(and, new org.netbeans.lib.awtextra.AbsoluteConstraints(90, 60, 80, 20));

        jLabel1.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel1.setText("Annotators");
        jPanel2.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 310, 100, 15));

        ishid.setFont(new java.awt.Font("Arial", 1, 12));
        jPanel2.add(ishid, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 325, 100, 20));

        jLabel4.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel4.setText("Deregulated molecule");
        jPanel2.add(jLabel4, new org.netbeans.lib.awtextra.AbsoluteConstraints(40, 125, 160, -1));

        mutant.setFont(new java.awt.Font("Arial", 1, 12));
        jPanel2.add(mutant, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 140, 130, -1));

        buttonGroup1.add(gene);
        gene.setFont(new java.awt.Font("Arial", 1, 9));
        gene.setText("gene (eg. ci0100133709)");
        gene.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        gene.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(gene, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 80, 200, 20));

        buttonGroup1.add(clone);
        clone.setFont(new java.awt.Font("Arial", 1, 9));
        clone.setSelected(true);
        clone.setText("clone & construction (eg. cicl045e03)");
        clone.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        clone.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(clone, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 100, 200, 20));

        jLabel3.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel3.setText("Stained molecule");
        jPanel2.add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 25, 150, -1));

        molecule.setFont(new java.awt.Font("Arial", 1, 12));
        jPanel2.add(molecule, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 40, 130, -1));

        buttonGroup3.add(mnone);
        mnone.setFont(new java.awt.Font("Arial", 1, 9));
        mnone.setSelected(true);
        mnone.setText("none");
        mnone.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        mnone.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(mnone, new org.netbeans.lib.awtextra.AbsoluteConstraints(80, 180, 90, -1));

        jLabel2.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel2.setText("Embryo manipulation");
        jPanel2.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(40, 205, 160, -1));

        buttonGroup4.add(ninclude);
        ninclude.setFont(new java.awt.Font("Arial", 1, 9));
        ninclude.setText("include");
        ninclude.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        ninclude.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(ninclude, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 220, -1, -1));

        buttonGroup4.add(nany);
        nany.setFont(new java.awt.Font("Arial", 1, 9));
        nany.setText("only");
        nany.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        nany.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(nany, new org.netbeans.lib.awtextra.AbsoluteConstraints(60, 220, 60, -1));

        buttonGroup4.add(nnone);
        nnone.setFont(new java.awt.Font("Arial", 1, 9));
        nnone.setSelected(true);
        nnone.setText("none");
        nnone.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        nnone.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(nnone, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 220, 70, -1));

        buttonGroup3.add(many);
        many.setFont(new java.awt.Font("Arial", 1, 9));
        many.setText("only");
        many.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        many.setHorizontalTextPosition(javax.swing.SwingConstants.LEADING);
        jPanel2.add(many, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 180, 80, -1));

        jLabel6.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel6.setText("In situ ID");
        jPanel2.add(jLabel6, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 310, 100, 15));

        jButton2.setBackground(new java.awt.Color(153, 0, 0));
        jButton2.setFont(new java.awt.Font("Arial", 1, 9));
        jButton2.setForeground(new java.awt.Color(255, 255, 255));
        jButton2.setText("Search");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(130, 140, 70, 20));

        jCheckBox1.setFont(new java.awt.Font("Arial", 1, 9));
        jCheckBox1.setText("Include ubiquitously expressed genes");
        jPanel2.add(jCheckBox1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 345, 205, 20));

        jCheckBox2.setFont(new java.awt.Font("Arial", 1, 9));
        jCheckBox2.setText("Include tested but not expressed genes");
        jPanel2.add(jCheckBox2, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 365, 205, 20));

        jButton21.setBackground(new java.awt.Color(153, 0, 0));
        jButton21.setFont(new java.awt.Font("Arial", 1, 9));
        jButton21.setForeground(new java.awt.Color(255, 255, 255));
        jButton21.setText("Search");
        jButton21.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton21ActionPerformed(evt);
            }
        });
        jPanel2.add(jButton21, new org.netbeans.lib.awtextra.AbsoluteConstraints(130, 40, 70, 20));

        Table1.setFont(new java.awt.Font("Arial", 0, 10));
        Table1.setShowVerticalLines(false);
        jScrollPane2.setViewportView(Table1);

        jPanel2.add(jScrollPane2, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 245, 200, 65));

        author.setFont(new java.awt.Font("Arial", 1, 12));
        jPanel2.add(author, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 325, 100, 20));

        jPanel1.add(jPanel2);

        add(jPanel1, java.awt.BorderLayout.NORTH);

        jScrollPane1.setFont(new java.awt.Font("Arial", 0, 12));
        jScrollPane1.setMinimumSize(null);

        Table.setFont(new java.awt.Font("Arial", 0, 12));
        Table.setPreferredScrollableViewportSize(null);
        Table.setPreferredSize(null);
        Table.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mousePressed(java.awt.event.MouseEvent evt) {
                mouseClic(evt);
            }
        });
        Table.addMouseMotionListener(new java.awt.event.MouseMotionAdapter() {
            public void mouseMoved(java.awt.event.MouseEvent evt) {
                mouseMove(evt);
            }
        });
        jScrollPane1.setViewportView(Table);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);

        jPanel21.setMinimumSize(new java.awt.Dimension(200, 560));

        jPanel3.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jButton1.setBackground(new java.awt.Color(153, 0, 0));
        jButton1.setFont(new java.awt.Font("Arial", 1, 12));
        jButton1.setForeground(new java.awt.Color(255, 255, 255));
        jButton1.setText("RESET");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel3.add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 40, 200, 20));

        jButton141.setBackground(new java.awt.Color(153, 0, 0));
        jButton141.setFont(new java.awt.Font("Arial", 1, 12));
        jButton141.setForeground(new java.awt.Color(255, 255, 255));
        jButton141.setText("Get full description");
        jButton141.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton141ActionPerformed(evt);
            }
        });
        jPanel3.add(jButton141, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 20, 200, 20));

        jButton131.setBackground(new java.awt.Color(153, 0, 0));
        jButton131.setFont(new java.awt.Font("Arial", 1, 11));
        jButton131.setForeground(new java.awt.Color(255, 255, 255));
        jButton131.setText("Expression in 3D");
        jButton131.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton131ActionPerformed(evt);
            }
        });
        jPanel3.add(jButton131, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 200, 20));

        jPanel21.add(jPanel3);

        add(jPanel21, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton131ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton131ActionPerformed
        StainCell();
    }//GEN-LAST:event_jButton131ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton141ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton141ActionPerformed
        try{
            if( Table.getSelectedRow() >= 0 )
                BrowserLauncher.openURL( VirtualEmbryo.url+"insitu.php?id="+Table.getValueAt(Table.getSelectedRow(),0) );
        }catch(Exception e){;}
    }//GEN-LAST:event_jButton141ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        while(t1.getRowCount()>0)
            t1.removeRow(0);
    }//GEN-LAST:event_jButton1ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton21ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton21ActionPerformed
        try{
            BrowserLauncher.openURL( VirtualEmbryo.url+"molecule-search.php" );
        }catch(Exception e){;}
    }//GEN-LAST:event_jButton21ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        try{
            BrowserLauncher.openURL( VirtualEmbryo.url+"molecule-search.php" );
        }catch(Exception e){;}
    }//GEN-LAST:event_jButton2ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void mouseMove(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mouseMove

        String tooltip = "<html><center>"+(String) Table.getValueAt( Table.rowAtPoint( new java.awt.Point(evt.getX(),evt.getY()) ),5);
        tooltip += "<br>Author: "+(String) Table.getValueAt( Table.rowAtPoint( new java.awt.Point(evt.getX(),evt.getY()) ),3)+"<center></html>";
        Table.setToolTipText(tooltip);

    }//GEN-LAST:event_mouseMove
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void mouseClic(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_mouseClic
        if( evt.getClickCount()==2 ){
            if(Table.getSelectedColumn()==4){
                java.awt.Color bgColor = JColorChooser.showDialog(this,"Choose object Color",new java.awt.Color(153,0,0));
                if (bgColor != null){
                    JButton bout = (JButton) Table.getValueAt(Table.getSelectedRow(),4);
                    bout.setBackground(bgColor);
                }
            }
            else{
                StainCell();
            }
        }
    }//GEN-LAST:event_mouseClic
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed
        query();
    }//GEN-LAST:event_jButton11ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void query(){

        try{
            DriverManager.registerDriver(new org.postgresql.Driver());
            String db = VirtualEmbryo.database;
            String userID = VirtualEmbryo.DBlog;
            String pass = VirtualEmbryo.DBpass;

            con = DriverManager.getConnection(db, userID, pass);
            Statement s;
            ResultSet result=null;

            s=con.createStatement();


            String query=new String();

            query += "Select \"IN_SITU_ID\" from \"IN_SITU\" where (\"DEV_STAGE_ID\"="+ VirtualEmbryo.devstage ;

            query += ") ";

            query += " and \"CHECKED\"='y' and \"PRIVATE\"='n'";

//SEARCH FOR TARGET MOL
            if( molecule.getText().length() >0){

                String[] targetTMP;
                    targetTMP=molecule.getText().toUpperCase().split(":");

                if(targetTMP.length>100){
                    JOptionPane diag2=new JOptionPane();
                    diag2.showMessageDialog(new JWindow(),"Error: due to performance reasons, you cannot search for more than 100 items");
                    return;
                }

                if(and.isSelected()){
                    if(gene.isSelected()){//if gene ... -> Recover corresponding clones

                        for (int a=0; a < targetTMP.length; ++a){
                           query +=" INTERSECT SELECT \"IN_SITU_ID\" FROM \"TARGET\" WHERE \"TARGET_ID\" IN ( "
                                   +"select B.\"CLONE_ID\" from \"CLONE_SEQ\" A, \"CLONE\" B where A.\"CLONE_NAME\"=B.\"CLONE_NAME\" and A.\"ANISEED_CLUSTER_ID\"=(select \"GENE_ID\" from \"GENE\" where upper(\"NAME\")='"+targetTMP[a]+"') "
                                   +"UNION select \"CLONE_SEQ_ID\" from \"CLONE_SEQ\" where \"ANISEED_CLUSTER_ID\"=(select \"GENE_ID\" from \"GENE\" where upper(\"NAME\")='"+targetTMP[a]+"') "
                                   +"UNION select \"GENE_ID\" from \"GENE\" where upper(\"NAME\")='"+targetTMP[a]+"')";
                        }

                    }else if(clone.isSelected()){//if clone

                        for (int a=0; a < targetTMP.length; ++a){
                            query += " INTERSECT SELECT \"IN_SITU_ID\" FROM \"TARGET\" WHERE \"TARGET_ID\" IN (SELECT \"MOL_ID\" FROM \"MOL_ENTITY\" WHERE upper(\"NAME\")='"+targetTMP[a]+"' OR upper(FULL_NAME)='"+targetTMP[a]+"')";
                        }

                    }
                }else{

                    if(gene.isSelected()){//if gene -> Recover corresponding clone

                        String name="";
                        for (int a=0; a < targetTMP.length; ++a){
                            if(a==0){

                                name+=" (\"TARGET_ID\" IN ( "
                                        +"select B.\"CLONE_ID\" from \"CLONE_SEQ\" A, \"CLONE\" B where A.\"CLONE_NAME\"=B.\"CLONE_NAME\" and A.\"ANISEED_CLUSTER_ID\"=(select \"GENE_ID\" from \"GENE\" where upper(\"NAME\")='"+targetTMP[a]+"')"
					+" UNION select \"CLONE_SEQ_ID\" from \"CLONE_SEQ\" where \"ANISEED_CLUSTER_ID\"=(select \"GENE_ID\" from \"GENE\" where upper(\"NAME\")='"+targetTMP[a]+"')"
					+" UNION select \"GENE_ID\" from \"GENE\" where upper(\"NAME\")='"+targetTMP[a]+"'";
                            }else{

                                name+= " UNION select B.\"CLONE_ID\" from \"CLONE_SEQ\" A, \"CLONE\" B where A.\"CLONE_NAME\"=B.\"CLONE_NAME\" and A.\"ANISEED_CLUSTER_ID\"=(select \"GENE_ID\" from \"GENE\" where upper(\"NAME\")='"+targetTMP[a]+"')"
                                        +" UNION select \"CLONE_SEQ_ID\" from \"CLONE_SEQ\" where \"ANISEED_CLUSTER_ID\"=(select \"GENE_ID\" from \"GENE\" where upper(\"NAME\")='"+targetTMP[a]+"')"
					+" UNION select \"GENE_ID\" from \"GENE\" where upper(\"NAME\")='"+targetTMP[a]+"'";

                            }
                        }
                        query += " INTERSECT SELECT \"IN_SITU_ID\" FROM \"TARGET\" WHERE "+name+"))";

                    }else if(clone.isSelected()){//if clone

                        String name="";
                        for (int a=0; a < targetTMP.length; ++a){
                            if(a==0)
                                name += " (\"TARGET_ID\" IN (SELECT \"MOL_ID\" FROM \"MOL_ENTITY\" WHERE(upper(\"NAME\")='"+targetTMP[a]+"' OR upper(\"FULL_NAME\")='"+targetTMP[a]+"'))) ";
                            else
                                name += " OR (\"TARGET_ID\" IN (SELECT \"MOL_ID\" FROM \"MOL_ENTITY\" WHERE(upper(\"NAME\")='"+targetTMP[a]+"' OR upper(\"FULL_NAME\")='"+targetTMP[a]+"'))) ";
                        }
                        query +=" INTERSECT SELECT \"IN_SITU_ID\" FROM \"TARGET\" WHERE "+name;

                    }
                }
            }

//SEARCH FOR DEREGULATED ELEMENTS
            if(mutant.getText().length() > 0){

                String[] mutantTMP;

                    mutantTMP=mutant.getText().toUpperCase().split(":");

                if(mutantTMP.length>100){
                    JOptionPane diag2=new JOptionPane();
                    diag2.showMessageDialog(new JWindow(),"Error: due to performance reasons, you cannot search for more than 100 items");
                    return;
                }

                if(mand.isSelected()){
                    for (int a=0; a < mutantTMP.length; ++a){
                        query += " INTERSECT SELECT \"IN_SITU_ID\" FROM \"MUTANT\" WHERE \"BIO_ID\" IN (SELECT \"MOL_ID\" FROM \"MOL_ENTITY\" WHERE upper(\"NAME\")='$mutantTMP[$a]' OR upper(FULL_NAME)='"+mutantTMP[a]+"')";
                    }
                }
                else if(mor.isSelected()){
                    String name=new String();;
                    for (int a=0; a < mutantTMP.length; ++a){
                        if(a==0)
                            name += " (\"BIO_ID\" IN (SELECT \"MOL_ID\" FROM \"MOL_ENTITY\" WHERE(upper(\"NAME\")='"+mutantTMP[a]+"' OR upper(\"FULL_NAME\")='"+mutantTMP[a]+"'))) ";
                        else
                            name += " OR (\"BIO_ID\" IN (SELECT \"MOL_ID\" FROM \"MOL_ENTITY\" WHERE(upper(\"NAME\")='"+mutantTMP[a]+"' OR upper(\"FULL_NAME\")='"+mutantTMP[a]+"'))) ";
                    }
                    query += " INTERSECT SELECT \"IN_SITU_ID\" FROM \"MUTANT\" WHERE "+name;
                }
            }
            if(mnone.isSelected()){
                query += " EXCEPT SELECT \"IN_SITU_ID\" FROM \"MUTANT\" ";

            }else if(many.isSelected()){
                query += " INTERSECT SELECT \"IN_SITU_ID\" FROM \"MUTANT\"";
            }

//SEARCH FOR EMBRYO MANIPULATIONS
            if(nnone.isSelected()){
                query += " EXCEPT SELECT \"IN_SITU_ID\" FROM \"EMBRYO_MANIP\" ";

            }else if(nany.isSelected()){
                query += " INTERSECT SELECT \"IN_SITU_ID\" FROM \"EMBRYO_MANIP\" ";
            }

//SEARCH FOR AUTHOR
            if(author.getText().length()>0){
                String annot="'"+author.getText()+"'";
                Pattern p = Pattern.compile(":"); //(" ")
                Matcher m = p.matcher(annot);
                annot=m.replaceAll("','");
                annot=annot.toUpperCase();

                query += " intersect (Select a.\"IN_SITU_ID\" from \"IN_SITU\" a, \"ENTRY_ORIGIN\" b, \"AUTHOR\" c where (a.\"IN_SITU_ID\"=b.\"BIO_ID\") and (b.\"AUTHOR_ID\"=c.\"AUTHOR_ID\") and (upper(c.\"NAME\") in ("+annot+"))) ";
            }

//SEARCH FOR ISH IDs
            if(ishid.getText().length()>0){
                String annot="'"+ishid.getText()+"'";
                Pattern p = Pattern.compile(":"); //(" ")
                Matcher m = p.matcher(annot);
                annot=m.replaceAll("','");

                query += " intersect (Select \"IN_SITU_ID\" from \"IN_SITU\" where (\"IN_SITU_ID\" in ("+annot+"))) ";
            }

//SEARCH FOR UNSTAINED TERRITORIES

            String unst=new String();
            int[] intlist=new int[Table1.getSelectedRowCount()];
            intlist=Table1.getSelectedRows();
            for(int a=0; intlist.length > a; ++a){
                if(a>0)
                    unst +=",";
                unst += "'"+t2.getValueAt(intlist[a],0)+"'" ;
            }
            if(unst.length()>2){



                String[] tmp=unst.split(",");
                recResult2="";
                for (int i=0;i<tmp.length;i++)
                    {
                    recResult="";
                    Statement psmt = null;
                    ResultSet rs = null;
                    psmt=con.createStatement();
                    rs=psmt.executeQuery("SELECT \"ANAT_ID\" FROM \"ANAT_ENTITY\" WHERE \"NAME\"="+tmp[i]+" and \"DEV_STAGE_ID\"='"+VirtualEmbryo.devstage+ "' ");

                    while (rs.next()) //always one result ...
                    {
                    recResult2+=select_recursif2(rs.getString(1));
                    }
                    }

                recResult2=recResult2.substring(0,recResult2.length()-1);

query += " EXCEPT (SELECT \"IN_SITU_ID\" from \"TARGET\" where (\"REGION_ID\" in ("+recResult2+")))";

            }

//SEARCH FOR EXPRESSION
            if(! jCheckBox1.isSelected()){
                query += " EXCEPT (select a.\"IN_SITU_ID\" from \"TARGET\" a, \"ANAT_ENTITY\" b where b.\"ANAT_ID\"=a.\"REGION_ID\" and b.\"NAME\" in ('Whole embryo','Whole egg')) ";
            }
            if(! jCheckBox2.isSelected()){
                query += " EXCEPT (select a.\"IN_SITU_ID\" from \"TARGET\" a, \"ANAT_ENTITY\" b where b.\"ANAT_ID\"=a.\"REGION_ID\" and b.\"NAME\"='No expression') ";
            }
            query = "select distinct X.\"NAME\" as \"AUTHOR\", Y.\"NAME\", Z.\"IN_SITU_ID\", V.\"IM_COMMENTS\", V.\"WILD_TYPE\" FROM \"TARGET\" Z, \"MOL_ENTITY\" Y, \"AUTHOR\" X, \"ENTRY_ORIGIN\" W, \"IN_SITU\" V where (V.\"CHECKED\"='y')and (Z.\"TARGET_ID\"=Y.\"MOL_ID\") and (Z.\"IN_SITU_ID\"=W.\"BIO_ID\") and (W.\"AUTHOR_ID\"=X.\"AUTHOR_ID\")and(Z.\"IN_SITU_ID\"=V.\"IN_SITU_ID\")and(Z.\"IN_SITU_ID\" in ("+query+"))";

            result=s.executeQuery(query);


            while(result.next()){

                String id, name, mutant, author, comment = new String();
                author=result.getString(1);
                name=result.getString(2);
                id=result.getString(3);
                comment=result.getString(4);
                mutant=result.getString(5);

                if (mutant.equals("y"))
                    mutant="WT";
                else if (mutant.equals("n"))
                    mutant="M";

                int a=40; int b=0;
                String comment2=new String();
                while( a <= comment.length()-b ){
                    comment2 += comment.substring(comment2.length()-b,comment.indexOf(" ",a))+"<br>";//+comment.substring(comment.indexOf(" ",a));
                    a += 40;
                    b += 4;
                }
                if(a>40)
                    comment=comment2 + comment.substring(comment2.length()-b)+"<br>";

                t1.addRow( new Object[]{id, name, mutant, author, new CustomButtonRenderer(), comment} );

            }
            s.close();

            con.close();
        }catch(Exception e){

            if( con !=null){
                try{ con.rollback();}
                catch (SQLException ev){;}
            }


            JOptionPane diag2=new JOptionPane();
            diag2.showMessageDialog(new JWindow(),"Error: "+ e.getMessage());
        }
        finally {
            if( con !=null){
                try {con.close();}
                catch (SQLException e) {
                    JOptionPane diag2=new JOptionPane();
                    diag2.showMessageDialog(new JWindow(),"Error: "+ e.getMessage());
                }
            }
        }


    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void StainAllCell(){
;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Hierarchical query
    public void select_recursif1(String start,Hashtable objs,java.awt.Color coul) throws SQLException
    {
    	Statement psmt = null;
        ResultSet rs = null;

        psmt=con.createStatement();
    	rs=psmt.executeQuery("SELECT \"ANAT_ID\",\"NAME\" FROM \"ANAT_ENTITY\" WHERE \"CHILD_OF\"="+start);
    while (rs.next())
    {
    	 try{
            String name = rs.getString(2);
            cell shape=(cell) objs.get(name);
            shape.setSelected(true, coul, shape.isSelected());
        }catch(NullPointerException e ){;}
        select_recursif1(rs.getString(1),objs,coul);
    }

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
// Hierarchical query
    public String select_recursif2(String start) throws SQLException
    {
    	Statement psmt = null;
        ResultSet rs = null;

        psmt=con.createStatement();
        //System.out.println("Start="+start);
        if (start!=null)
        {rs=psmt.executeQuery("SELECT \"ANAT_ID\",\"CHILD_OF\" FROM \"ANAT_ENTITY\" where \"ANAT_ID\"="+start);


    while (rs.next())
    {
    	recResult+=rs.getString(1)+",";
        //System.out.println(">>"+rs.getString(1));
        select_recursif2(rs.getString(2));
    }
        }
        return recResult;

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void StainCell(){
        if(Table.getRowCount()<=0)
            return;

        String id = Table.getValueAt(Table.getSelectedRow(), 0).toString();
        java.awt.Color coul = ((JButton) Table.getValueAt(Table.getSelectedRow(),4)).getBackground();

        try{
            DriverManager.registerDriver(new org.postgresql.Driver());
            String url = VirtualEmbryo.database;
            String userID = VirtualEmbryo.DBlog;
            String pass = VirtualEmbryo.DBpass;

            con = DriverManager.getConnection(url, userID, pass);
            Statement s;
            ResultSet result=null;

            s=con.createStatement();

            String query=new String();
            query = "Select \"REGION_ID\" from \"TARGET\" where \"IN_SITU_ID\"="+id;
            result=s.executeQuery(query);

            while(result.next()){
                while(result.next()){
                    String anatid = result.getString(1);
                    s=con.createStatement();

                    select_recursif1(anatid,objs,coul);

                }
            }
            s.close();


        }catch(SQLException e){
            ;
            }

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////////////////////////
    class CustomButtonRenderer extends JButton implements javax.swing.table.TableCellRenderer {
////////////////////////////////////////////////////////////////////////////////////////////////////
        public CustomButtonRenderer() {
            setOpaque(true);
            this.setBackground( new java.awt.Color(153,0,0) );
        }
////////////////////////////////////////////////////////////////////////////////////////////////////
        public java.awt.Component getTableCellRendererComponent(
        JTable Table, Object value,
        boolean isSelected,
        boolean hasFocus, int row,
        int column) {
            return (JButton)value;
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void destroy(){
        try{
            Set keys = objs.keySet();
            Iterator ite = keys.iterator();
            while (ite.hasNext()){
                Object obj3d = ite.next();
                objs.remove(obj3d);
            }
            //objs.clear();
            this.removeAll();
        }catch(Exception e){;}
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable Table;
    private javax.swing.JTable Table1;
    private javax.swing.JRadioButton and;
    private javax.swing.JTextField author;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.ButtonGroup buttonGroup2;
    private javax.swing.ButtonGroup buttonGroup3;
    private javax.swing.ButtonGroup buttonGroup4;
    private javax.swing.JRadioButton clone;
    private javax.swing.JRadioButton gene;
    private javax.swing.JTextField ishid;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton21;
    private javax.swing.JCheckBox jCheckBox1;
    private javax.swing.JCheckBox jCheckBox2;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JRadioButton mand;
    private javax.swing.JRadioButton many;
    private javax.swing.JRadioButton mnone;
    private javax.swing.JTextField molecule;
    private javax.swing.JRadioButton mor;
    private javax.swing.JTextField mutant;
    private javax.swing.JRadioButton nany;
    private javax.swing.JRadioButton ninclude;
    private javax.swing.JRadioButton nnone;
    private javax.swing.JRadioButton or;
    // End of variables declaration//GEN-END:variables

}
