package fr.cnrs.aniseed;

import java.util.*;
import java.sql.*;
import javax.swing.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, Created on 29 juillet 2003, 15:43
 */

public class QuerySelection extends javax.swing.JPanel {

    Hashtable objs;
    Connection con=null;
    DynamicTree treePanel = new DynamicTree();
    GTableModel t2;
    String recResult="";

////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor
    public QuerySelection(Hashtable objs) {

        treePanel.getTree().getSelectionModel().setSelectionMode(javax.swing.tree.TreeSelectionModel.SINGLE_TREE_SELECTION);

        this.objs=objs;
        initComponents();



        t2=new GTableModel();
        t2.addColumn("Expression excluded from");
        t2.addMouseListenerToHeaderInTable(Table1);
        Table1.setModel(t2);
        Table1.getTableHeader().setReorderingAllowed(false);

        t2.addRow(new Object[]{""});

        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while (ite.hasNext()){
            Object obj = ite.next();
            cell node=(cell) objs.get( obj.toString() );

            t2.addRow( new Object[]{obj.toString()} );
        }

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
////////////////////////////////////////////////////////////////////////////////////////////////////
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        javax.swing.ButtonGroup buttonGroup1 = new javax.swing.ButtonGroup();
        javax.swing.ButtonGroup buttonGroup2 = new javax.swing.ButtonGroup();
        javax.swing.JPanel jPanel2 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel1 = new javax.swing.JPanel();
        byGene = new javax.swing.JRadioButton();
        byCell = new javax.swing.JRadioButton();
        javax.swing.JButton jButton11 = new javax.swing.JButton();
        expression = new javax.swing.JRadioButton();
        jLabel1 = new javax.swing.JLabel();
        noexpression = new javax.swing.JRadioButton();
        jLabel2 = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        Table1 = new javax.swing.JTable();
        scrollPaneQuery = new javax.swing.JScrollPane();
        javax.swing.JPanel jPanel21 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel11 = new javax.swing.JPanel();
        javax.swing.JButton jButton2 = new javax.swing.JButton();
        javax.swing.JButton jButton14 = new javax.swing.JButton();
        javax.swing.JButton jButton3 = new javax.swing.JButton();
        javax.swing.JButton collall = new javax.swing.JButton();
        javax.swing.JButton expall = new javax.swing.JButton();
        javax.swing.JButton expmain = new javax.swing.JButton();
        javax.swing.JButton jButton1 = new javax.swing.JButton();

        setFont(new java.awt.Font("Arial", 0, 12));
        setLayout(new java.awt.BorderLayout());

        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        buttonGroup1.add(byGene);
        byGene.setFont(new java.awt.Font("Arial", 1, 9));
        byGene.setText("by gene");
        jPanel1.add(byGene, new org.netbeans.lib.awtextra.AbsoluteConstraints(120, 130, 80, 20));

        buttonGroup1.add(byCell);
        byCell.setFont(new java.awt.Font("Arial", 1, 9));
        byCell.setSelected(true);
        byCell.setText("by cell");
        jPanel1.add(byCell, new org.netbeans.lib.awtextra.AbsoluteConstraints(50, 130, 70, 20));

        jButton11.setBackground(new java.awt.Color(153, 0, 0));
        jButton11.setFont(new java.awt.Font("Arial", 1, 12));
        jButton11.setForeground(new java.awt.Color(255, 255, 255));
        jButton11.setText("Find expressed genes");
        jButton11.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton11ActionPerformed(evt);
            }
        });
        jPanel1.add(jButton11, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 105, 210, -1));

        buttonGroup2.add(expression);
        expression.setFont(new java.awt.Font("Arial", 1, 9));
        expression.setSelected(true);
        expression.setText("selected");
        jPanel1.add(expression, new org.netbeans.lib.awtextra.AbsoluteConstraints(55, 0, 70, 20));

        jLabel1.setFont(new java.awt.Font("Dialog", 1, 9));
        jLabel1.setText(" Display: ");
        jPanel1.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 130, -1, 20));

        buttonGroup2.add(noexpression);
        noexpression.setFont(new java.awt.Font("Arial", 1, 9));
        noexpression.setText("not selected");
        jPanel1.add(noexpression, new org.netbeans.lib.awtextra.AbsoluteConstraints(125, 0, -1, 20));

        jLabel2.setFont(new java.awt.Font("Dialog", 1, 9));
        jLabel2.setText("proceed:");
        jPanel1.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(5, 0, 50, 20));

        Table1.setFont(new java.awt.Font("Arial", 0, 10));
        Table1.setShowVerticalLines(false);
        jScrollPane2.setViewportView(Table1);

        jPanel1.add(jScrollPane2, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 20, 210, 85));

        jPanel2.add(jPanel1);

        add(jPanel2, java.awt.BorderLayout.NORTH);

        scrollPaneQuery.setFont(new java.awt.Font("Arial", 0, 12));
        scrollPaneQuery.setMinimumSize(null);
        scrollPaneQuery.setPreferredSize(null);
        add(scrollPaneQuery, java.awt.BorderLayout.CENTER);

        jPanel11.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jButton2.setBackground(new java.awt.Color(153, 0, 0));
        jButton2.setFont(new java.awt.Font("Arial", 1, 12));
        jButton2.setForeground(new java.awt.Color(255, 255, 255));
        jButton2.setText("Expression in 3D");
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton2ActionPerformed(evt);
            }
        });
        jPanel11.add(jButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(5, 0, 210, 20));

        jButton14.setBackground(new java.awt.Color(153, 0, 0));
        jButton14.setFont(new java.awt.Font("Arial", 1, 12));
        jButton14.setForeground(new java.awt.Color(255, 255, 255));
        jButton14.setText("Description");
        jButton14.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton14ActionPerformed(evt);
            }
        });
        jPanel11.add(jButton14, new org.netbeans.lib.awtextra.AbsoluteConstraints(5, 20, 110, 20));

        jButton3.setBackground(new java.awt.Color(153, 0, 0));
        jButton3.setFont(new java.awt.Font("Arial", 1, 12));
        jButton3.setForeground(new java.awt.Color(255, 255, 255));
        jButton3.setText("Color");
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });
        jPanel11.add(jButton3, new org.netbeans.lib.awtextra.AbsoluteConstraints(115, 20, 100, 20));

        collall.setBackground(new java.awt.Color(153, 0, 0));
        collall.setFont(new java.awt.Font("Arial", 1, 9));
        collall.setForeground(new java.awt.Color(255, 255, 255));
        collall.setText("Collapse tree");
        collall.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                collallActionPerformed(evt);
            }
        });
        jPanel11.add(collall, new org.netbeans.lib.awtextra.AbsoluteConstraints(115, 40, 100, 20));

        expall.setBackground(new java.awt.Color(153, 0, 0));
        expall.setFont(new java.awt.Font("Arial", 1, 9));
        expall.setForeground(new java.awt.Color(255, 255, 255));
        expall.setText("Expand tree");
        expall.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                expallActionPerformed(evt);
            }
        });
        jPanel11.add(expall, new org.netbeans.lib.awtextra.AbsoluteConstraints(5, 40, 110, 20));

        expmain.setBackground(new java.awt.Color(153, 0, 0));
        expmain.setFont(new java.awt.Font("Arial", 1, 9));
        expmain.setForeground(new java.awt.Color(255, 255, 255));
        expmain.setText("Expand main");
        expmain.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                expmainActionPerformed(evt);
            }
        });
        jPanel11.add(expmain, new org.netbeans.lib.awtextra.AbsoluteConstraints(5, 60, 110, 20));

        jButton1.setBackground(new java.awt.Color(153, 0, 0));
        jButton1.setFont(new java.awt.Font("Arial", 1, 12));
        jButton1.setForeground(new java.awt.Color(255, 255, 255));
        jButton1.setText("RESET");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        jPanel11.add(jButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(115, 60, 100, 20));

        jPanel21.add(jPanel11);

        add(jPanel21, java.awt.BorderLayout.SOUTH);
    }// </editor-fold>//GEN-END:initComponents
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed

        if(treePanel.getSelected().getTitle().equals("is")){
            java.awt.Color bgColor = JColorChooser.showDialog(this,"Choose object Color",new java.awt.Color(153,0,0));
            if (bgColor != null){
                treePanel.getSelected().setColor(bgColor);
            }
        }

    }//GEN-LAST:event_jButton3ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton2ActionPerformed
        StainCell();
    }//GEN-LAST:event_jButton2ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void expmainActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_expmainActionPerformed
        if(byCell.isSelected())
            treePanel.expandMainObject("cell");
        if(byGene.isSelected())
            treePanel.expandMainObject("gene");
    }//GEN-LAST:event_expmainActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void collallActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_collallActionPerformed
        treePanel.collapseAllObject();
    }//GEN-LAST:event_collallActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void expallActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_expallActionPerformed
        treePanel.expandAllObject();
    }//GEN-LAST:event_expallActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton14ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton14ActionPerformed
        try{
            treePanel.launchBrowser();
        }catch(NullPointerException e){;}
    }//GEN-LAST:event_jButton14ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        scrollPaneQuery.setViewportView(null);
    }//GEN-LAST:event_jButton1ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jButton11ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton11ActionPerformed

        try{

            treePanel = new DynamicTree();

            DriverManager.registerDriver(new org.postgresql.Driver());
            String url = VirtualEmbryo.database;
            String userID = VirtualEmbryo.DBlog;
            String pass= VirtualEmbryo.DBpass;
            con = DriverManager.getConnection(url, userID, pass);
            con.setAutoCommit(false);


            Set keys = objs.keySet();
            Iterator ite = keys.iterator();

            boolean selection=expression.isSelected();//search on selected cells or not selected cells

            java.util.Hashtable hash=new java.util.Hashtable();
            while (ite.hasNext()){


                Object obj3d = ite.next();
                cell node = (cell) objs.get(obj3d);
                anatomyPart anat=node.getTreeRef();

                if(anat.isSelected()==selection){

                    if(byCell.isSelected()){
                        //Selected cell's name
                        anatomyPart p = treePanel.addObject( treePanel.getrootNode(), anat.getName(), anat.getTitle(), anat.getID(), null);
                        p.setColor(new java.awt.Color(255,255,255));


                        hash=new java.util.Hashtable();
                        anatomyPart actualCell=p;

                        //Expression data query
                        Statement pstmt = con.createStatement();

                        recResult=select_recursif2(anat.getID());
                        recResult=recResult.substring(0,recResult.length()-1);

                        String query="select distinct A.\"IN_SITU_ID\", A.\"TARGET_ID\" from \"TARGET\" A where A.\"IN_SITU_ID\" in(select B.\"IN_SITU_ID\" from \"IN_SITU\" B where B.\"IN_SITU_ID\" in (select \"IN_SITU_ID\" from \"TARGET\" where \"REGION_ID\" in ("+recResult+")) and B.\"CHECKED\"='y' and B.\"PRIVATE\"='n')";

                        recResult="";
                        ResultSet rs=pstmt.executeQuery(query);

                        while(rs.next()){//in situ & target id


                            Statement pstmt2 = con.createStatement();
                            query="SELECT \"NAME\", \"TYPE\" FROM \"MOL_ENTITY\" WHERE \"MOL_ID\" = "+rs.getString(2);
                            ResultSet rs2=pstmt2.executeQuery(query);
                            while(rs2.next()){//clone name//cdna

                                if(rs2.getString(2).equals("clone_sequence")){
                                    Statement pstmt22 = con.createStatement();
                                    query="select \"ANISEED_CLUSTER_ID\" from \"CLONE_SEQ\" where \"CLONE_SEQ_ID\"="+rs.getString(2);
                                    ResultSet rs22=pstmt22.executeQuery(query);
                                    if(rs22.next()){
                                        int clustid=rs22.getInt(1);
                                        query="SELECT a.\"NAME\", a.\"GENE_ID\" FROM \"GENE\" a WHERE a.\"GENE_ID\"="+clustid;
                                    }else{
                                        query="";
                                    }
                                    pstmt22.close();
                                }else{

                                    Statement pstmt22 = con.createStatement();

                                    query="SELECT distinct b.\"ANISEED_CLUSTER_ID\" FROM \"CLONE_SEQ\" b, \"CLONE\" c WHERE b.\"CLONE_NAME\"=c.\"CLONE_NAME\" and c.\"CLONE_ID\"="+rs.getString(2);
                                    ResultSet rs22=pstmt22.executeQuery(query);
                                    if(rs22.next()){
                                        int clustid=rs22.getInt(1);
                                        query="SELECT a.\"NAME\", a.\"GENE_ID\" FROM \"GENE\" a WHERE a.\"GENE_ID\"="+clustid;
                                    }else{
                                        query="";
                                    }
                                    pstmt22.close();

                                }
                                String geneid=new String();
                                if(query.length()>0){
                                    Statement pstmt3 = con.createStatement();
                                    ResultSet rs3=pstmt3.executeQuery(query);


                                    if(rs3.next()){//gene name
                                        geneid=rs3.getString(2);
                                        if(! hash.containsKey(geneid)){
                                            p = treePanel.addObject( actualCell, rs3.getString(1), "gene", null, null);
                                            p.setColor(new java.awt.Color(255,255,255));
                                            hash.put(geneid,p);

                                            //create a name folder to store biological names
                                            p = treePanel.addObject( p, "Biological names", "folder", null, null);
                                            p.setColor(new java.awt.Color(255,255,255));
                                            anatomyPart actualGene=p;

                                            //search and add synonyms to the name folder
                                            Statement pstmt4 = con.createStatement();
                                            query="SELECT \"SYNO\" FROM \"SYNO\" WHERE \"GENE_ID\" = "+geneid;
                                            ResultSet rs4=pstmt4.executeQuery(query);
                                            while(rs4.next()){
                                                p = treePanel.addObject( actualGene, rs4.getString(1), "folder", rs3.getString(1), null);
                                                p.setColor(new java.awt.Color(255,255,255));
                                            }
                                            pstmt4.close();


                                        }
                                    }
                                    pstmt3.close();
                                }
                                if(hash.containsKey(geneid)){
                                    p = treePanel.addObject( (anatomyPart) hash.get(geneid), rs2.getString(1), "cdna", null, null);
                                }else{
                                    p = treePanel.addObject( actualCell, rs2.getString(1), "clone", null, null);
                                }
                                p.setColor(new java.awt.Color(255,255,255));
                                hash.put(rs.getString(2),p);//enr des id des clones pour associer les in situ redondantes

                            }
                            pstmt2.close();

                            p = treePanel.addObject( (anatomyPart) hash.get(rs.getString(2)), rs.getString(1), "is", null, null);
                            p.setColor(new java.awt.Color(153,0,0));


                        }
                        pstmt.close();

                    }else if(byGene.isSelected()){

                        anatomyPart p;

                        //Expression data query
                        Statement pstmt = con.createStatement();

                        String recResult="";
                        recResult=select_recursif2(anat.getID());
                        recResult=recResult.substring(0,recResult.length()-1);
                        System.out.println("Result: "+recResult);

                        String query="select distinct A.\"IN_SITU_ID\", A.\"TARGET_ID\" from \"TARGET\" A where A.\"IN_SITU_ID\" in(select B.\"IN_SITU_ID\" from \"IN_SITU\" B where B.\"IN_SITU_ID\" in (select \"IN_SITU_ID\" from \"TARGET\" where \"REGION_ID\" in ("+recResult+")) and B.\"CHECKED\"='y' and B.\"PRIVATE\"='n')";

                        ResultSet rs=pstmt.executeQuery(query);


                        while(rs.next()){//in situ & target id
                            Statement pstmt2 = con.createStatement();
                            query="SELECT \"NAME\", \"TYPE\" FROM \"MOL_ENTITY\" WHERE \"MOL_ID\" = "+rs.getString(2);
                            ResultSet rs2=pstmt2.executeQuery(query);
                            while(rs2.next()){//clone name / cdna
                                if(rs2.getString(2).equals("clone_sequence")){
                                    query="SELECT a.\"NAME\", a.\"GENE_ID\" FROM \"GENE\" a, \"CLONE_SEQ\" b WHERE a.\"GENE_ID\"=b.\"ANISEED_CLUSTER_ID\" and b.\"CLONE_SEQ_ID\"="+rs.getString(2);
                                }else{
                                    query="SELECT distinct a.\"NAME\", a.\"GENE_ID\" FROM \"GENE\" a, \"CLONE_SEQ\" b, \"CLONE\" c WHERE a.\"GENE_ID\"=b.\"ANISEED_CLUSTER_ID\" and b.\"CLONE_NAME\"=c.\"CLONE_NAME\" and c.\"CLONE_ID\"="+rs.getString(2);
                                }
                                Statement pstmt3 = con.createStatement();
                                ResultSet rs3=pstmt3.executeQuery(query);

                                String geneid=new String();
                                if(rs3.next()){
                                    geneid=rs3.getString(2);
                                    if(! hash.containsKey(geneid)){

                                        p = treePanel.addObject( treePanel.getrootNode(), rs3.getString(1), "gene", null, null);
                                        p.setColor(new java.awt.Color(255,255,255));
                                        hash.put(geneid,p);

                                        p = treePanel.addObject( p, "Biological names", "folder", null, null);
                                        p.setColor(new java.awt.Color(255,255,255));
                                        anatomyPart actualGene=p;

                                        //search and add synonyms to the name folder
                                        Statement pstmt4 = con.createStatement();
                                        query="SELECT \"SYNO\" FROM \"SYNO\" WHERE \"GENE_ID\" = "+geneid;
                                        ResultSet rs4=pstmt4.executeQuery(query);
                                        while(rs4.next()){
                                            p = treePanel.addObject( actualGene, rs4.getString(1), "folder", rs3.getString(1), null);
                                            p.setColor(new java.awt.Color(255,255,255));
                                        }
                                        pstmt4.close();

                                    }
                                }
                                pstmt3.close();



                                p = treePanel.addObject( (anatomyPart) hash.get(geneid), anat.getName(), anat.getTitle(), anat.getID(), null);
                                p.setColor(new java.awt.Color(255,255,255));
                                anatomyPart actualCell=p;



                                if(hash.containsKey(geneid)){

                                    p = treePanel.addObject( actualCell, rs2.getString(1), "cdna", null, null);
                                }else{

                                    p = treePanel.addObject( treePanel.getrootNode(), rs2.getString(1), "clone", null, null);
                                }
                                p.setColor(new java.awt.Color(255,255,255));
                                hash.put(rs.getString(2),p);//enr des id des clones pour associer les in situ redondantes

                            }
                            pstmt2.close();

                            p = treePanel.addObject( (anatomyPart) hash.get(rs.getString(2)), rs.getString(1), "is", null, null);
                            p.setColor(new java.awt.Color(153,0,0));
                        }
                        pstmt.close();


                    }


                }

            }

            con.close();
            treePanel.setPreferredSize(new java.awt.Dimension(0,0));
            treePanel.setMinimumSize(new java.awt.Dimension(0,0));

            scrollPaneQuery.setViewportView(treePanel);


        }catch( Exception e){

            if( con !=null){
                try{ con.rollback();}
                catch (SQLException ev){;}
            }
            JOptionPane diag2=new JOptionPane();
            diag2.showMessageDialog(new javax.swing.JFrame(),"ErrorRR: "+ e.getMessage());
        }
        finally {
            if( con !=null){
                try {con.close();}
                catch (SQLException e) {
                    JOptionPane diag2=new JOptionPane();
                    diag2.showMessageDialog(new javax.swing.JFrame(),"ErrorQQ: "+ e.getMessage());
                }
            }
        }
    }//GEN-LAST:event_jButton11ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
//Hierachical query
    public void select_recursif1(String start,Hashtable objs,java.awt.Color coul) throws SQLException
    {
    	Statement psmt = null;
        ResultSet rs = null;

        psmt=con.createStatement();
    	rs=psmt.executeQuery("SELECT \"ANAT_ID\",\"NAME\" FROM \"ANAT_ENTITY\" WHERE \"CHILD_OF\"="+start);
    while (rs.next())
    {
    	 try{
            String name = rs.getString(2);
            cell shape=(cell) objs.get(name);
            shape.setSelected(true, coul, shape.isSelected());
        }catch(NullPointerException e ){;}
        select_recursif1(rs.getString(1),objs,coul);
    }

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Hierarchical query
    public String select_recursif2(String start) throws SQLException
    {
    	Statement psmt = null;
        ResultSet rs = null;



        psmt=con.createStatement();
    	rs=psmt.executeQuery("SELECT \"ANAT_ID\",\"CHILD_OF\" FROM \"ANAT_ENTITY\" WHERE \"ANAT_ID\"="+start);

    while (rs.next())
    {
    	recResult+=rs.getString(1)+",";
        select_recursif2(rs.getString(2));
    }
        return recResult;

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void StainCell(){
        if(treePanel.getSelected() == null)
            return;

        java.awt.Color coul = treePanel.getSelected().getColor();
        String id = treePanel.getSelected().getName();

        try{
            DriverManager.registerDriver(new org.postgresql.Driver());
            String url = VirtualEmbryo.database;
            String userID = VirtualEmbryo.DBlog;
            String pass = VirtualEmbryo.DBpass;

            con = DriverManager.getConnection(url, userID, pass);
            Statement s;
            ResultSet result=null;

            s=con.createStatement();

            String query=new String();
            query = "Select \"REGION_ID\" from \"TARGET\" where \"IN_SITU_ID\"="+id;
            result=s.executeQuery(query);

            while(result.next()){
                String anatid = result.getString(1);
                s=con.createStatement();
                select_recursif1(anatid, objs, coul);

            }
            s.close();

        }catch(SQLException e){;}

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void destroy(){
        try{
            Set keys = objs.keySet();
            Iterator ite = keys.iterator();
            while (ite.hasNext()){
                Object obj3d = ite.next();
                objs.remove(obj3d);
            }
            this.removeAll();
        }catch(Exception e){;}
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTable Table1;
    private javax.swing.JRadioButton byCell;
    private javax.swing.JRadioButton byGene;
    private javax.swing.JRadioButton expression;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JRadioButton noexpression;
    private javax.swing.JScrollPane scrollPaneQuery;
    // End of variables declaration//GEN-END:variables

}
