package fr.cnrs.aniseed;

import javax.media.j3d.*;
import javax.swing.*;
import java.util.Iterator;
import java.util.Set;
import javax.vecmath.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, Created on 29 avril 2002, 12:40
 */

public class Slicer extends javax.swing.JPanel {
    
    ModelClip mc = new ModelClip();
    double pointhautX,pointhautY,pointhautZ,pointbasX,pointbasY,pointbasZ;
    int Xepaisseur,Yepaisseur,Zepaisseur;
    
    BoundingBox polytope = new BoundingBox();
    
    BranchGroup planes;
    
    //Vector to move the modelclip
    Vector4d eqn1= new Vector4d();
    Vector4d eqn2= new Vector4d();
    Vector4d eqn3= new Vector4d();
    Vector4d eqn4= new Vector4d();
    Vector4d eqn5= new Vector4d();
    Vector4d eqn6= new Vector4d();
    
    
    //tg to move 3d cutting plan materialisation
    TransformGroup TGX1;
    TransformGroup TGX2;
    TransformGroup TGY1;
    TransformGroup TGY2;
    TransformGroup TGZ1;
    TransformGroup TGZ2;
    
    //3d plane appearance
    appPlane appX=new appPlane(new Color3f(1f,0f,0f));
    appPlane appY=new appPlane(new Color3f(0f,1f,0f));
    appPlane appZ=new appPlane(new Color3f(0f,0f,1f));
 
    
    //names appearance
    Appearance transpApp=new Appearance();
    
    double hautX, hautY, hautZ, basX, basY, basZ;
    
////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor    
    public Slicer(ModelClip mc,double pointhautX,double pointhautY,double pointhautZ,double pointbasX,double pointbasY,double pointbasZ) {
        
        transpApp.setTransparencyAttributes(new TransparencyAttributes(TransparencyAttributes.NICEST, 1.0f));    
        
        initComponents();
        this.mc=mc;
        this.pointhautX=pointhautX;
        this.pointhautY=pointhautY;
        this.pointhautZ=pointhautZ;
        this.pointbasX=pointbasX;
        this.pointbasY=pointbasY;
        this.pointbasZ=pointbasZ;
        initVolumePlanes();
        
        basX=pointbasX; basY=pointbasY; basZ=pointbasZ;
        hautX=pointhautX; hautY=pointhautY; hautZ=pointhautZ;
        
        polytope.setLower(basX,basY,basZ);
        polytope.setUpper(hautX,hautY,hautZ);

        volume();
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
////////////////////////////////////////////////////////////////////////////////////////////////////    
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        Panel = new javax.swing.JPanel();
        javax.swing.JPanel jPanel3 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel4 = new javax.swing.JPanel();
        javax.swing.JLabel jLabel1 = new javax.swing.JLabel();
        ZCheckBox = new javax.swing.JCheckBox();
        XtopSlider = new javax.swing.JSlider();
        XbottomSlider = new javax.swing.JSlider();
        javax.swing.JLabel jLabel2 = new javax.swing.JLabel();
        XCheckBox = new javax.swing.JCheckBox();
        YCheckBox = new javax.swing.JCheckBox();
        javax.swing.JLabel jLabel3 = new javax.swing.JLabel();
        ZtopSlider = new javax.swing.JSlider();
        YbottomSlider = new javax.swing.JSlider();
        ZbottomSlider = new javax.swing.JSlider();
        YtopSlider = new javax.swing.JSlider();
        filledZ = new javax.swing.JCheckBox();
        filledX = new javax.swing.JCheckBox();
        filledY = new javax.swing.JCheckBox();
        javax.swing.JPanel jPanel1 = new javax.swing.JPanel();
        javax.swing.JPanel jPanel2 = new javax.swing.JPanel();
        javax.swing.JButton resetButton = new javax.swing.JButton();
        jRadioButton3 = new javax.swing.JRadioButton();
        jRadioButton1 = new javax.swing.JRadioButton();
        jRadioButton2 = new javax.swing.JRadioButton();
        jLabel4 = new javax.swing.JLabel();

        setLayout(new java.awt.BorderLayout());

        Panel.setLayout(new java.awt.BorderLayout());

        jPanel3.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        jPanel3.setMinimumSize(new java.awt.Dimension(200, 401));
        jPanel3.setPreferredSize(new java.awt.Dimension(30, 410));

        jPanel4.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jLabel1.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel1.setText(" Z axis");
        jPanel4.add(jLabel1, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 290, 100, 20));

        ZCheckBox.setFont(new java.awt.Font("Arial", 0, 10));
        ZCheckBox.setText("Lock");
        ZCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ZCheckBoxActionPerformed(evt);
            }
        });
        jPanel4.add(ZCheckBox, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 380, 70, -1));

        XtopSlider.setForeground(new java.awt.Color(153, 0, 0));
        XtopSlider.setMajorTickSpacing(10);
        XtopSlider.setMinorTickSpacing(2);
        XtopSlider.setPaintTicks(true);
        XtopSlider.setValue(100);
        XtopSlider.addChangeListener(         new javax.swing.event.ChangeListener(){             public void stateChanged(javax.swing.event.ChangeEvent evt){XdecoupeTop(evt);}});
        jPanel4.add(XtopSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 90, 180, 40));

        XbottomSlider.setForeground(new java.awt.Color(153, 0, 0));
        XbottomSlider.setMajorTickSpacing(10);
        XbottomSlider.setMinorTickSpacing(2);
        XbottomSlider.setPaintTicks(true);
        XbottomSlider.setValue(0);
        XbottomSlider.addChangeListener(         new javax.swing.event.ChangeListener(){             public void stateChanged(javax.swing.event.ChangeEvent evt){XdecoupeBottom(evt);}});
        jPanel4.add(XbottomSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 50, 180, 40));

        jLabel2.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel2.setForeground(new java.awt.Color(204, 0, 0));
        jLabel2.setText(" X axis");
        jPanel4.add(jLabel2, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 30, 100, 20));

        XCheckBox.setFont(new java.awt.Font("Arial", 0, 10));
        XCheckBox.setText("Lock");
        XCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                XCheckBoxActionPerformed(evt);
            }
        });
        jPanel4.add(XCheckBox, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 130, 70, 20));

        YCheckBox.setFont(new java.awt.Font("Arial", 0, 10));
        YCheckBox.setText("Lock");
        YCheckBox.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                YCheckBoxActionPerformed(evt);
            }
        });
        jPanel4.add(YCheckBox, new org.netbeans.lib.awtextra.AbsoluteConstraints(110, 260, 70, 20));

        jLabel3.setFont(new java.awt.Font("Arial", 1, 12));
        jLabel3.setForeground(new java.awt.Color(0, 153, 0));
        jLabel3.setText(" Y axis");
        jPanel4.add(jLabel3, new org.netbeans.lib.awtextra.AbsoluteConstraints(70, 160, 100, 20));

        ZtopSlider.setForeground(new java.awt.Color(153, 0, 0));
        ZtopSlider.setMajorTickSpacing(10);
        ZtopSlider.setMinorTickSpacing(2);
        ZtopSlider.setPaintTicks(true);
        ZtopSlider.setValue(100);
        ZtopSlider.addChangeListener(         new javax.swing.event.ChangeListener(){             public void stateChanged(javax.swing.event.ChangeEvent evt){ZdecoupeTop(evt);}});
        jPanel4.add(ZtopSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 340, 180, 40));

        YbottomSlider.setForeground(new java.awt.Color(153, 0, 0));
        YbottomSlider.setMajorTickSpacing(10);
        YbottomSlider.setMinorTickSpacing(2);
        YbottomSlider.setPaintTicks(true);
        YbottomSlider.setValue(0);
        YbottomSlider.addChangeListener(         new javax.swing.event.ChangeListener(){             public void stateChanged(javax.swing.event.ChangeEvent evt){YdecoupeBottom(evt);}});
        jPanel4.add(YbottomSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 180, 180, 40));

        ZbottomSlider.setForeground(new java.awt.Color(153, 0, 0));
        ZbottomSlider.setMajorTickSpacing(10);
        ZbottomSlider.setMinorTickSpacing(2);
        ZbottomSlider.setPaintTicks(true);
        ZbottomSlider.setValue(0);
        ZbottomSlider.addChangeListener(         new javax.swing.event.ChangeListener(){             public void stateChanged(javax.swing.event.ChangeEvent evt){ZdecoupeBottom(evt);}});
        jPanel4.add(ZbottomSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 310, 180, 30));

        YtopSlider.setForeground(new java.awt.Color(153, 0, 0));
        YtopSlider.setMajorTickSpacing(10);
        YtopSlider.setMinorTickSpacing(2);
        YtopSlider.setPaintTicks(true);
        YtopSlider.setValue(100);
        YtopSlider.addChangeListener(         new javax.swing.event.ChangeListener(){             public void stateChanged(javax.swing.event.ChangeEvent evt){YdecoupeTop(evt);}});
        jPanel4.add(YtopSlider, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 220, 180, 40));

        filledZ.setFont(new java.awt.Font("Arial", 0, 10));
        filledZ.setText("Filled");
        filledZ.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filledZActionPerformed(evt);
            }
        });
        jPanel4.add(filledZ, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 380, 80, 20));

        filledX.setFont(new java.awt.Font("Arial", 0, 10));
        filledX.setText("Filled");
        filledX.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filledXActionPerformed(evt);
            }
        });
        jPanel4.add(filledX, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 130, 80, 20));

        filledY.setFont(new java.awt.Font("Arial", 0, 10));
        filledY.setText("Filled");
        filledY.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filledYActionPerformed(evt);
            }
        });
        jPanel4.add(filledY, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 260, 80, 20));

        jPanel3.add(jPanel4);

        Panel.add(jPanel3, java.awt.BorderLayout.CENTER);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        jPanel2.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        resetButton.setBackground(new java.awt.Color(153, 0, 0));
        resetButton.setText("Reset");
        resetButton.setBorder(new javax.swing.border.SoftBevelBorder(javax.swing.border.BevelBorder.RAISED));
        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetButtonActionPerformed(evt);
            }
        });
        jPanel2.add(resetButton, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 80, 160, 20));

        jRadioButton3.setFont(new java.awt.Font("Dialog", 0, 10));
        jRadioButton3.setText("Show all names");
        jRadioButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton3ActionPerformed(evt);
            }
        });
        jPanel2.add(jRadioButton3, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 50, 140, 20));

        jRadioButton1.setFont(new java.awt.Font("Dialog", 0, 10));
        jRadioButton1.setSelected(true);
        jRadioButton1.setText("Show Slicing");
        jRadioButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton1ActionPerformed(evt);
            }
        });
        jPanel2.add(jRadioButton1, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 10, 140, 20));

        jRadioButton2.setFont(new java.awt.Font("Dialog", 0, 10));
        jRadioButton2.setText("Show clipping planes");
        jRadioButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jRadioButton2ActionPerformed(evt);
            }
        });
        jPanel2.add(jRadioButton2, new org.netbeans.lib.awtextra.AbsoluteConstraints(20, 30, 140, 20));

        jPanel1.add(jPanel2);

        jLabel4.setText("  ");
        jPanel1.add(jLabel4);

        Panel.add(jPanel1, java.awt.BorderLayout.SOUTH);

        add(Panel, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void filledZActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filledZActionPerformed
        if (filledZ.isSelected()){
            appZ.setFilled();
        }
        else{
            appZ.setWire();
        }
        
        if (jRadioButton2.isSelected()){  //avoid a bug
            appX.setOpaque(true);
            appY.setOpaque(true);
            appZ.setOpaque(true);
          
            appX.setVisible(true);
            appY.setVisible(true);
            appZ.setVisible(true);
        }
        else{
            appX.setOpaque(false);
            appY.setOpaque(false);
            appZ.setOpaque(false);
          
            appX.setVisible(false);
            appY.setVisible(false);
            appZ.setVisible(false);
        }
    }//GEN-LAST:event_filledZActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void filledYActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filledYActionPerformed
        if (filledY.isSelected()){
            appY.setFilled();
        }
        else{
            appY.setWire();
        }
        
        if (jRadioButton2.isSelected()){  //avoid bug ...
            appX.setOpaque(true);
            appY.setOpaque(true);
            appZ.setOpaque(true);
          
            appX.setVisible(true);
            appY.setVisible(true);
            appZ.setVisible(true);
        }
        else{
            appX.setOpaque(false);
            appY.setOpaque(false);
            appZ.setOpaque(false);
          
            appX.setVisible(false);
            appY.setVisible(false);
            appZ.setVisible(false);
        }
    }//GEN-LAST:event_filledYActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void filledXActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filledXActionPerformed
        if (filledX.isSelected()){
            appX.setFilled();
        }
        else{
            appX.setWire();
        }
        
        if (jRadioButton2.isSelected()){  //avoid a bug
            appX.setOpaque(true);
            appY.setOpaque(true);
            appZ.setOpaque(true);
          
            appX.setVisible(true);
            appY.setVisible(true);
            appZ.setVisible(true);
        }
        else{
            appX.setOpaque(false);
            appY.setOpaque(false);
            appZ.setOpaque(false);
          
            appX.setVisible(false);
            appY.setVisible(false);
            appZ.setVisible(false);
        }
    }//GEN-LAST:event_filledXActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jRadioButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton3ActionPerformed
        if (jRadioButton3.isSelected()){
            Set keys = embryo.objs.keySet();
            Iterator ite = keys.iterator();
            
            while (ite.hasNext()){
                Object obj3d = ite.next();
                cell node = (cell) embryo.objs.get(obj3d);
                String nameLabel = node.getUserData().toString();
                Shape3D pp = (Shape3D) embryo.labels.get(nameLabel);
                if(node.isSelected())
                    pp.setAppearance(embryo.AppSelectedText);
                else
                    pp.setAppearance(embryo.AppText);
            }
            
        }else{volume();}
            
    }//GEN-LAST:event_jRadioButton3ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jRadioButton2ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton2ActionPerformed
        if (jRadioButton2.isSelected()){
            appX.setOpaque(true);
            appY.setOpaque(true);
            appZ.setOpaque(true);
          
            appX.setVisible(true);
            appY.setVisible(true);
            appZ.setVisible(true);
        }
        else{
            appX.setOpaque(false);
            appY.setOpaque(false);
            appZ.setOpaque(false);
          
            appX.setVisible(false);
            appY.setVisible(false);
            appZ.setVisible(false);
        }
    }//GEN-LAST:event_jRadioButton2ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void jRadioButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jRadioButton1ActionPerformed
        
        
        if (jRadioButton1.isSelected()){
            mc.setEnable(0, true);
            mc.setEnable(1, true);
            mc.setEnable(2, true);
            mc.setEnable(3, true);
            mc.setEnable(4, true);
            mc.setEnable(5, true);
            
            mc.setPlane(0,eqn6);
            mc.setPlane(1,eqn1);
            mc.setPlane(2,eqn2);
            mc.setPlane(3,eqn3);
            mc.setPlane(4,eqn4);
            mc.setPlane(5,eqn5);
            
        }else{
            mc.setEnable(0, false);
            mc.setEnable(1, false);
            mc.setEnable(2, false);
            mc.setEnable(3, false);
            mc.setEnable(4, false);
            mc.setEnable(5, false);
        }
        
        
    }//GEN-LAST:event_jRadioButton1ActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void initVolumePlanes(){
        
        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 100.0);
        
        planes = new BranchGroup();
        planes.setCollidable(false);
        planes.setPickable(false);

        appX.setWire();
        appY.setWire();
        appZ.setWire();
        
        appX.setOpaque(false);
        appY.setOpaque(false);
        appZ.setOpaque(false);
        
        appX.setVisible(false);
        appY.setVisible(false);
        appZ.setVisible(false);
        
        //Y Plane

        QuadArray trStripY=new QuadArray(4 ,QuadArray.COORDINATES );//|QuadArray.COLOR_3
        
        trStripY.setCoordinate(0,new Point3d(pointbasX,0,pointhautZ));
        trStripY.setCoordinate(1,new Point3d(pointhautX,0,pointhautZ));
        trStripY.setCoordinate(3,new Point3d(pointbasX,0,pointbasZ));
        trStripY.setCoordinate(2,new Point3d(pointhautX,0,pointbasZ));
       
        Shape3D planeY1 = new Shape3D(trStripY,appY);
        Shape3D planeY2 = new Shape3D(trStripY,appY);
        planeY1.setPickable(false);
        planeY2.setPickable(false);
        
        
        Transform3D translateY1 = new Transform3D();
        translateY1.set(new Vector3d(0,pointhautY,0));
        TGY1 = new TransformGroup(translateY1);
        TGY1.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        TGY1.addChild(planeY1);
        planes.addChild(TGY1);
        
        Transform3D translateY2 = new Transform3D();
        translateY2.set(new Vector3d(0,pointbasY,0));
        TGY2 = new TransformGroup(translateY2);
        TGY2.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        TGY2.addChild(planeY2);
        planes.addChild(TGY2);     
        
        //X plane
        
        QuadArray trStripX=new QuadArray(4 ,QuadArray.COORDINATES );
        
        trStripX.setCoordinate(0,new Point3d(0,pointbasY,pointbasZ));
        trStripX.setCoordinate(1,new Point3d(0,pointhautY,pointbasZ));
        trStripX.setCoordinate(3,new Point3d(0,pointbasY,pointhautZ));
        trStripX.setCoordinate(2,new Point3d(0,pointhautY,pointhautZ));
        
        Shape3D planeX1 = new Shape3D(trStripX,appX);
        Shape3D planeX2 = new Shape3D(trStripX,appX);
        planeX1.setPickable(false);
        planeX2.setPickable(false);
        
        Transform3D translateX1 = new Transform3D();
        translateX1.set(new Vector3d(pointhautX,0,0));
        TGX1 = new TransformGroup(translateX1);
        TGX1.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        
        TGX1.addChild(planeX1);
        planes.addChild(TGX1);
        
        Transform3D translateX2 = new Transform3D();
        translateX2.set(new Vector3d(pointbasX,0,0));
        TGX2 = new TransformGroup(translateX2);
        
        TGX2.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        
        TGX2.addChild(planeX2);
        planes.addChild(TGX2);
               
        //Z plane
        
        QuadArray trStripZ=new QuadArray(4 ,QuadArray.COORDINATES );
        
        trStripZ.setCoordinate(0,new Point3d(pointbasX,pointbasY,0));
        trStripZ.setCoordinate(1,new Point3d(pointhautX,pointbasY,0));
        trStripZ.setCoordinate(3,new Point3d(pointbasX,pointhautY,0));
        trStripZ.setCoordinate(2,new Point3d(pointhautX,pointhautY,0));
        
        Shape3D planeZ1 = new Shape3D(trStripZ,appZ);
        Shape3D planeZ2 = new Shape3D(trStripZ,appZ);
        planeZ1.setPickable(false);
        planeZ2.setPickable(false);
        
        Transform3D translateZ1 = new Transform3D();
        translateZ1.set(new Vector3d(0,0,pointhautZ));
        TGZ1 = new TransformGroup(translateZ1);
        TGZ1.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        TGZ1.addChild(planeZ1);
        planes.addChild(TGZ1);
        
        Transform3D translateZ2 = new Transform3D();
        translateZ2.set(new Vector3d(0,0,pointbasZ));
        TGZ2 = new TransformGroup(translateZ2);
        TGZ2.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
        TGZ2.addChild(planeZ2);
        planes.addChild(TGZ2);   
        
        planes.setCapability(BranchGroup.ALLOW_DETACH);

        embryo.TGsizeCell.addChild(planes);
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void volume(){         
        
        polytope.setLower(basX,basY,basZ);
        polytope.setUpper(hautX,hautY,hautZ);
            
        if (! jRadioButton3.isSelected())
            eraseName();
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void eraseName(){
            
            Set keys = embryo.objs.keySet();
            Iterator ite = keys.iterator();
            
            
            while (ite.hasNext()){
                
                Object obj3d = ite.next();
                cell node = (cell) embryo.objs.get(obj3d);
                String nameLabel = node.getUserData().toString();
                Shape3D pp = (Shape3D) embryo.labels.get(nameLabel);
                
                if (  polytope.intersect(node.getBounds()) ){
                    if(node.isSelected())
                        pp.setAppearance(embryo.AppSelectedText);
                    else
                        pp.setAppearance(embryo.AppText);
                    node.setVisible(true);
                }else{
                    pp.setAppearance(transpApp);
                    node.setVisible(false);
                }
            }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_resetButtonActionPerformed
        reset();
    }//GEN-LAST:event_resetButtonActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void reset(){
        XCheckBox.setSelected(false);
        YCheckBox.setSelected(false);
        ZCheckBox.setSelected(false);
        
        XtopSlider.setValue(100);
        XbottomSlider.setValue(0);
        
        YtopSlider.setValue(100);
        YbottomSlider.setValue(0);
        
        ZtopSlider.setValue(100);
        ZbottomSlider.setValue(0);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    private void YCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_YCheckBoxActionPerformed
        Yepaisseur = -( YbottomSlider.getValue() - YtopSlider.getValue() );
    }//GEN-LAST:event_YCheckBoxActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void XCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_XCheckBoxActionPerformed
        Xepaisseur = -( XbottomSlider.getValue() - XtopSlider.getValue() );
    }//GEN-LAST:event_XCheckBoxActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////
    private void ZCheckBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ZCheckBoxActionPerformed
        Zepaisseur = -( ZbottomSlider.getValue() - ZtopSlider.getValue() );
    }//GEN-LAST:event_ZCheckBoxActionPerformed
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void close(){
        remove (Panel);
        planes.detach();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void XdecoupeTop(javax.swing.event.ChangeEvent evt){
        
        JSlider curs=(JSlider) evt.getSource();
        double valeur=curs.getValue();
        double niv=valeur/100;
        eqn1 = new Vector4d(1.0, 0.0, 0.0, -(pointbasX+niv*(pointhautX - pointbasX)) );
        mc.setPlane(1, eqn1);
        if (XCheckBox.isSelected()){
            XbottomSlider.setValue(XtopSlider.getValue()-Xepaisseur);
        }
        
        Transform3D translateX1 = new Transform3D();
        translateX1.set(new Vector3d(pointbasX+niv*(pointhautX - pointbasX), 0, 0));
        TGX1.setTransform(translateX1);
        hautX=pointbasX+niv*(pointhautX - pointbasX);
        
        volume();
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void YdecoupeTop(javax.swing.event.ChangeEvent evt){
        JSlider curs=(JSlider) evt.getSource();
        double valeur=curs.getValue();
        double niv=valeur/100;
        eqn3 = new Vector4d(0.0, 1.0, 0.0, -(pointbasY+niv*(pointhautY - pointbasY)) );
        mc.setPlane(3, eqn3);
        if (YCheckBox.isSelected()){
            YbottomSlider.setValue(YtopSlider.getValue()-Yepaisseur);         
        }
        Transform3D translateY1 = new Transform3D();
        translateY1.set( new Vector3d(0, pointbasY+niv*(pointhautY - pointbasY), 0) );
        TGY1.setTransform(translateY1);

        hautY=pointbasZ+niv*(pointhautZ - pointbasZ);

        volume();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void ZdecoupeTop(javax.swing.event.ChangeEvent evt){
        JSlider curs=(JSlider) evt.getSource();
        double valeur=curs.getValue();
        double niv=valeur/100;
        eqn5 = new Vector4d(0.0, 0.0, 1.0, -(pointbasZ+niv*(pointhautZ - pointbasZ)) );
        mc.setPlane(5, eqn5);
        if (ZCheckBox.isSelected()){
            ZbottomSlider.setValue(ZtopSlider.getValue()-Zepaisseur);         
        }
        Transform3D translateZ1 = new Transform3D();
        translateZ1.set( new Vector3d(0, 0, pointbasZ+niv*(pointhautZ - pointbasZ)) );
        TGZ1.setTransform(translateZ1);

        hautZ=pointbasZ+niv*(pointhautZ - pointbasZ);
        
        volume();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void XdecoupeBottom(javax.swing.event.ChangeEvent evt){
        JSlider curs=(JSlider) evt.getSource();
        double valeur=curs.getValue();
        double niv=valeur/100;
        eqn2 = new Vector4d(-1.0, 0.0, 0.0,  pointbasX+niv*(pointhautX - pointbasX) );
        mc.setPlane(2, eqn2);
        if (XCheckBox.isSelected()){
            XtopSlider.setValue(XbottomSlider.getValue()+Xepaisseur);         
        }
        Transform3D translateX2 = new Transform3D();
        translateX2.set( new Vector3d(pointbasX+niv*(pointhautX - pointbasX),0,0) );
        TGX2.setTransform(translateX2);
        
        basX=pointbasX+niv*(pointhautX - pointbasX);
        
        volume();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void YdecoupeBottom(javax.swing.event.ChangeEvent evt){
        JSlider curs=(JSlider) evt.getSource();
        double valeur=curs.getValue();
        double niv=valeur/100;
        eqn4 = new Vector4d( 0.0, -1.0, 0.0,  pointbasY+niv*(pointhautY - pointbasY) );
        mc.setPlane(4, eqn4);
        if (YCheckBox.isSelected()){
            YtopSlider.setValue(YbottomSlider.getValue()+Yepaisseur);  
        }
        Transform3D translateY2 = new Transform3D();
        translateY2.set( new Vector3d(0,pointbasY+niv*(pointhautY - pointbasY),0) );
        TGY2.setTransform(translateY2);
        
        basY=pointbasY+niv*(pointhautY - pointbasY);
        
        volume();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void ZdecoupeBottom(javax.swing.event.ChangeEvent evt){
        JSlider curs=(JSlider) evt.getSource();
        double valeur=curs.getValue();
        double niv=valeur/100;
        eqn6 = new Vector4d(0.0, 0.0, -1.0,  pointbasZ+niv*(pointhautZ - pointbasZ) );
        mc.setPlane(0, eqn6);
        if (ZCheckBox.isSelected()){
            ZtopSlider.setValue(ZbottomSlider.getValue()+Zepaisseur);  
        }
        Transform3D translateZ2 = new Transform3D();
        translateZ2.set( new Vector3d(0,0,pointbasZ+niv*(pointhautZ - pointbasZ)) );
        TGZ2.setTransform(translateZ2);
        
        basZ=pointbasZ+niv*(pointhautZ - pointbasZ);
        
        volume();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel Panel;
    private javax.swing.JCheckBox XCheckBox;
    private javax.swing.JSlider XbottomSlider;
    private javax.swing.JSlider XtopSlider;
    private javax.swing.JCheckBox YCheckBox;
    private javax.swing.JSlider YbottomSlider;
    private javax.swing.JSlider YtopSlider;
    private javax.swing.JCheckBox ZCheckBox;
    private javax.swing.JSlider ZbottomSlider;
    private javax.swing.JSlider ZtopSlider;
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JCheckBox filledX;
    private javax.swing.JCheckBox filledY;
    private javax.swing.JCheckBox filledZ;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JRadioButton jRadioButton1;
    private javax.swing.JRadioButton jRadioButton2;
    private javax.swing.JRadioButton jRadioButton3;
    // End of variables declaration//GEN-END:variables

}
