package fr.cnrs.aniseed;

import java.awt.*;
import java.util.*;
import javax.swing.tree.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0
 */

//Build anatomy node and tree
public class anatomyPart extends DefaultMutableTreeNode {
    
    private Object name;
    private String title, id;
    boolean selected;
    Color couleur=new Color(153,0,0);
    cell shape=null;

////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor
    public anatomyPart(Object name, String title){
        super(name);
        
        this.name = name;
        this.title = title;
        this.setSelected(false);
        this.allowsChildren=true;
        this.setColor(couleur);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor
    public anatomyPart(Object name, String title, String id, cell shape){
        super(name);
        
        this.name = name;
        this.title = title;
        this.id = id;
        this.shape=shape;
        
        
        try{
            shape.setTreeRef(this);
        }catch(NullPointerException e){;}
        
        
        this.setSelected(false);
        this.allowsChildren=true;
        this.setColor(couleur);
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setID(String newid) {
        id=newid;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public String getID() {
        return id;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public String getName() {
        return name.toString();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setName(String newname) {
        name=newname;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public String getTitle() {
        return title;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setTitle(String newtitle) {
        title=newtitle;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public TreeNode getChild(int index){
        return this.getChildAt(index);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public boolean isSelected(){
        return selected;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setSelected(boolean bool){
        selected=bool;
        
        try{
            shape.setSelected( bool, new javax.vecmath.Color3f(this.getColor()) );
            if (bool){
                shape.getAppearance().setTransparencyAttributes( embryo.AppSelected.getTransparency() );
                shape.getAppearance().setPolygonAttributes( embryo.AppSelected.getPolygon() );
            }
        }catch(java.lang.NullPointerException e){;}
        
        
        if (children != null) {
            Enumeration enume = children.elements();
            while (enume.hasMoreElements()) {
                anatomyPart node = (anatomyPart)enume.nextElement();
                node.setSelected(bool);
            }
        }
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public Color getColor(){
        return couleur;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setColor(Color col){
        couleur=col;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setShape(cell shap){
        shape=shap;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public cell getShape(){
        return shape;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    
}