package fr.cnrs.aniseed;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, Created on 8 juillet 2003, 11:40
 */

//Default appareance for embryo
public class appDefault extends Appearance{
    
    boolean visible=true;
    int colmode=1;
    
    /** Creates a new instance of defaultApp */
    public appDefault() {
        
        //Objects default appearance
        setCapability(Appearance.ALLOW_MATERIAL_WRITE);
        setCapability(Appearance.ALLOW_MATERIAL_READ);
        setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_WRITE);
        setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_WRITE);
        setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_WRITE);
        
        
        TransparencyAttributes t_attr = new TransparencyAttributes(
        TransparencyAttributes.BLENDED, 0.7f, TransparencyAttributes.BLEND_SRC_ALPHA, TransparencyAttributes.BLEND_ONE
        );
        
        t_attr.setCapability(TransparencyAttributes.ALLOW_VALUE_READ);
        t_attr.setCapability(TransparencyAttributes.ALLOW_VALUE_WRITE);
        t_attr.setCapability(TransparencyAttributes.ALLOW_MODE_READ);
        t_attr.setCapability(TransparencyAttributes.ALLOW_MODE_WRITE);
        setTransparencyAttributes( t_attr );
        setRenderingAttributes( new RenderingAttributes() );
        
        
        Material mat = new Material();
        mat.setCapability(Material.ALLOW_COMPONENT_WRITE);
        mat.setCapability(Material.ALLOW_COMPONENT_READ);
        mat.setDiffuseColor(0.2f,0.2f,0.4f);
        mat.setLightingEnable(true);
        setMaterial(mat);
        
        
        PolygonAttributes poly = new PolygonAttributes();
        poly.setCapability(PolygonAttributes.ALLOW_MODE_WRITE);
        poly.setCapability(PolygonAttributes.ALLOW_MODE_READ);
        poly.setCapability(PolygonAttributes.ALLOW_CULL_FACE_WRITE);
        poly.setCapability(PolygonAttributes.ALLOW_CULL_FACE_READ );
        poly.setCullFace(PolygonAttributes.CULL_NONE);
        setPolygonAttributes(poly);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setWire(){
        //Wireframe
        this.getPolygonAttributes().setPolygonMode(PolygonAttributes.POLYGON_LINE);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setFilled(){
        //Fill
        this.getPolygonAttributes().setPolygonMode(PolygonAttributes.POLYGON_FILL);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setPoint(){
        //Point
        this.getPolygonAttributes().setPolygonMode(PolygonAttributes.POLYGON_POINT);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setDoubleSided(boolean bool){
        if(bool){
            //Double sided
            this.getPolygonAttributes().setCullFace(PolygonAttributes.CULL_NONE);
        }else{
            //Single sided
            this.getPolygonAttributes().setCullFace(PolygonAttributes.CULL_BACK);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setOpaque(boolean bool){
        if(bool){
            //Opaque
            this.getTransparencyAttributes().setTransparencyMode(TransparencyAttributes.NONE);
        }else{
            //Transparent
            this.getTransparencyAttributes().setTransparencyMode(TransparencyAttributes.NICEST);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setColor(Color Couleur){
        if (Couleur != null){
            Color3f coul =new Color3f(Couleur);
            
            if (colmode==1)
                this.getMaterial().setDiffuseColor(coul);
            else if (colmode==2)
                this.getMaterial().setAmbientColor(coul);
            else if (colmode==3)
                this.getMaterial().setEmissiveColor(coul);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setVisible(boolean bool){
        if(bool==false){
            this.getTransparencyAttributes().setTransparency(1f);
            visible=false;
        }else{
            float transp=0.7f;
            this.getTransparencyAttributes().setTransparency(transp);
            visible=true;
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public boolean isVisible(){
        return(visible);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setColorMode(int mode){
        Color3f coul=new Color3f();
        if (colmode==1)
            this.getMaterial().getDiffuseColor(coul);
        else if (colmode==2)
            this.getMaterial().getAmbientColor(coul);
        else if (colmode==3)
            this.getMaterial().getEmissiveColor(coul);
        
        colmode=mode;
        
        if (colmode==1){
            Material mat = new Material();
            mat.setCapability(Material.ALLOW_COMPONENT_WRITE);
            mat.setCapability(Material.ALLOW_COMPONENT_READ);
            mat.setDiffuseColor(coul);
            mat.setLightingEnable(true);
            setMaterial(mat);
        }else if (colmode==2){
            Material mat = new Material();
            mat.setCapability(Material.ALLOW_COMPONENT_WRITE);
            mat.setCapability(Material.ALLOW_COMPONENT_READ);
            mat.setAmbientColor(coul);    //MACOS incompatibility
            mat.setLightingEnable(true);
            setMaterial(mat);
        }else if (colmode==3){
            Material mat = new Material();
            mat.setCapability(Material.ALLOW_COMPONENT_WRITE);
            mat.setCapability(Material.ALLOW_COMPONENT_READ);
            mat.setEmissiveColor(coul);    //MACOS incompatibility
            mat.setLightingEnable(true);
            setMaterial(mat);
        }
        
    }
    
}