package fr.cnrs.aniseed;

import javax.media.j3d.*;
import javax.vecmath.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, Created on 22 mars 2004, 17:42
 */

//Plane object appearance for embryo
public class appPlane extends Appearance{
    
    boolean visible=true;
    
    public appPlane(Color3f Couleur) {
        
        //Selected objects appearance
        setCapability(Appearance.ALLOW_MATERIAL_WRITE);
        setCapability(Appearance.ALLOW_MATERIAL_READ);
        setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_WRITE);
        setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_READ);
        
        setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_WRITE);
        setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_WRITE);
        
        
        TransparencyAttributes t_attr2 = new TransparencyAttributes(TransparencyAttributes.NONE, 0f);
        t_attr2.setTransparencyMode(TransparencyAttributes.NONE);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_VALUE_READ);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_VALUE_WRITE);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_MODE_READ);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_MODE_WRITE);
        setTransparencyAttributes(t_attr2);
        setRenderingAttributes( new RenderingAttributes() );
        
        ColoringAttributes ca = new ColoringAttributes();
        ca.setColor(Couleur);
        ca.setShadeModel(ColoringAttributes.FASTEST);
        setColoringAttributes(ca);
        
        PolygonAttributes poly2 = new PolygonAttributes();
        poly2.setCapability(PolygonAttributes.ALLOW_MODE_WRITE);
        poly2.setCapability(PolygonAttributes.ALLOW_MODE_READ);
        poly2.setCapability(PolygonAttributes.ALLOW_CULL_FACE_WRITE);
        poly2.setCapability(PolygonAttributes.ALLOW_CULL_FACE_READ );
        poly2.setCullFace(PolygonAttributes.CULL_NONE);
        setPolygonAttributes(poly2);
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setWire(){
        //Wireframe
        this.getPolygonAttributes().setPolygonMode(PolygonAttributes.POLYGON_LINE);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setFilled(){
        //Fill
        this.getPolygonAttributes().setPolygonMode(PolygonAttributes.POLYGON_FILL);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setOpaque(boolean bool){
        if(bool){
            //Opaque
            this.getTransparencyAttributes().setTransparencyMode(TransparencyAttributes.NONE);
        }else{
            //Transparent
            this.getTransparencyAttributes().setTransparencyMode(TransparencyAttributes.NICEST);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setVisible(boolean bool){
        if(bool==false){
            getTransparencyAttributes().setTransparency(1f);
            visible=false;
        }else{
            getTransparencyAttributes().setTransparency(0f);
            visible=true;
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public boolean isVisible(){
        return(visible);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
}