package fr.cnrs.aniseed;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.awt.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, Created on 9 juillet 2003, 18:09
 */

//Selected object appearance
public class appSelected extends Appearance{

    boolean visible=true;

////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor: create a new instance of default app
    public appSelected() {
        float transp=0.4f;
        try{
            transp=embryo.AppSelected.getTransparencyAttributes().getTransparency();
        }catch(NullPointerException e){transp=0.4f;}

        //selected objects appearance
        setCapability(Appearance.ALLOW_COLORING_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_COLORING_ATTRIBUTES_READ);
        
        setCapability(Appearance.ALLOW_MATERIAL_WRITE);
        setCapability(Appearance.ALLOW_MATERIAL_READ);
        setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_WRITE);
        setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_WRITE);
        setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_WRITE);
        
        TransparencyAttributes t_attr2 = new TransparencyAttributes(
        TransparencyAttributes.BLENDED,
        transp,//0.6f,
        TransparencyAttributes.BLEND_SRC_ALPHA,
        TransparencyAttributes.BLEND_ONE);
        t_attr2.setTransparencyMode(TransparencyAttributes.NONE);
        setTransparencyAttributes(t_attr2);
        setRenderingAttributes( new RenderingAttributes() );
        
        t_attr2.setCapability(TransparencyAttributes.ALLOW_VALUE_READ);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_VALUE_WRITE);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_MODE_READ);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_MODE_WRITE);
        
        Material mat2 = new Material();
        mat2.setCapability(Material.ALLOW_COMPONENT_WRITE);
        mat2.setCapability(Material.ALLOW_COMPONENT_READ);
        mat2.setLightingEnable(true);
        mat2.setAmbientColor(0.6f,0.0f,0.0f);
        
        PolygonAttributes poly2 = new PolygonAttributes();
        poly2.setCapability(PolygonAttributes.ALLOW_MODE_WRITE);
        poly2.setCapability(PolygonAttributes.ALLOW_MODE_READ);
        poly2.setCapability(PolygonAttributes.ALLOW_CULL_FACE_WRITE);
        poly2.setCapability(PolygonAttributes.ALLOW_CULL_FACE_READ );
        poly2.setCullFace(PolygonAttributes.CULL_NONE);
        setPolygonAttributes(poly2);
        setMaterial(mat2);
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor: create a new instance of default app with a color
    public appSelected(Color3f Couleur) {
        float transp=0.4f;
        try{
            transp=embryo.AppSelected.getTransparencyAttributes().getTransparency();
        }catch(NullPointerException e){transp=0.4f;}

        //Selected object appearance
        setCapability(Appearance.ALLOW_MATERIAL_WRITE);
        setCapability(Appearance.ALLOW_MATERIAL_READ);
        setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_WRITE);
        setCapability(Appearance.ALLOW_POLYGON_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_WRITE);
        setCapability(Appearance.ALLOW_TRANSPARENCY_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_READ);
        setCapability(Appearance.ALLOW_RENDERING_ATTRIBUTES_WRITE);
        
        
        TransparencyAttributes t_attr2 = new TransparencyAttributes(
        TransparencyAttributes.BLENDED,
        transp,//0.6f,                             //0.2f
        TransparencyAttributes.BLEND_SRC_ALPHA,
        TransparencyAttributes.BLEND_ONE);
        t_attr2.setTransparencyMode(TransparencyAttributes.NONE);
        setTransparencyAttributes(t_attr2);
        setRenderingAttributes( new RenderingAttributes() );
        
        t_attr2.setCapability(TransparencyAttributes.ALLOW_VALUE_READ);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_VALUE_WRITE);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_MODE_READ);
        t_attr2.setCapability(TransparencyAttributes.ALLOW_MODE_WRITE);
        
        Material mat2 = new Material();
        mat2.setCapability(Material.ALLOW_COMPONENT_WRITE);
        mat2.setCapability(Material.ALLOW_COMPONENT_READ);
        mat2.setLightingEnable(true);
        mat2.setDiffuseColor(Couleur);
        setMaterial(mat2);
        
        PolygonAttributes poly2 = new PolygonAttributes();
        poly2.setCapability(PolygonAttributes.ALLOW_MODE_WRITE);
        poly2.setCapability(PolygonAttributes.ALLOW_MODE_READ);
        poly2.setCapability(PolygonAttributes.ALLOW_CULL_FACE_WRITE);
        poly2.setCapability(PolygonAttributes.ALLOW_CULL_FACE_READ );
        poly2.setCullFace(PolygonAttributes.CULL_NONE);
        setPolygonAttributes(poly2);
        
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setWire(){
        //Wireframe
        this.getPolygonAttributes().setPolygonMode(PolygonAttributes.POLYGON_LINE);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setFilled(){
        //Fill
        this.getPolygonAttributes().setPolygonMode(PolygonAttributes.POLYGON_FILL);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setPoint(){
        //Point
        this.getPolygonAttributes().setPolygonMode(PolygonAttributes.POLYGON_POINT);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////   
    public void setDoubleSided(boolean bool){
        if(bool){
            //Double sided
            this.getPolygonAttributes().setCullFace(PolygonAttributes.CULL_NONE);
        }else{
            //Single sided
            this.getPolygonAttributes().setCullFace(PolygonAttributes.CULL_BACK);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setOpaque(boolean bool){
        if(bool){
            //Opaque
            this.getTransparencyAttributes().setTransparencyMode(TransparencyAttributes.NONE);
        }else{
            //Transparent
            this.getTransparencyAttributes().setTransparencyMode(TransparencyAttributes.NICEST);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setColor(Color Couleur){
        if (Couleur != null){
            Color3f coul =new Color3f(Couleur);
            this.getMaterial().setDiffuseColor(coul);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public void setVisible(boolean bool){
        if(bool==false){
            getTransparencyAttributes().setTransparency(1f);
            visible=false;
        }else{
            float transp=0.4f;
            this.getTransparencyAttributes().setTransparency(transp);
            visible=true;
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public boolean isVisible(){
        return(visible);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public TransparencyAttributes getTransparency(){
        return this.getTransparencyAttributes();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
    public PolygonAttributes getPolygon(){
        return this.getPolygonAttributes();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////    
 
}