package fr.cnrs.aniseed;

import javax.media.j3d.*;
import javax.vecmath.*;
import java.util.*;

import java.util.regex.*;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.RandomAccessFile;

import Jama.*;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, Created on 26 octobre 2002, 11:43
 */

//All about the cells
public class cell extends Shape3D{

    boolean visible=true;
    boolean selected=false;
    String name=null;
    anatomyPart treeRef=null;
    Blinker blink;

////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor
    public cell(Geometry geo) {
        super(geo);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Constructor 2
    public cell() {
        super();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//                                              MESURES                                           //
////////////////////////////////////////////////////////////////////////////////////////////////////
//Get cell's area
    public double getSurface(){

        GeometryArray geom = (GeometryArray) this.getGeometry();
        com.sun.j3d.utils.geometry.GeometryInfo geoinfo = new com.sun.j3d.utils.geometry.GeometryInfo(geom);
        Point3f[] coord = new Point3f[geom.getVertexCount()];
        coord = geoinfo.getCoordinates();

       //Calculation of the triangles areas by using distances
       //between points (Heron formula)

        double surface=0;
        for(int i=0; i<coord.length-2; i+=3){

            float a = coord[i].distance(coord[i+1]);
            float b = coord[i+1].distance(coord[i+2]);
            float c = coord[i+2].distance(coord[i]);

            float p =(a+b+c)/2;   //p=1/2 perimeter

            surface+=Math.sqrt(p*(p-a)*(p-b)*(p-c));

        }
        return surface;

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Get cell's volume
    public double getVolume(){

        GeometryArray geom1 = (GeometryArray) this.getGeometry();
        com.sun.j3d.utils.geometry.GeometryInfo geoinfo1 = new com.sun.j3d.utils.geometry.GeometryInfo(geom1);
        Point3f[] coordinates1 = new Point3f[geom1.getVertexCount()];
        coordinates1 = geoinfo1.getCoordinates();

        double volu=0;
        for(int i=0; i<coordinates1.length-2; i+=3){

            float[] tuple1=new float[3];
            coordinates1[i].get(tuple1);
            float[] tuple2=new float[3];
            coordinates1[i+1].get(tuple2);
            float[] tuple3=new float[3];
            coordinates1[i+2].get(tuple3);

            volu += (-(tuple3[0]*tuple2[1]*tuple1[2])+(tuple2[0]*tuple3[1]*tuple1[2])+(tuple3[0]*tuple1[1]*tuple2[2])-(tuple1[0]*tuple3[1]*tuple2[2])-(tuple2[0]*tuple1[1]*tuple3[2])+(tuple1[0]*tuple2[1]*tuple3[2]))/6;
        }
        return(Math.abs(volu));
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Get cell's convex hull
    private Point3f[] convexHull()
    {

    	  Vector hullPoints=new Vector();

              GeometryArray geom1 = (GeometryArray) this.getGeometry();

              com.sun.j3d.utils.geometry.GeometryInfo geoinfo1 = new com.sun.j3d.utils.geometry.GeometryInfo(geom1);

              Point3f[] coordinates1 = new Point3f[geom1.getVertexCount()];

              coordinates1 = geoinfo1.getCoordinates();


              //Writting to file
              FileOutputStream fluxsortant;
              BufferedWriter out;
              try{
                  fluxsortant=new FileOutputStream("Qhull/point.txt");
      		  out=new BufferedWriter(new OutputStreamWriter(fluxsortant));
      		  out.write("3 rbox "+coordinates1.length+"\n"+coordinates1.length+"\n");
             for (int i=0;i<coordinates1.length;i++)
              {
              	out.write(coordinates1[i].x+" "+coordinates1[i].y+" "+coordinates1[i].z+"\n");
              }

              out.close();
              }
              catch (Exception e){;}

              //Qhull
              String os=System.getProperty("os.name");

              if (!os.startsWith("Win"))
              {
              	if (os.startsWith("Mac OS"))
              	{
              	//MacOS
              	try {
                Process proc = Runtime.getRuntime().exec("Qhull/mac/mac.sh Qhull/point.txt Qhull/result.txt");
              	proc.waitFor();
                }
                catch (Exception e) {System.out.println("Qhull error");}

              	}
              	else
              	{
              //UNIX
              try {
                Process proc = Runtime.getRuntime().exec("Qhull/linux/hull.sh Qhull/point.txt Qhull/result.txt");
              	proc.waitFor();

              } catch (Exception e) {System.out.println("Qhull error");}
              	}
              }
              else
              {

              //Windows
              try {
                Process proc = Runtime.getRuntime().exec("Qhull\\win\\hull.bat");
              	proc.waitFor();

              } catch (Exception e) {System.out.println("Qhull error");}


              }

              //Processing Qhull results
              FileInputStream stream;
              BufferedReader in;

              String lec="";
              String glob="";

              try{
              RandomAccessFile raf = new RandomAccessFile("Qhull/result.txt", "r");
              String ligne;

              int hit=0;
              while ( (ligne = raf.readLine()) != null )
                {
              	Point3f point=new Point3f();

              	glob = ligne;

                //Java 1.4
                glob=Pattern.compile("Polygon\\[\\{").matcher(glob).replaceAll("");
                glob=Pattern.compile("\\}\\]").matcher(glob).replaceAll("");
                glob=Pattern.compile("\\}").matcher(glob).replaceAll("");
                glob=Pattern.compile("\\{").matcher(glob).replaceAll("");
                glob=Pattern.compile(" ").matcher(glob).replaceAll("");
                glob=Pattern.compile(",").matcher(glob).replaceAll(" ");
                glob=Pattern.compile("\\}\\}").matcher(glob).replaceAll("");

                //the same with Java 1.5
                /*
              	 glob=glob.replace("Polygon[{","");
                 glob=glob.replace("}]","");
                 glob=glob.replace("},","");
                 glob=glob.replace("{","");
                 glob=glob.replace(" ","");
                 glob=glob.replace(","," ");
                 glob=glob.replace("}}","");
                 */

                 String[] gt=glob.split(" ");

                 if (gt.length==3)
                 {

                 point.x=Float.parseFloat(gt[0]);
                 point.y=Float.parseFloat(gt[1]);
                 point.z=Float.parseFloat(gt[2]);

                 hullPoints.add(hit,point);

                 hit++;
                 }
                }

              }
              catch (Exception e){e.printStackTrace();}

              //Give the convex hull
              Point3f[] shared = new Point3f[hullPoints.size()];
              hullPoints.copyInto(shared);

              return shared;

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Get the shapes factor in order to compute bounding box
    public float[] getShapeFactors(boolean display){//, int tolerance){

        GeometryArray geom = (GeometryArray) this.getGeometry();
        com.sun.j3d.utils.geometry.GeometryInfo geoinfo = new com.sun.j3d.utils.geometry.GeometryInfo(geom);
        Point3f[] coord = new Point3f[geom.getVertexCount()];
        coord = geoinfo.getCoordinates();

        Point3f g=this.getGravity();

        float a1=0, a2=0, a3=0, b1=0, b2=0, b3=0, c1=0, c2=0, c3=0;

        for(int aa=0; aa< coord.length; aa++){
            coord[aa].x=coord[aa].x - g.x;       //move the axis to the center of gravity
            coord[aa].y=coord[aa].y - g.y;
            coord[aa].z=coord[aa].z - g.z;

            a1 += (coord[aa].x) * (coord[aa].x);
            a2 += (coord[aa].x) * (coord[aa].y);
            a3 += (coord[aa].x) * (coord[aa].z);

            b1 += (coord[aa].y) * (coord[aa].x);
            b2 += (coord[aa].y) * (coord[aa].y);
            b3 += (coord[aa].y) * (coord[aa].z);

            c1 += (coord[aa].z) * (coord[aa].x);
            c2 += (coord[aa].z) * (coord[aa].y);
            c3 += (coord[aa].z) * (coord[aa].z);
        }

        double[][] res = new double[3][3];         //create the 3x3 matrix
        res[0][0]=a1; res[0][1]=a2; res[0][2]=a3;
        res[1][0]=b1; res[1][1]=b2; res[1][2]=b3;
        res[2][0]=c1; res[2][1]=c2; res[2][2]=c3;

        Matrix matrice = new Matrix(res,3,3);
        EigenvalueDecomposition eigen = matrice.eig();  //compute eigenvectors & eigenvalues
        Matrix result=eigen.getV();

        double[] result3=eigen.getRealEigenvalues();

        //transform the shape coord acording to the new axis
        Point3f[] coord2=new Point3f[coord.length];
        Matrix result3333=result;
        result=result.inverse();
        for(int aa=0; aa< coord.length; aa++){
            Matrix m = new Matrix(new double[]{coord[aa].x, coord[aa].y, coord[aa].z},3);
            Matrix r = result.times(m);
            coord2[aa]=new Point3f((float)r.get(0,0), (float)r.get(1,0), (float)r.get(2,0));
        }

        //compute the bounding box
        float bestxx=0, bestyy=0, bestzz=0;
        float bestxx2=1, bestyy2=1, bestzz2=1;

        for(int a=0; a< coord2.length; a++){

            if(coord2[a].x >= 0.0f){
                if( coord2[a].x > bestxx ){
                    bestxx=coord2[a].x;
                }
            }else{
                if( coord2[a].x < bestxx2 ){
                    bestxx2=coord2[a].x;
                }
            }

            if(coord2[a].y >= 0.0f){
                if( coord2[a].y > bestyy ){
                    bestyy=coord2[a].y;
                }
            }else{
                if( coord2[a].y < bestyy2 ){
                    bestyy2=coord2[a].y;
                }
            }

            if(coord2[a].z >= 0.0f){
                if( coord2[a].z > bestzz ){
                    bestzz=coord2[a].z;
                }
            }else{
                if( coord2[a].z < bestzz2 ){
                    bestzz2=coord2[a].z;
                }
            }
        }

        float bestx=(bestxx-bestxx2);
        float besty=(bestyy-bestyy2);
        float bestz=(bestzz-bestzz2);


        //Display bounding box
        if(display){
            BranchGroup bgsurf=new BranchGroup();
            bgsurf.setCapability(BranchGroup.ALLOW_DETACH);

            appDefault app = new appDefault();
            app.setColor(new java.awt.Color(0.0f,1.0f,0.0f));
            com.sun.j3d.utils.geometry.Box sphe = new com.sun.j3d.utils.geometry.Box(bestx/2, besty/2, bestz/2, app);

            javax.media.j3d.Transform3D t3d = new javax.media.j3d.Transform3D();

            t3d.setTranslation(new Vector3d(g.x, g.y, g.z));

            javax.media.j3d.Transform3D t3d2 = new javax.media.j3d.Transform3D();
            Matrix3d mmm=new Matrix3d(result3333.get(0,0), result3333.get(0,1), result3333.get(0,2), result3333.get(1,0), result3333.get(1,1), result3333.get(1,2), result3333.get(2,0), result3333.get(2,1), result3333.get(2,2) );
            t3d2.set(mmm);
            t3d.mul(t3d2);
            TransformGroup TG = new TransformGroup(t3d);

            Transform3D t3d3=new Transform3D();
            t3d3.setTranslation( new Vector3f( ((bestxx+bestxx2)/2), ((bestyy+bestyy2)/2), ((bestzz+bestzz2)/2) ));
            TransformGroup TG2 = new TransformGroup( t3d3 );
            TG.addChild(TG2);
            TG2.addChild(sphe);
            bgsurf.addChild(TG);

            //Centre of gravity
            com.sun.j3d.utils.geometry.Sphere sphe3 = new com.sun.j3d.utils.geometry.Sphere(2, app);
            javax.media.j3d.Transform3D t3d322 = new javax.media.j3d.Transform3D();
            t3d322.setTranslation(new Vector3f(g.x, g.y, g.z));
            TransformGroup TG3 = new TransformGroup(t3d322);
            TG3.addChild(sphe3);
            bgsurf.addChild(TG3);

            embryo.extra.addChild(bgsurf);
        }
////////////////////////////////////////////////////////////////////////////////////////////////////
//                              COMPUTE THE SHAPE DESCRIPTORS                                     //
////////////////////////////////////////////////////////////////////////////////////////////////////
        double vol=this.getVolume();
        double surf=this.getSurface();

        float occupancy =(float) (100*(vol/(bestx*besty*bestz)));
        float sv=(float) ((surf/vol)*100);


        //sort axis / length
        float[] axis3d = {bestx,besty,bestz};

        if(axis3d[1]>axis3d[0]){
            float tmp=axis3d[0];
            axis3d[0]=axis3d[1];
            axis3d[1]=tmp;
        }
        if(axis3d[2]>axis3d[0]){
            float tmp=axis3d[0];
            axis3d[0]=axis3d[2];
            axis3d[2]=tmp;
        }
        if(axis3d[2]>axis3d[1]){
            float tmp=axis3d[1];
            axis3d[1]=axis3d[2];
            axis3d[2]=tmp;
        }

        float elongation=100*(1-(axis3d[1]/axis3d[0]));
        float flatness  =100*(1-(axis3d[2]/axis3d[1]));

        float sphericity= (float) (100*( (vol*6.0*java.lang.Math.sqrt(java.lang.Math.PI))/(java.lang.Math.pow(surf,(3.0/2.0))) ));

//ENTROPY COMPUTATION
        double p1,p2,p3;  //normalised eigenvalues
        p1=result3[0]/(result3[0]+result3[1]+result3[2]);
        p2=result3[1]/(result3[0]+result3[1]+result3[2]);
        p3=result3[2]/(result3[0]+result3[1]+result3[2]);

        p1=p1*java.lang.Math.log(p1);
        p2=p2*java.lang.Math.log(p2);
        p3=p3*java.lang.Math.log(p3);
        float entropy = (float) ((1.0/java.lang.Math.log(3.0))*(p1+p2+p3)*-1.0);
////////////////////////////////////////////////////////////////
//CONVEXITY COMPUTAITON

//Step 1: Convex hull triangulation recovery
        Point3f[] shared=this.convexHull();
        //Volume computation
        double volu=0;
        for(int i=0; i<shared.length-2; i+=3){

            float[] tuple1=new float[3];
            shared[i].get(tuple1);
            float[] tuple2=new float[3];
            shared[i+1].get(tuple2);
            float[] tuple3=new float[3];
            shared[i+2].get(tuple3);

            volu += (-(tuple3[0]*tuple2[1]*tuple1[2])+(tuple2[0]*tuple3[1]*tuple1[2])+(tuple3[0]*tuple1[1]*tuple2[2])-(tuple1[0]*tuple3[1]*tuple2[2])-(tuple2[0]*tuple1[1]*tuple3[2])+(tuple1[0]*tuple2[1]*tuple3[2]))/6;
        }
        volu=Math.abs(volu);

        float convexity=(float) ((this.getVolume()/volu)*100);

////////////////////////////////////////////////////////////////
//COMPLEXITY COMPUTATION
//Hull area divided by cell area
// Actually this descriptor is not visible by the user ...
        //Area computation
        double surface=0;
        for(int i=0; i<shared.length-2; i+=3){

            float a = shared[i].distance(shared[i+1]);
            float b = shared[i+1].distance(shared[i+2]);
            float c = shared[i+2].distance(shared[i]);

            float p =(a+b+c)/2;

            surface+=Math.sqrt(p*(p-a)*(p-b)*(p-c));

        }

        float complex=(float) ((surface/this.getSurface())*100);

////////////////////////////////////////////////////////////////
//v/V COMPUTATION
        float vV= (float) ((this.getVolume()/this.getGlobalVolume())*100);
////////////////////////////////////////////////////////////////

        float[] results={occupancy, 0.0f,elongation, flatness, 0.0f,sphericity, entropy*100, sv, convexity, vV};
        return results;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Compute the total embryo volume (each cells)
     public double getGlobalVolume()
    {
        double global=0f;

        //Cells list recovery
        java.util.Hashtable objs=embryo.objs;

        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
         while (ite.hasNext()){
            Object obj3d = ite.next();
            cell node = (cell) objs.get(obj3d);
            global+=node.getVolume();
        }

        return global;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Compute the center of gravity
    public Point3f getGravity(){

        GeometryArray geom = (GeometryArray) this.getGeometry();
        com.sun.j3d.utils.geometry.GeometryInfo geoinfo = new com.sun.j3d.utils.geometry.GeometryInfo(geom);
        Point3f[] coord = new Point3f[geom.getVertexCount()];
        coord = geoinfo.getCoordinates();

        double surface=0;
        double ALLsurface=this.getSurface();
        float x=0,y=0,z=0;
        int aaa=0;
        double test=0;
        for(int i=0; i<coord.length-2; i+=3){
            ++aaa;
            float a = coord[i].distance(coord[i+1]);
            float b = coord[i+1].distance(coord[i+2]);
            float c = coord[i+2].distance(coord[i]);
            float p =(a+b+c)/2;   //p=1/2 perimetre
            surface = Math.sqrt(p*(p-a)*(p-b)*(p-c));

            x += ((coord[i].x + coord[i+1].x + coord[i+2].x)/3) * (surface/ALLsurface);
            y += ((coord[i].y + coord[i+1].y + coord[i+2].y)/3) * (surface/ALLsurface);
            z += ((coord[i].z + coord[i+1].z + coord[i+2].z)/3) * (surface/ALLsurface);

        }

        //create gravity point g
        Point3f g=new Point3f(x,y,z);

        return g;

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    private double carre(double num){
        return (num*num);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    private double cube(double num){
        return (num*num*num);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public double[] Distance(cell node, int mode){
        //mode1 -> dist from center to center
        //mode2 -> dist from closest point to closest point
        if(mode==1){
            Point3d position1=new Point3d( this.getGravity() );
            Point3d position2=new Point3d( node.getGravity() );

            double results[]=new double[1];
            results[0]=position1.distance(position2);

            return results;

        }
        else if(mode==2){

            GeometryArray geom1 = (GeometryArray) this.getGeometry();
            GeometryArray geom2 = (GeometryArray) node.getGeometry();

            com.sun.j3d.utils.geometry.GeometryInfo geoinfo1 = new com.sun.j3d.utils.geometry.GeometryInfo(geom1);
            com.sun.j3d.utils.geometry.GeometryInfo geoinfo2 = new com.sun.j3d.utils.geometry.GeometryInfo(geom2);

            Point3f[] coordinates1 = new Point3f[geom1.getVertexCount()];
            Point3f[] coordinates2 = new Point3f[geom2.getVertexCount()];

            coordinates1 = geoinfo1.getCoordinates();
            coordinates2 = geoinfo2.getCoordinates();

            double min=1000000000, max=0;
            for(int a=0;a< coordinates1.length-2;a+=3){
                for(int b=0;b< coordinates2.length-2;b+=3){
                    if( coordinates1[a].distance(coordinates2[b])<min ){
                        min=coordinates1[a].distance(coordinates2[b]);
                    }
                    if( coordinates1[a].distance(coordinates2[b])>max ){
                        max=coordinates1[a].distance(coordinates2[b]);
                    }
                }
            }
            double results[]=new double[2];
            results[0]=min;
            results[1]=max;
            return results;

        }
        else{
            double results[]=new double[1];
            results[0]=-1d;
            return results;
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void updateTree(boolean bool){
        try{
            if(this.getTreeRef().isSelected() != bool){
                this.getTreeRef().setSelected(bool);
                VirtualEmbryo.treePanel.getTree().updateUI();
            }
        }catch(NullPointerException e){;};
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelected(boolean bool){
        try{
            selected=bool;
            if(bool){

                this.setAppearance(embryo.AppSelected);
                ((OrientedShape3D)embryo.labels.get(this.getName())).setAppearance(embryo.AppSelectedText);//text
                updateTree(bool);
            }else{
                stopBlinking();
                this.setAppearance(embryo.AppDefault);
                ((OrientedShape3D)embryo.labels.get(this.getName())).setAppearance(embryo.AppText);//text
                updateTree(bool);
            }
        }catch(NullPointerException e){;};

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelected(boolean bool,Color3f Couleur){
        try{
            selected=bool;
            if(bool){

                this.setAppearance(new appSelected2(new java.awt.Color(Couleur.x,Couleur.y,Couleur.z)));

                ((OrientedShape3D)embryo.labels.get(this.getName())).setAppearance(embryo.AppSelectedText);//text
                updateTree(bool);

            }else{
                stopBlinking();
                this.setAppearance(embryo.AppDefault);
                ((OrientedShape3D)embryo.labels.get(this.getName())).setAppearance(embryo.AppText);//text
                updateTree(bool);
            }
        }catch(NullPointerException e){;};
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Start to select from a query -> update tree (contrary to the others selection system)
    public void setSelected(boolean bool,java.awt.Color Couleur, boolean wasSelected){
        try{
            selected=bool;
            if(bool){

                if(wasSelected){
                    if(blink != null){
                        blink.addColor(Couleur);
                    }else{
                        blink = new Blinker(this, treeRef.getColor(), Couleur);
                        blink.start();
                    }
                }

                this.setAppearance(new appSelected2( Couleur ));

                treeRef.setColor( Couleur );
                ((OrientedShape3D)embryo.labels.get(this.getName())).setAppearance(embryo.AppSelectedText);//text
                updateTree(bool);

            }else{
                stopBlinking();
                this.setAppearance(embryo.AppDefault);
                ((OrientedShape3D)embryo.labels.get(this.getName())).setAppearance(embryo.AppText);//text
                updateTree(bool);

            }
        }catch(NullPointerException e){;};
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public boolean isSelected(){
        return selected;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setName(String nom){
        name=nom;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public String getName(){
        return name;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public boolean isVisible(){
        return visible;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setVisible(boolean bool){
        visible=bool;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setTreeRef(anatomyPart part){
        treeRef=part;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public anatomyPart getTreeRef(){
        return treeRef;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public boolean isBlinking(){
        boolean bool=false;
        if (blink != null)
            bool=true;
        return bool;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void stopBlinking(){
        try{
            blink.stopBlinking();
            blink=null;
            //permet de retrouver la bonne couleur a affecter a la cellule
            this.setSelected( true, new Color3f(this.getTreeRef().getColor()) );
        }catch(NullPointerException e){;}
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
}
