package fr.cnrs.aniseed;

import java.io.*;
import java.sql.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import javax.vecmath.*;
import java.awt.event.*;
import javax.media.j3d.*;
import com.sun.j3d.loaders.*;
import com.sun.j3d.loaders.objectfile.*;
import com.sun.j3d.utils.universe.*;
import com.sun.j3d.utils.behaviors.vp.*;
import com.sun.j3d.utils.behaviors.keyboard.*;
import java.awt.image.*;
import j3d.utils.*;
import java.net.URL;

/**
 * @author Olivier Tassy
 *
 * @version 1.0, Created on 8 juillet 2003, 18:58
 */

public class embryo extends JPanel{

    Connection con=null;

    ModelClip mc = new ModelClip();
    double pointhautX,pointhautY,pointhautZ;
    double pointbasX,pointbasY,pointbasZ;
    static appText AppText=new appText();
    static appSelectedText AppSelectedText=new appSelectedText();
    static appDefault AppDefault=new appDefault();
    static appSelected AppSelected=new appSelected();
    Axis3D tripod;


    static Hashtable objs ;//store the name of 3D objects contained in the Obj file
    static Hashtable labels ;//store label3d
    static BranchGroup scene;
    static BranchGroup extra;  //used to see & remove 3d shape axis
    static TransformGroup TGsizeCell;
    Canvas3D c;
    OffScreenCanvas3D offScreenCanvas3D;
    int OFF_SCREEN_SCALE = 1;
    SimpleUniverse u;

    String recResult="";


    public embryo(String fichier) {

        setMinimumSize(new java.awt.Dimension(0,0));

        setLayout(new BorderLayout());
        GraphicsConfiguration config = SimpleUniverse.getPreferredConfiguration();
        c = new Canvas3D(config);
        add("Center", c);

        // Create the scene + connect to the virtual universe
        u = new SimpleUniverse(c);
        scene=createSceneGraph(fichier);
        scene.setCapability(Node.ENABLE_PICK_REPORTING);
        scene.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
        scene.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);

        scene.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        scene.setCapability(BranchGroup.ALLOW_DETACH);

        // Create the off-screen Canvas3D used for snapshots
        offScreenCanvas3D = new OffScreenCanvas3D(config, true);
        Screen3D sOn = c.getScreen3D();
        Screen3D sOff = offScreenCanvas3D.getScreen3D();
        Dimension dim = sOn.getSize();
        dim.width *= OFF_SCREEN_SCALE;
        dim.height *= OFF_SCREEN_SCALE;
        sOff.setSize(dim);
        sOff.setPhysicalScreenWidth( sOn.getPhysicalScreenWidth()  * OFF_SCREEN_SCALE);
        sOff.setPhysicalScreenHeight(sOn.getPhysicalScreenHeight() * OFF_SCREEN_SCALE);

        // attach the offscreen canvas to the view
        u.getViewer().getView().addCanvas3D(offScreenCanvas3D);

        //set the front view
        u.getViewer().getView().setFrontClipDistance( 0.005 );//0.0001 );

        //picking
        c.addMouseListener(new MouseAdapter() {
            public void mouseClicked( MouseEvent e ){
                //get the mouse coords.
                int mouseX=e.getX();
                int mouseY=e.getY();

                Point3d rayOrg = new Point3d();
                Vector3d rayDir = new Vector3d();

                //get coords. of the user point of view
                Point3d eyePos = new Point3d();
                c.getCenterEyeInImagePlate(eyePos);

                // translate the mouse canvas position to view space
                Point3d mousePos = new Point3d();
                c.getPixelLocationInImagePlate(
                mouseX, mouseY, mousePos);

                // get the view-to-world transform
                Transform3D xform = new Transform3D();
                c.getImagePlateToVworld(xform);

                // transform eye and mouse from view to world space
                xform.transform(eyePos);
                xform.transform(mousePos);

                // save the world pick ray origin
                rayOrg.set(eyePos);

                // build the world pick ray direction
                rayDir.sub(mousePos, rayOrg);
                rayDir.normalize();

                /// build pick ray object from ray origin and direction
                PickRay ray = new PickRay(rayOrg, rayDir);

                // throw the pick ray into the scene at all the leaf shape
                // nodes under the pick root
                SceneGraphPath paths[] = scene.pickAllSorted(ray);


                if( paths != null) {
                    SceneGraphPath[] pickedshapeTMP=new SceneGraphPath[paths.length];
                    int conteur=0;

                    // shape target bounds were hit, check for real hits
                    for( int hitI= 0; hitI< paths.length; hitI++) {
                        // intersect pick ray with shape target geometry
                        Node shape = paths[ hitI].getObject();
                        double dist[] = {0.0};
                        cell obj=(cell) shape;

                        boolean visibol=true;
                        if( (e.getModifiers()==e.BUTTON1_MASK)||(e.getModifiers()==18) ){
                            //Destroy null case et invisible objects
                            if(obj.getAppearance() instanceof appDefault){
                                appDefault app=(appDefault) obj.getAppearance();
                                visibol = app.isVisible();
                            }else{
                                appSelected app=(appSelected) obj.getAppearance();
                                visibol = app.isVisible();
                            }
                            ///used for the slicer: meme s'il a une apparence visible, un objet coupe n'est pas represente
                            if(visibol){
                                visibol=obj.isVisible();
                            }

                        }

                        boolean isRealHit = obj.intersect(paths[ hitI], ray, dist);

                        if((visibol)&&(isRealHit == true)) {
                            // compute hit point from hit distance and pick ray
                            Point3d point = new Point3d();
                            point.scaleAdd( dist[ 0], rayDir, rayOrg);
                            pickedshapeTMP[conteur++] = paths[ hitI];
                        }

                   }

                    //erase empty boxes of the array
                    SceneGraphPath[] pickedshape=new SceneGraphPath[conteur];
                    System.arraycopy(pickedshapeTMP,0,pickedshape,0,conteur);


                    if ( (pickedshape.length > 0) ){
                        cell obj=new cell();
                        Node shape;

                        int nextone=-1;

                        if( (e.getModifiers()==e.BUTTON1_MASK)||(e.getModifiers()==18) ){
                            //left clic unselect the cell

                            if(! e.isControlDown() ){       // if the ctrl key is down, the 1st cell is selected
                                for( int hitI=0; hitI < pickedshape.length; ++hitI) {
                                    shape = pickedshape[hitI].getObject();
                                    obj=(cell) shape;
                                    if ( obj.isSelected() ) {
                                        nextone=hitI;
                                        break;
                                    }
                                }
                            }

                            if(nextone==-1){
                                shape = pickedshape[0].getObject();
                                obj=(cell) shape;
                                if(! obj.isSelected())
                                    obj.setSelected(true);
                            }
                            else if ( nextone+1 < pickedshape.length ){
                                obj.setSelected(false);
                                shape = pickedshape[nextone+1].getObject();
                                cell obj2=(cell) shape;
                                if(! obj2.isSelected()){
                                    obj2.setSelected(true);
                                }
                            }else{
                                obj.setSelected(false);
                            }


                        }else{
                            //right clic=>unselect
                            for( int hitI=0; hitI < pickedshape.length; ++hitI) {
                                shape = pickedshape[hitI].getObject();
                                obj=(cell) shape;
                                if ( obj.isSelected() ) {
                                    obj.setSelected(false);
                                    break;
                                }
                            }

                        }

                    }

                }

            }
        });

        scene.compile();
        u.addBranchGraph(scene);

        // add a mouse behaviors to the ViewingPlatform
        ViewingPlatform viewingPlatform = u.getViewingPlatform();

        // This will move the ViewPlatform back a bit so the objects in the scene can be viewed.
        viewingPlatform.setNominalViewingTransform();

        //restore the point of view of the last seen embryo.
        try{
            viewingPlatform.getViewPlatformTransform().setTransform(VirtualEmbryo.view);
        }catch(Exception e){;};

        //the mouse control zoom rotation & translation
        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0, 0.0, 0.0), 100.0);
        OrbitBehavior orbit = new OrbitBehavior(c, OrbitBehavior.REVERSE_ALL);
        orbit.setSchedulingBounds(bounds);
        viewingPlatform.setViewPlatformBehavior(orbit);

        //navigation with the keyboard
        TransformGroup viewtrans = u.getViewingPlatform().getViewPlatformTransform();
        KeyNavigatorBehavior keybehavior = new KeyNavigatorBehavior(viewtrans);
        keybehavior.setSchedulingBounds(bounds);
        PlatformGeometry vp = new PlatformGeometry();
        vp.addChild(keybehavior);
        u.getViewingPlatform().setPlatformGeometry(vp);


        //lower the thread priority to make the user interface working faster (!?)
        u.setJ3DThreadPriority(Thread.MIN_PRIORITY);

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    private BranchGroup createSceneGraph(String fichier){

        objs = new Hashtable();
        labels = new Hashtable();

        BranchGroup objRoot=new BranchGroup();

        Group cellules = new Group();

        //TG to shrink cells (~100x too big)
        Transform3D t3dcell = new Transform3D();
        t3dcell.setScale(0.01);
        TGsizeCell = new TransformGroup(t3dcell);
        TGsizeCell.setCapability(Node.ENABLE_PICK_REPORTING);
        TGsizeCell.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
        TGsizeCell.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
        TGsizeCell.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        objRoot.addChild(TGsizeCell);
        TGsizeCell.addChild(cellules);

        extra = new BranchGroup();
        extra.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
        extra.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
        extra.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
        extra.setPickable(false);
        TGsizeCell.addChild(extra); // to add main shape axis using shape descriptors tools

        Group text = new Group();
        TGsizeCell.addChild(text);



        int flags = ObjectFile.TRIANGULATE;
        ObjectFile f = new ObjectFile(flags,(float)(60 * Math.PI / 180.0));

        Scene s = null;
        try {
            /* local launch */
            //s = f.load(fichier);

            /* jnlp launch */
            URL url_fichier = new URL(VirtualEmbryo.url + "3dve/" + fichier);
            s = f.load(url_fichier);
            f=null;
        }
        catch (FileNotFoundException e){
            JOptionPane.showMessageDialog(this,"Error: Wrong file format (not found)");
            VirtualEmbryo.clear();
            return(null);
        }
        catch (ParsingErrorException e){
            JOptionPane.showMessageDialog(this,"Error: Wrong file format (parsing error)");
            VirtualEmbryo.clear();
            return(null);
        }
        catch (IncorrectFormatException e){
            JOptionPane.showMessageDialog(this,"Error: Wrong file format (incorrect format)");
            VirtualEmbryo.clear();
            return(null);
        }
        catch (Exception e){
            JOptionPane.showMessageDialog(this,"Error: Wrong file format");
            VirtualEmbryo.clear();
            return(null);
        }

        //get 3d objects stored in the file
        Hashtable objtmps=s.getNamedObjects();

        //Set keys = objs.keySet();
        Set keys = objtmps.keySet();
        Iterator ite = keys.iterator();


        //Convert shapes into cell objects   on peut mieux faire en bidouillant ObjectFile pour produire directement un objet cell on pourra alors utiliser "cellules.addChild(s.getSceneGroup());" pour attacher ces objet a la scene
        while (ite.hasNext()){
            String objtmp = (String) ite.next();
            cell celltmp = new cell( ((Shape3D) objtmps.get(objtmp)).getGeometry() );
            objtmp=objtmp.replace(':',' ');
            objs.put(objtmp,celltmp);
        }
        objtmps.clear();


        keys = objs.keySet();
        ite = keys.iterator();

        pointhautX=0;pointhautY=0;pointhautZ=0;
        pointbasX=0;pointbasY=0;pointbasZ=0;
        while (ite.hasNext()){
            Object obj3d = ite.next();

            cell node = (cell) objs.get(obj3d);

            //appearance by default
            node.setAppearance(AppDefault);

            //attach to the scene
            ///Clear that line if modif ObjFile
            cellules.addChild(node);

            node.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
            node.getGeometry().setCapability(Geometry.ALLOW_INTERSECT);
            node.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
            node.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
            node.setCapability(Node.ALLOW_BOUNDS_READ);
            node.getGeometry().setCapability(TriangleArray.ALLOW_COORDINATE_READ);
            node.getGeometry().setCapability(TriangleArray.ALLOW_COUNT_READ);
            node.getGeometry().setCapability(GeometryArray.ALLOW_FORMAT_READ);
            node.getGeometry().setCapability(GeometryArray.ALLOW_NORMAL_READ);

            String nomobj =(String) obj3d;

            node.setUserData(nomobj);
            node.setName(nomobj);

            //get objects coordinates to write their name inside
            javax.media.j3d.BoundingSphere bSphere = new BoundingSphere( node.getBounds());
            Point3d position2 = new Point3d();
            bSphere.getCenter(position2);

            double[] coord=new double[3];
            position2.get(coord);
            Point3f position = new Point3f((float)coord[0]/100, (float)coord[1]/100, (float)coord[2]/100);   //div par 100 pour etre raccord avec les cellules remises e l'echelle

            //search bounding points for the whole embryo
            javax.media.j3d.BoundingBox bbox = new BoundingBox(node.getBounds());
            Point3d posUpper = new Point3d();
            bbox.getUpper(posUpper);
            Point3d posLower = new Point3d();
            bbox.getLower(posLower);

            double[] tupleUpper=new double[3];
            posUpper.get(tupleUpper);
            double[] tupleLower=new double[3];
            posLower.get(tupleLower);

            if (tupleUpper[0]>pointhautX)
                pointhautX= tupleUpper[0];
            if(tupleLower[0]<pointbasX)
                pointbasX= tupleLower[0];

            if (tupleUpper[1]>pointhautY)
                pointhautY= tupleUpper[1];
            if(tupleLower[1]<pointbasY)
                pointbasY= tupleLower[1];

            if (tupleUpper[2]>pointhautZ)
                pointhautZ= tupleUpper[2];
            if(tupleLower[2]<pointbasZ)
                pointbasZ= tupleLower[2];

            //display object names
            Font3D f3d = new Font3D(new Font("dialog", Font.BOLD, 1),new FontExtrusion());

            Text3D text3d= new Text3D(
            //Font3D
            f3d,
            //String
            nomobj,
            //position
            position,
            //alignment
            Text3D.ALIGN_CENTER,
            //path
            Text3D.PATH_RIGHT
            );

            //the text have to face the user all the time => use orientedshape3d
            OrientedShape3D orient = new OrientedShape3D(
            text3d,
            AppText,
            OrientedShape3D.ROTATE_ABOUT_POINT,
            position
            );

            orient.setPickable(false);
            orient.setCollidable(false);
            orient.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
            orient.setCapability(Shape3D.ALLOW_APPEARANCE_READ);

            //TG to shrink text size
            Transform3D t3dtxt = new Transform3D();

            try{
                t3dtxt.setScale(  VirtualEmbryo.materialPanel.getTextSize()/10  );
            }catch(Exception e){
                t3dtxt.setScale(4f);
            }

            //TG to add the name in the center of the object
            Transform3D translateY1 = new Transform3D();
            translateY1.set(new Vector3d(position2));

            /////////////
            TransformGroup TGY1 = new TransformGroup(translateY1);
            TransformGroup TGY111 = new TransformGroup(t3dtxt);
            TGY1.addChild(TGY111);
            TGY111.addChild(orient);

            TGY111.setCapability(TransformGroup.ALLOW_TRANSFORM_WRITE);
            TGY111.setCapability(TransformGroup.ALLOW_TRANSFORM_READ);
            ////////////

            //add to the group handling text
            text.addChild(TGY1);

            orient.setUserData(TGY111);
            labels.put(nomobj, orient);

        }

        ////////////////////////////////////////////////////////////////////////////////
        //////////////////////////////CLIPPING//////////////////////////////////////////
        ////////////////////////////////////////////////////////////////////////////////
        //BoundingSphere used for the modelclip & lights
        BoundingSphere bounds = new BoundingSphere(new Point3d(0.0,0.0,0.0), 10000.0);

        if (mc.isLive()){
            mc=new ModelClip();
        }

        mc.setCapability(ModelClip.ALLOW_ENABLE_READ);
        mc.setCapability(ModelClip.ALLOW_ENABLE_WRITE);
        mc.setCapability(ModelClip.ALLOW_PLANE_READ);
        mc.setCapability(ModelClip.ALLOW_PLANE_WRITE);
        mc.setCapability(ModelClip.ALLOW_SCOPE_READ);
        mc.setCapability(ModelClip.ALLOW_SCOPE_WRITE);
        mc.setCapability(Node.ALLOW_BOUNDS_READ);

        //ModelClip -> to slice the embryo
        boolean enables[] = {true, true, true, true, true, true};
        //X
        Vector4d eqn1 = new Vector4d(0.0, 0.0, 0.0, 0.0 );
        Vector4d eqn2 = new Vector4d(0.0, 0.0, 0.0, 0.0);
        //Y
        Vector4d eqn3 = new Vector4d(0.0, 0.0, 0.0, 0.0);
        Vector4d eqn4 = new Vector4d(0.0, 0.0, 0.0, 0.0);
        //Z
        Vector4d eqn5 = new Vector4d(0.0, 0.0, 0.0, 0.0);
        Vector4d eqn6 = new Vector4d(0.0, 0.0, 0.0, 0.0);

        mc.setEnables(enables);
        //X
        mc.setPlane(1, eqn1);
        mc.setPlane(2, eqn2);
        //Y
        mc.setPlane(3, eqn3);
        mc.setPlane(4, eqn4);
        //Z
        mc.setPlane(5, eqn5);
        mc.setPlane(0, eqn6);

        mc.setInfluencingBounds(bounds);
        mc.addScope(cellules);
        TGsizeCell.addChild(mc);


        // set background colour
        Color3f bgColor = new Color3f(0f, 0f, 0f);
        Background bgNode = new Background(bgColor);
        //            bgNode.setCapability( Background.ALLOW_COLOR_WRITE );
        bgNode.setApplicationBounds(bounds);
        //objRoot.addChild(bgNode);
        TGsizeCell.addChild(bgNode);


        //            Fog ... to accentuate text depth ...
        //            Color3f fogColor = new Color3f( 0.0f,0.0f,0.0f );
        //            ExponentialFog fog = new ExponentialFog(fogColor,1.5f);
        //            fog.setInfluencingBounds(bounds);
        //            fog.addScope(text);
        //            objRoot.addChild(fog);



        // ambiant light
        Color3f ambientColor = new Color3f(.2f, .2f, .2f);
        AmbientLight ambientLightNode = new AmbientLight(ambientColor);
        ambientLightNode.setInfluencingBounds(bounds);
        TGsizeCell.addChild(ambientLightNode);

        // directional lights
        Color3f light2Color = new Color3f(1f, 1f, 1f);
        Vector3f light1Direction  = new Vector3f( java.lang.Math.round(pointhautX-10), java.lang.Math.round(pointhautY-10), java.lang.Math.round(pointhautZ-10));

        Color3f light1Color = new Color3f(1f, 1f, 1f);
        Vector3f light2Direction  = new Vector3f(java.lang.Math.round(pointbasX+10), java.lang.Math.round(pointbasY+10), java.lang.Math.round(pointbasZ+10));

        DirectionalLight light1 = new DirectionalLight(light1Color, light1Direction);
        light1.setInfluencingBounds(bounds);
        TGsizeCell.addChild(light1);

        DirectionalLight light2 = new DirectionalLight(light2Color, light2Direction);
        light2.setInfluencingBounds(bounds);
        TGsizeCell.addChild(light2);

        return objRoot;

    }

////////////////////////////////////////////////////////////////////////////////////////////////////
    public void snapshot(){
        Point loc = c.getLocationOnScreen();
        offScreenCanvas3D.setOffScreenLocation(loc);

        Dimension dim = c.getSize();
        dim.width *= OFF_SCREEN_SCALE;
        dim.height *= OFF_SCREEN_SCALE;

        BufferedImage bImage = offScreenCanvas3D.doRender(dim.width, dim.height);
        new ImageDisplayer(bImage);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void showTripod(boolean bool){
        if (bool){
            tripod = new Axis3D(pointbasX/100, pointbasY/100, pointbasZ/100);  //div par 100 pour etre raccord avec les cellules remises e l'echelle
            tripod.setCapability(BranchGroup.ALLOW_DETACH);
            tripod.setPickable(false);
            tripod.setCollidable(false);
            scene.addChild(tripod);
        }else{
            tripod.detach();
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public Slicer addSlicer(){
        Slicer slice= new Slicer(mc, pointhautX, pointhautY, pointhautZ, pointbasX, pointbasY, pointbasZ);
        return slice;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public Hashtable getObj(){
        return objs;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public Hashtable getLabels(){
        return labels;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setTextVisible(boolean bool){
        if(bool){
            AppText.setVisible(true);
        }else{
            AppText.setVisible(false);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedTextVisible(boolean bool){
        if(bool){
            AppSelectedText.setVisible(true);
        }else{
            AppSelectedText.setVisible(false);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setTextColor(Color couleur){
        AppText.setColor(couleur);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedTextColor(Color couleur){
        AppSelectedText.setColor(couleur);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setDefaultCellsFilled(){
        AppDefault.setFilled();
    }
///////////////////////////////////////////////////////////////////////////////////////////////////
    public void setDefaultCellsWire(){
        AppDefault.setWire();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setDefaultCellsPoint(){
        AppDefault.setPoint();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setDefaultCellsColor(Color Couleur){
        AppDefault.setColor(Couleur);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setDefaultCellsOpaque(boolean bool){
        AppDefault.setOpaque(bool);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setDefaultCellsDoubleSided(boolean bool){
        AppDefault.setDoubleSided(bool);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setDefaultCellsVisible(boolean bool){
        AppDefault.setVisible(bool);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedCellsFilled(){
        AppSelected.setFilled();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedCellsWire(){
        AppSelected.setWire();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedCellsPoint(){
        AppSelected.setPoint();
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedCellsColor(Color Couleur){
        AppSelected.setColor(Couleur);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedCellsOpaque(boolean bool){
        AppSelected.setOpaque(bool);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedCellsDoubleSided(boolean bool){
        AppSelected.setDoubleSided(bool);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedCellsVisible(boolean bool){
        AppSelected.setVisible(bool);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void reset(){
        //All the cells are in state  -> not selected
        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while (ite.hasNext()){
            Object obj = ite.next();
            cell celltmp = (cell) objs.get(obj);
            celltmp.setSelected(false);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void getBlinking(){
        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while (ite.hasNext()){
            Object obj = ite.next();
            cell celltmp = (cell) objs.get(obj);
            if(! celltmp.isBlinking() )
                celltmp.setSelected(false);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void stopBlinking(){
        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while (ite.hasNext()){
            Object obj = ite.next();
            cell celltmp = (cell) objs.get(obj);
            if( celltmp.isBlinking() )
                celltmp.stopBlinking();
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void getNotBlinking(){
        Set keys = objs.keySet();
        Iterator ite = keys.iterator();
        while (ite.hasNext()){
            Object obj = ite.next();
            cell celltmp = (cell) objs.get(obj);
            if( celltmp.isBlinking() )
                celltmp.setSelected(false);
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public java.util.Hashtable getSelectedCells(){
        java.util.Hashtable selcell = new java.util.Hashtable();

        Set keys = objs.keySet();
        Iterator ite = keys.iterator();

        while (ite.hasNext()){
            Object obj3d = ite.next();
            cell node = (cell) objs.get(obj3d);

            if(node.isSelected())
                selcell.put( node.getName(), node.getTreeRef().getColor() );
        }
        return(selcell);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Hierarchical query
    public String select_recursif2(String start) throws SQLException
    {
    	Statement psmt = null;
        ResultSet rs = null;

        psmt=con.createStatement();
    	rs=psmt.executeQuery("SELECT \"DAUGHTER_CELL\",\"MOTHER_CELL\" FROM \"LINEAGE\" where \"DAUGHTER_CELL\" ="+start);

    while (rs.next())
    {
    	recResult+=rs.getString(1)+",";
        select_recursif2(rs.getString(2));
    }
        return recResult;

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
//Hierarchical query
    public String select_recursif3(String start) throws SQLException
    {
    	Statement psmt = null;
        ResultSet rs = null;

        psmt=con.createStatement();
    	rs=psmt.executeQuery("SELECT \"DAUGHTER_CELL\" FROM \"LINEAGE\" where \"MOTHER_CELL\" ="+start);

    while (rs.next())
    {
    	recResult+=rs.getString(1)+",";
        select_recursif3(rs.getString(1));
    }
        return recResult;

    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedCells(Hashtable cell, String olddevstage){
               if(olddevstage.length()<=0)
            return;
        if(cell.size()<=0)
            return;

        try{

            DriverManager.registerDriver(new org.postgresql.Driver());
            String db = VirtualEmbryo.database;
            String userID = VirtualEmbryo.DBlog;
            String pass = VirtualEmbryo.DBpass;

            con = DriverManager.getConnection(db, userID, pass);
            Statement s;
            ResultSet result=null;


            Set keys = cell.keySet();
            Iterator ite = keys.iterator();

            while (ite.hasNext()){
                String cellname = (String) ite.next();
                Color couleur = (Color) cell.get(cellname);


                s=con.createStatement();
                String query=new String();
                query="select \"ANAT_ID\" from \"ANAT_ENTITY\" where \"NAME\"='"+cellname+"' and \"DEV_STAGE_ID\"='"+olddevstage+"'";
                result=s.executeQuery(query);
                String anatid = new String();
                if(result.next()){
                    anatid=result.getString(1);
                }

                //search ancestor cells
                s=con.createStatement();
                query=new String();

                recResult="";
                recResult=select_recursif2(anatid);
                recResult=recResult.substring(0,recResult.length()-1);

                query="SELECT \"NAME\" FROM \"LINEAGE\", \"ANAT_ENTITY\" where (\"DAUGHTER_CELL\"=\"ANAT_ID\") AND (\"DEV_STAGE_ID\"="+VirtualEmbryo.devstage+") AND \"DAUGHTER_CELL\" in ("+recResult+")";

                result=s.executeQuery(query);

                while(result.next()){
                    String name = new String();
                    name=result.getString(1);
                    cell shape=(cell) objs.get(name);
                    shape.setSelected(true, couleur, shape.isSelected());
                }

                //search descendant cells
                s=con.createStatement();
                query=new String();

                recResult="";
                recResult=select_recursif3(anatid);
                recResult=recResult.substring(0,recResult.length()-1);

                query="SELECT \"NAME\" FROM \"LINEAGE\", \"ANAT_ENTITY\" where (\"DAUGHTER_CELL\"=\"ANAT_ID\") AND (\"DEV_STAGE_ID\"="+VirtualEmbryo.devstage+") AND \"DAUGHTER_CELL\" in ("+recResult+")";

                result=s.executeQuery(query);
                while(result.next()){
                    String name = new String();
                    name=result.getString(1);
                    cell shape=(cell) objs.get(name);
                    shape.setSelected(true, couleur, shape.isSelected());
                }
            }

        con.close();
        }catch(Exception e){
            JOptionPane diag2=new JOptionPane();
            diag2.showMessageDialog(new JWindow(),"Error: "+ e.getMessage());
            ;
        }
        finally {
            if( con !=null){
                try {con.close();}
                catch (SQLException e) {
                    JOptionPane diag2=new JOptionPane();
                    diag2.showMessageDialog(new JWindow(),"Error: "+ e.getMessage());
                }
            }
        }


    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void resetView(){
        try{
            ViewingPlatform vp = u.getViewingPlatform();
            vp.setNominalViewingTransform();

        }catch(NullPointerException e){;}
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setZbuffer(boolean bool){
        AppText.setZbuffered(bool);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setSelectedZbuffer(boolean bool){
        AppSelectedText.setZbuffered(bool);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setAntialiased(boolean bool){
        u.getViewer().getView().setSceneAntialiasingEnable(bool);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public void setColorMode(int mode){
        //AppSelected.setColorMode(mode);
        AppDefault.setColorMode(mode);
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
    public Transform3D getViewPlatform(){
        Transform3D trans=new Transform3D();
        u.getViewingPlatform().getViewPlatformTransform().getTransform(trans);
        return trans;
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
   /* public void destroy(){
        try{
            scene=null;
            u.removeAllLocales();
            u=null;
            c=null;
            this.removeAll();

            //memory cleaning
            System.gc();
            //run pending finalizations
            System.runFinalization();

        }catch(Exception e){
            JOptionPane diag2=new JOptionPane();
        }

    }
    */
    public void destroy(){
        try{
        u.getLocale().removeBranchGraph(scene);
        BranchGroup emptyGroup = new BranchGroup();
        emptyGroup.setCapability(BranchGroup.ALLOW_DETACH);
        u.getLocale().addBranchGraph(emptyGroup);
        u.getLocale().removeBranchGraph(emptyGroup);
        emptyGroup = null;


        u.removeAllLocales();
        u.cleanup();
        u=null;

        this.remove(c);
        c=null;


        //memory cleaning
        System.gc();
        //run pending finalizations
        System.runFinalization();
        }catch(Exception e){
        /*JOptionPane diag2=new JOptionPane();
        diag2.showMessageDialog(new JWindow(),"Error: "+ e.getMessage());*/
        }
    }
////////////////////////////////////////////////////////////////////////////////////////////////////
}
